// DITypes.h
//#pragma once	// Does not work in converter
#if !defined(AFX_DIITYPES_H__FACB7364_50C6_454e_AE0C_8B3969C4D4B1__INCLUDED_)
#define AFX_DIITYPES_H__FACB7364_50C6_454e_AE0C_8B3969C4D4B1__INCLUDED_
#include "TDefs.h"

#define RELEASE(I)			\
	{						\
		if(I)				\
			I->Release();	\
		I = NULL;			\
	}	

typedef enum EDIConst {
							eMaxParamName = 30,
							eMaxClassName = 50,
							eMaxPropName = 30,
		} EDIConst;


typedef struct DIVect { 
		double v[3];
		} DIVect;

typedef struct DIPoint { 
		double x[3];
		} DIPoint;

typedef struct RayKC {
	DIPoint origin;
	DIVect  direction;
} RayKC;

typedef struct KC2D { 
		double x[2];
		} KC2D;

typedef struct Color_KC { 
		float red;
		float green;
		float blue;
		} Color_KC;

typedef struct KCRange { 
							double min;
							double max;
		} KCRange;

typedef struct KCBox { 
							KCRange range[3];
		} KCBox;

typedef struct KCN3 { 
							int n[3];
		} KCN3;

typedef struct PairInt { 
							int x;
							int y;
		} PairInt;

// Frame (3D system of coordinates) 
typedef struct Frame_KC_ {
	DIPoint origin;
	DIVect axes[2];		//Normalised vectors of X and Y axes . Z is defined as perpendicular
} Frame_KC;

// Note: enumerations below may be expanded (without changing existing members) 
// in future releases 

typedef enum EDIMove {
						eDIMovePan = 1,
						eDIMoveZoom = 2,
						eDIMoveRotate = 4
		} EDIMove;


typedef enum EViewMode {
						eViewModeView = 1,
						eViewModeModify = 2,
		} EViewMode;


typedef enum EHighLight {
							eHighLightPoint = 128,
							eHighLightLine = 256,
							eHighLightSurface = 512,
		} EHighLight;


typedef enum EEnableBit {
							eEnablePan = 1,
							eEnableZoom = 2,
							eEnableRotate = 4,
							eEnableHighLightPoint = 128,
							eEnableHighLightLine = 256,
							eEnableHighLightSurface = 512,
							eEnableTransparency = 1024,
							eEnablePerspectiveProjection = 2048,
							eEnableNormals = 4096,
		} EEnableBit;

typedef enum EViewType {
							eViewType2D = 2,
							eViewType3D = 3,
		} EViewType;

typedef enum E3DViewProjectionType {
							e3DViewProjectionTypeOrthographic,
							e3DViewProjectionTypePerspective
		} E3DViewProjectionType;

typedef enum EGeometryType {
							eGeometryTypeUnknown,
							eGeometryTypeWireFrame,
							eGeometryTypeSurface,
							eGeometryTypeSolid,
		} EGeometryType;

typedef enum ESegmentType {
							eSegmTypeLine = 1,
							eSegmTypeArc = 2,
		} ESegmentType;


typedef enum EPatchType {
							ePatchTypeCurvature = 1,
							ePatchTypeRadius = 2,
		} EPatchType;


typedef enum ECoordinatesType {
								eCoordTypeCartesian = 1,
								eCoordTypePolar = 2,
		} ECoordinatesType;

typedef enum EBooleanOperation {
						eBoolOpUnknown = 0,
						eBoolOpSubtract = 1,
						eBoolOpUnion = 2,
						eBoolOpInters = 3,
						eBoolOpClip = 4,
		} EBooleanOperation;

typedef struct EBoolOpContext {
						EBooleanOperation operation;
						VARIANT_BOOL execute;
						VARIANT_BOOL intersectionLine;
						VARIANT_BOOL needEdges;
						IUnknown* edges;
						VARIANT_BOOL separateComponents;
		} EBoolOpContext;

typedef struct DISectInfo
{
	VARIANT_BOOL closed;
	int segments;
	double radius;
	ESegmentType segmentType;
	VARIANT_BOOL regularJoints;
} DISectInfo;

typedef struct DI3DSectInfo
{
	DISectInfo sectInfo;
	int knots;
	ESegmentType		axialSegmType;
	ECoordinatesType	edgeCoordType;
	EPatchType patchType;
} DI3DSectInfo;

// Additional parameters for IMetrics.Dist method
typedef struct MetrDistContext
{
	VARIANT_BOOL includeChildren;		// Include children of the objects in search for nearest points.
	VARIANT_BOOL needAll;				// Include points at distances bettween min and min+tolerance into the nearest set. Significantly affects performance
	double tolerance;					// Tolerance for the nearest set. Ignored if needAllInTolerRange is false
	double precision;					// Currently unused. Set equal to 1e-10 for forward compatibility
} MetrDistContext;

// For IKCPathCollisionDetector
typedef struct PathDetectorContext
{
	VARIANT_BOOL decreasingStart;		// It is known that on start of the movement minimal distance beween object decreases
	double minDistToler;				// objects are considered collided if minimal distance is less than minDist. Lower than 1e-6 is not recommended. Clumped to (1e-10, 0.1) range
	double precision;					// Precision of calculated position along movement(s) path. Lower than 1e-7 is not recommended. Clumped to (1e-10, 0.1) range

} PathDetectorContext;

// Additional parameters for IMetrics.IsCloserThan method
typedef struct MetrIsCloserThanContext
{
	VARIANT_BOOL includeChildren;		// Include children of both objects in search for nearest points.
	VARIANT_BOOL further;				// If true returns true if the objects are further (there is at least one pair of further points), not closer than the specified distance
	VARIANT_BOOL quickCheck;			// For increased performance check vertexes only. 

} MetrIsCloserThanContext;

typedef struct AssociationPair
{
	POSNT posn0;		// Positions in the lists which keep the associated items. e.g. pairs or nearest points in calculation of distance of two objects
	POSNT posn1;
	double data;	// Some data relevant to the pair. e.g. distance between two nearest point. May not be used.

} AssociationPair;

// Additional parameters for IGraphicItem.DrawEx() method
typedef struct RenderContext
{
	VARIANT_BOOL surface;		// If false wire frame will be rendered. Default: true
	VARIANT_BOOL normals;		// Draw normals? Default: false
	double		maxSampler;		// Default: -1.0. Max length of a segment for approximation of curves with sequences of segments or curved surfaces with triangles. 
} RenderContext;

typedef enum KC3State
{
	kcUnknown = -1,
	kcFalse = 0,
	kcTrue = 1
} KC3State;

typedef struct KCSceneItemInfo {
	KC3State hasChildren;
	KC3State hasParent;
	KC3State isEmpty;		// No geometry. The object has no surface or other geometric elements
	KC3State hasLocalFrame;	// section or scene item?
	__int32  hashItemStartAfter;	// Hash of the object to start after. Use IObject_KC.GetHash() to obtain
	__int32  _reserved;
	BSTR     name;
} KCSceneItemInfo;

typedef enum EObjectType {
								eObjTypeNULL,
								eObjTypeLine,
								eObjTypeMeshSection,
								eObjType3DSGenerator,
								eObjTypeSORGenerator,
								eObjTypeModelGenerator,
								eObjTypeFrame,
								eObjType3DPoint,
								eObjTypePointSet,
								eObjTypeLineStrip,
								eObjTypePlane,
								eObjTypeBox,
								eObjTypeArc,
								eObjTypeFreeFormCurve,
								eObjTypeArcSplineCurve,
								eObjTypePipeSection,
								eObjTypeNumericArray,
								eObjTypeCircle,
								eObjTypeBRepSection,
								eObjTypePathCollisionDetector,
								eObjTypeMove,
								eObjType3DS,
								eObjTypeSOR,
								eObjTypeGraphicItem,
								eObjTypeCutEffect,
								eObjTypeMeasurement,
								eObjTypeLineSection,
								eObjTypeEllipse,
								eObjTypeRay,
								eObjTypeArray,
								eObjTypeSectionOCC,
								eObjTypeESPAlgorithm,
								eObjTypeLabel3D,					// The basic facing text
								eObjTypeViewPoint,
								eObjTypeMeasurementGeometry,
								eObjTypeSceneItemAngleAnnotation,
								eObjTypeOverlay,
								eObjTypeListUnkn,
								eObjTypeStickyLabelEntity,			// Stickable text
								eObjTypeBRepTextSection,			// Used in converter only
								eObjTypeBRepCharSection,			// Used in converter only
								eObjTypeSmartLabel,
								eObjTypeMesh,
								eObjTypeSphere,
								eObjTypePrizmInfinite,
								eObjTypeArcLineStrip,
								eObjType3DSSection,
								eObjTypeSORSection,															
								eObjTypeImageOrientedSection,
								eObjTypeTorus,
								eObjTypeSurfacePointArray
		} EObjectType;


typedef enum EDrawPrimitive {
								ePoints,
								eLines,
								eLineLoop,
								eLineStrip,
								eTriangles,
								eTriangleStrip,
								eTriangleFan,
								eQuads,       
								eQuadStrip,  
								ePolygon,
								eDrawPrimitiveUnknown
		} EDrawPrimitive;


typedef enum EDataType {
								eDataTypeNULL, 
								eDataTypeDouble, 
								eDataTypeSingle, 
								eDataTypeLong, 
								eDataTypeShort, 
								eDataTypeString
		} EDataType;

typedef enum EKCType {
								eKCTypeNULL, 
								eKCTypeDouble, 
								eKCTypeSingle, 
								eKCTypeLong, 
								eKCTypeShort, 
								eKCTypeString,
								eKCTypeBool,
								eKCTypeIUnknown,
								eKCTypeColor,
		} EKCType;

typedef enum EDictionaryType_KC {
								eKDUnknown, 
								eKDInt, 
								eKDDouble, 
								eKDBool,
								eKD3State,
								eKDString, 
								eKDVariant,
								eKDInterface,
								eKDPointer,
								eKDUInt64,
		} EDictionaryType_KC;


typedef enum ESymmType {
								eSymmTypeNULL,
								eSymmTypeAxial, 
								eSymmTypeMirror, 
								eSymmTypeTranslation, 
								eSymmTypeGeneral,
		} ESymmType;


typedef enum EDIEvent {
								eEventMouseHover,
								eEventClientDraw,
								eEventCollision,
								eEventUICommand,
								eEventSelection,
								eEventExplorerSelection,	// Selection changed in Model Explorer. Has to be enbled using IKCContext.SetBoolParam(e3DBoolParamExplorerSelectionNotify, true);
								eEvent2DEditor,
								eEventMouseSimple,		//For RequestEvent. All button down/up etc apart from intesive mouse move
								eEventMouseMove,
								eEventMouseLButtonDown,
								eEventMouseRButtonDown,
								eEventModelStructureChanged,	//3.10.14 Object hierarchy has changed
								eEventMouseRButtonMove,
								eEventMouseRButtonUp,
								eEventKernelCAD,
								eEventDgkMisc,
								eEventCount		// This must be last. Add new members above
		} EDIEvent;

typedef enum EEditorEvent_KC {
								eEditEventUnknown,
								eEditEventActivated,
								eEditEventModelStructureChanged,
								eEditEventItemStructureChanged,
								eEditEventClosing,
		} EEditorEvent_KC;

typedef enum EElemTypeKC {
								eElTypeVertex,
								eElTypeEdge,
								eElTypeFace,
								eElTypeEntity,
								eElTypeUnknown,
		} EElemTypeKC;


typedef enum EItemType {
								eItemTypeSection,
								eItemTypeLabel, 
								eItemTypeViewPoint,
		} EItemType;

typedef enum EModelViewFrame {
								eModelViewFrameGlobal,
								eModelViewFrameEye
		} EModelViewFrame;

typedef enum EModelEntity {
								eModelEntityUnknown,
								eModelEntityObject,
								eModelEntityModel,
		} EModelEntity;

typedef enum ESTLAnalysis {
								eStlAnalysAuto,
								eStlAnalysPerform,
								eStlAnalysSkip,
		} ESTLAnalysis;

typedef enum EViewReset {
								eViewResetAll,
								eViewResetVolume,
		} EViewReset;

typedef enum ECADFormat {
								eCADFormatGLM,
								eCADFormatVRML,
								eCADFormatSTL,
								eCADFormatAutoCADDXF,
								eCADFormatAutoCADDWG,
								eCADFormatSAT,
								eCADFormatCSV,
								eCADFormatXYZ,
								eCADFormatPLY,
								eCADFormatSTEP,
								eCADFormatIGES,
								eCADFormatBREP,
								eCADFormatCSFDB,
								eCADFormatDat,
								eCADFormatMDG,
								eCADFormatOBJ,

								eCADFormatUnknown,
		} ECADFormat;

typedef enum EModifResult {
								eModifResInvalid = -1,
								eModifResNoChange = 0,
								eModifResModified = 1
				} EModifResult;

typedef enum E2DViewGeometryType {
									e2DViewGeometryTypeProjection,
									e2DViewGeometryTypeIntersection,
		} E2DViewGeometryType;

typedef enum EParametrisationType {
									eParametrisationTypePerStep,
									eParametrisationTypeNormalised,
		} EParametrisationType;

typedef enum EPointLocation {
									ePtLocnUnknown,
									ePtLocnInside,
									ePtLocnSurface,
									ePtLocnOutside
		} EPointLocation;

typedef enum EPointLocation2D {
									ePointLocation2DUnknown,
									ePointLocation2DInterval,	// On a segment in open interval
									ePointLocation2DPoint,		// At a point
									ePointLocation2DInside,		// Inside of a closed strip or on the left of an infinite long strip obtained by extending end lines as rays
									ePointLocation2DOutsnside,	// Outside of a closed strip or on the right of an infinite long strip obtained by extending end lines as rays
		} EPointLocation2D;

typedef enum EPageOrientation {
									eOrientAuto,
									eOrientPortrait,
									eOrientLandscape,
		} EPageOrientation;

typedef struct KCBitmap {
						   int type;
						   int width;
						   int height;
						   int widthBytes;
						   short planes;
						   short bitsPixel;
		} KCBitmap;

typedef enum EPaperSize {
									ePaperSizeUnknown,
									ePaperSizeA4,
									ePaperSizeA3,
		} EPaperSize;

typedef struct PrintContext_KC {
									VARIANT_BOOL validOrientation;
									EPageOrientation orientation;
									VARIANT_BOOL validPaperSize;
									EPaperSize paperSize;
									VARIANT_BOOL validMargin;
									float marginHorizontal;
									float marginVertical;
									VARIANT_BOOL validScale;
									float scale;
						   
		} PrintContext_KC;

typedef enum EMenuCommand_KC {
								eMenuCommandSaveAs,
								eMenuCommandSeparator1,			//Not used. To replicate the exact menu structure
								eMenuCommandFullScreen,
								eMenuCommandSeparator3,
								eMenuCommandSurface,
								eMenuCommandWireFrame,
								eMenuCommandSeparator6,
								eMenuCommandGlobalFrame,
								eMenuCommandSeparator8,
								eMenuCommandHelp,
								eMenuCommandAbout,
								eMenuCommandSeparator9,
								eMenuCommandCustomItem0,
								eMenuCommandCustomItem1,
								eMenuCommandCustomItem2,
								eMenuCommandCustomItem3,
								eMenuCommandCustomItem4,
		} EMenuCommand_KC;

typedef enum EMenuCmdLevel1_KC {
								eMenuCmdLevel1Normals = 100,
								eMenuCmdLevel1SelectionZoom = 101,
								eMenuCmdLevel1Explorer =  102,
		} EMenuCmdLevel1_KC;

typedef enum EMenuCmdLevel2_KC {
								eMenuCmdLevel2EditLine = 200,
								eMenuCmdLevel2EditCut = 201,
								eMenuCmdLevel2EditModify = 202,
								eMenuCmdLevel2MeasurementsModify = 203,
								eMenuCmdLevel2MeasurementsDelete = 204,
								eMenuCmdLevel2MeasurementsDeleteAll = 205,
								eMenuCmdLevel2ViewGrid = 206,
								eMenuCmdLevel2ViewReset = 207,
								eMenuCmdLevel2ViewFit = 208,
								eMenuCmdLevel2EditOverlay = 209,
								eMenuCmdLevel2EditClip = 210,
								eMenuCmdLevel2ViewBirdsEye = 211,
								eMenuCmdLevel2ViewPerspective = 212,
		} EMenuCmdLevel2_KC;

typedef enum EMenuCmdLevel3_KC {
								eMenuCmdLevel1EditSelectVertices = 300,
								eMenuCmdLevel1EditSelectEdges = 301,
								eMenuCmdLevel1EditSelectSimplexes = 302,
								eMenuCmdLevel1MeasurementsAddDistance = 303,
								eMenuCmdLevel1MeasurementsAddPoint = 304,
								eMenuCmdLevel1MeasurementsAddAngle = 305,
								eMenuCmdLevel1MeasurementsStyleTransient = 306,
								eMenuCmdLevel1MeasurementsStylePersistent = 307,
								eMenuCmdLevel1EditSelectSections = 308,
		} EMenuCmdLevel3_KC;


typedef enum E2DBoolParams { 
						e2DBoolParamShowAngles, 
						e2DBoolParamShowRulersOrGrid,	//1
						e2DBoolParamShowGrid,			//2
						e2DBoolParamShowSideAnnot,		//3
						e2DBoolParamShowAxesAnnot,		//4
						e2DBoolParamBreakLongDimension,	//5
						e2DBoolParamEnableHorPan,		//6
						e2DBoolParamEnableVertPan,		//7
						e2DBoolParamEnableZoom,			//8
						e2DBoolParamInterpolation,		//9
						e2DBoolParamRemoveTesselation,	//10
						e2DBoolParamDetectCurves,		//11
						e2DBoolParamMarginsWRTGeometry,	//12
						e2DBoolParamSetupHorAlignment,	//13
						e2DBoolParamSetupVertAlignment,	//14
						e2DBoolParamRulersAllSides,		//15
						e2DBoolParamApplyToAll,			//16
						e2DBoolParamShowAnnotationIsolatedItems, //17
						e2DBoolParamDetectEdgeCurves,			 //18
						e2DBoolParamCount 
		} E2DBoolParams;

typedef enum E2DIntParams { 
						e2DIntParamGeomType,					//0
						e2DIntParamLineWidth,					//1
						e2DIntParamDimentionLineWidth,			//2
						e2DIntParameIntParamTickLineWidth,		//3
						e2DIntParamLineWidthAll,				//4
						e2DIntParamDimensionTextToLinePixelsHor,//5
						e2DIntParamDimensionTextToLinePixelsVert,//6
						e2DIntParamBreakLineWidth,				//7
						e2DIntParamBreakLineStyle,				//8
						e2DIntParamNewItemLineStyle,			//9
						e2DIntParamDimensionLineStyle,			//10
						e2DIntParamUserData,					//11
						e2DIntParamCount 
		} E2DIntParams;						

typedef enum E2DDoubleParams { 
							e2DDoubleParamMinTickDistHor,		//0
							e2DDoubleParamMinTickDistVert,		//1
							e2DDoubleParamScale,				//2
							e2DDoubleParamBreak,				//3
							e2DDoubleLineWidenFactor,			//4
							e2DDoubleTickSizeFactor,			//5
							e2DDoubleRulersDistFactor,			//6
							e2DDoubleBreakRatio,				//7
							e2DDoubleMinAngleEdgeCurve,			//8
							e2DDoubleMaxAngleEdgeCurve,			//9
							e2DDoubleParamCount 
			} E2DDoubleParams;			

typedef enum E2DColorParams { 
							e2DColorParamDefaultItems,		//0
							e2DColorParamDefaultChildren,	//1
							e2DColorParamRulerLines,		//2
							e2DColorParamRulerText,			//3
							e2DColorParamBreakLine,			//4
							e2DColorOrientationText,		//5		
							e2DColorParamCount 
			} E2DColorParams;	

typedef enum E2DIUnknownParams { 
							e2DIUnknownParamChildrenFont,		//0
							e2DIUnknownParamDimensionsFont,		//1
							e2DIUnknownParamSideAnnotationFont,	//2
							e2DIUnknownParamHorVisibleRange,	//3
							e2DIUnknownParamVertVisibleRange,	//4
							e2DIUnknownParamDrawingBounds,		//5
							e2DIUnknownParamBreakRange,			//6
							e2DIUnknownParamBreakGap,			//7
							e2DIUnknownParamCount 
			} E2DIUnknownParams;

typedef enum E3DBoolParams { 
						e3DBoolParamContextMenu,					//0
						e3DBoolParamUseClipboard,					//1
						e3DBoolParamClosedSurfaceHint,				//2
						e3DBoolParamDump,							//3
						e3DBoolParamMeasureShowInterm,				//4
						e3DBoolParamWantSelectEvent,				//5
						e3DBoolParam3DGrid,							//6
						e3DBoolParamGridInteractiveDefault,			//7
						e3DBoolParamGridUseAngleMeasurementDefault,	//8
						e3DBoolParamPrecisePointPicking,			//9
						e3DBoolParamExplorerSelectionNotify,		//10
						e3DBoolParamUpdateDualView,					//11
						e3DBoolParamDualMode,						//12
						e3DBoolParamModelStaticOnResize,			//13
						e3DBoolParamSelectionGeometricOnly,			//14
						e3DBoolParamSelectionFastApproximation,		//15
						e3DBoolParamSelectionGeometric,				//16
						e3DBoolParamBoundingBoxVisibleObjOnly,		//17
						e3DBoolParamEnableHiddenLabelRemoval,		//18
						e3DBoolParamShowAxesIcon,					//19
						e3DBoolParamLeftHandCoordinateSystem,		//20
						e3DBoolParamCount
		} E3DBoolParams;

typedef enum E3DIntParams { 
						e3DIntParamBackgroundType,					//0
						e3DIntParamMeasurementDigits,				//1
						e3DIntParamSnapToPointDistance,				//2
						e3DIntParamSnapToLineDistance,				//3
						e3DIntParamMeasurementStyle,				//4
						e3DIntParamMeshAutoUpdateFull,				//5
						e3DIntParamMeshAutoUpdateMedium,			//6
						e3DIntParamCount 
		} E3DIntParams;

typedef enum E3DDoubleParams {
						e3DDoubleParamDeviationFactor,					//0
						e3DDoubleParamCount
		} E3DDoubleParams;

typedef enum EMeshModsAction { 
						eMeshActionNone = 0,
						eMeshActionNormalsFastApprox = 1,
						eMeshActionNormalsMedium = 2,
						eMeshActionNormalsFull = 4,
						eMeshActionNormalsAuto = 8,
		} EMeshModsAction;

typedef enum EStringSource {
									eStringSourceUnknown,
									eStringSourceObjectName,
									eStringSourceLayerName,
									eStringSourceTemplate,
		} EStringSource;

typedef enum EDwgVersion  {
		kc_vAC14 = 21,      // R14 release
		kc_vAC15 = 23,      // R15 (2000) release
		kc_vAC18 = 25,      // R18 (2004) release
		kc_vAC21 = 27,		// R21 (2007) release
		kc_vAC24 = 29,		// R24 (2010) release
		kc_vAC27 = 31,		// R27 (2013) release
  } EDwgVersion;

typedef enum EDXFVersion  {
		kc_vACdxf12 = 16,      // R11 and R12
		kc_vACdxf15 = 23,      // R15 (2000) release
		kc_vACdxf18 = 25,      // R18 (2004) release
		kc_vACdxf21 = 27,      // R21 (2007) release
		kc_vACdxf24 = 29,      // R24 (2010) release
		kc_vACdxf27 = 31,      // R27 (2013) release
  } EDXFVersion;


typedef enum ESatVersion  {
  kc_ASCII_106        = 0x01000000|106,
  kc_ASCII_400        = 0x01000000|400,
  kc_ASCII_500        = 0x01000000|500,
  kc_ASCII_600        = 0x01000000|600,
  kc_ASCII_700        = 0x01000000|700,
  kc_ASCII_20800      = 0x01000000|20800,
  kc_ASCII_21200      = 0x01000000|21200,
  kc_ASCII_21500      = 0x01000000|21500,  
} ESatVersion;

typedef enum EPointInSimplexLocation {
										eSimplexPointLocationUnknown,
										eSimplexPointLocationInside, 
										eSimplexPointLocationEdge,
										eSimplexPointLocationVertex, 
										eSimplexPointLocationOutside, 
										eSimplexPointLocationNotInPlane,
		} EPointInSimplexLocation;

typedef enum EMeshRefineType {
									eMeshRefineTypeFlat,
									eMeshRefineTypeButterfly,
									eMeshRefineTypeLoop,
									eMeshRefineTypeCatmull,
									eMeshRefineTypeONE_QUAD_X_EDGE
} EMeshRefineType;

typedef enum EMeshSmoothType {
	eMeshSmoothTypeLaplacian
} EMeshSmoothType;

#endif // !defined(AFX_DIITYPES_H__FACB7364_50C6_454e_AE0C_8B3969C4D4B1__INCLUDED_)