// DgInterface.h DG interface introduced in v6
#pragma once
#pragma warning( disable: 4467 ) //DgInterface.h(12,6): warning C4467: usage of ATL attributes is deprecated

#include <olectl.h>
#include <idispids.h>
#include "TypesDG.h"

class IEntity_DG;
class IBRepShape_DG;
class IBRepGeometry_DG;
class ISimplex_DG;
class IVertexSegment_DG;
class ILineStyle_DG;
class IView_DG;

#define _retval_
#define _inout_
#define _out_
#define _get_
#define _set_
#define _nullable_

[uuid("{465792D6-D9B7-4437-8EB4-035ABE0FC9CD}")]
class IArray_DG : public IUnknown
{
public:
	ICALLTYPE GetCount(_retval_ int* count) = 0;
	ICALLTYPE IsEmpty(_retval_ VARIANT_BOOL* result) = 0;
	ICALLTYPE GetAt(int index, _retval_ IUnknown** val) = 0;
	ICALLTYPE SetAt(int index, IUnknown* val) = 0;
	ICALLTYPE InsertAt(int indexAt, IUnknown* val) = 0;
	ICALLTYPE Add(IUnknown* val) = 0;
	ICALLTYPE RemoveAt(int index) = 0;
	ICALLTYPE RemoveAll() = 0;
	ICALLTYPE Find(IUnknown* val, _retval_ int* index) = 0;
	ICALLTYPE Copy(IArray_DG* iArray) = 0;
	ICALLTYPE Append(IArray_DG* iArray) = 0;
	IUNKNOWN_
};

[uuid("{E5956E91-189F-4554-9CDC-AF2DEB9F4741}")]
class IArrayDouble_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetCount(_retval_ int* count) = 0;
	ICALLTYPE _set_ SetCount(int count) = 0;
	ICALLTYPE IsEmpty(_retval_ VARIANT_BOOL* result) = 0;
	ICALLTYPE GetAt(int index, _retval_ double* val) = 0;
	ICALLTYPE SetAt(int index, double val) = 0;
	ICALLTYPE InsertAt(int indexAt, double val) = 0;
	ICALLTYPE Add(double val) = 0;
	ICALLTYPE RemoveAt(int index) = 0;
	ICALLTYPE RemoveAll() = 0;
	ICALLTYPE Find(double val, double tolerance, _retval_ int* index) = 0;
	ICALLTYPE Copy(IArrayDouble_DG* iArray) = 0;
	ICALLTYPE Append(IArrayDouble_DG* iArray) = 0;
	IUNKNOWN_
};

[uuid("{B50DB48D-31C4-4611-A729-B577638C3C48}")]
class IBlob_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetSize(int* bytes) = 0;
	ICALLTYPE _set_ SetSize(int bytes) = 0;
	ICALLTYPE Load(char* filePath, _retval_ VARIANT_BOOL* success) = 0;
	ICALLTYPE Save(char* filePath, _retval_ VARIANT_BOOL* success) = 0;
	ICALLTYPE Copy(SAFEARRAY* data) = 0;
	ICALLTYPE GetData(_retval_ SAFEARRAY** data) = 0;
	ICALLTYPE CopyBlob(IBlob_DG* blob) = 0;
	ICALLTYPE Clone(_retval_ IBlob_DG** blob) = 0;
	ICALLTYPE IsSame(IBlob_DG* blob, _retval_ VARIANT_BOOL* same) = 0;
	ICALLTYPE Get(int indexByte, _retval_ byte* val) = 0;
	ICALLTYPE Set(int indexByte, byte val) = 0;
	IUNKNOWN_
};

[uuid("{7C96CD23-D282-4DAD-9BB3-047DA26C5C2E}")]
class IMatrix_DG : public IUnknown
{
public:
	ICALLTYPE GetSize(_out_ int* rows, _out_ int* columns) = 0;
	ICALLTYPE SetSize(int rows, int columns) = 0;
	ICALLTYPE Get(int row, int column, _retval_ double* value) = 0;
	ICALLTYPE Set(int row, int column, double value) = 0;
	ICALLTYPE Copy(IMatrix_DG* matrix) = 0;
	ICALLTYPE GetRows(_retval_ int* rows) = 0;
	ICALLTYPE GetColumns(_retval_ int* columns) = 0;
	IUNKNOWN_
};

[uuid("{9CC4828A-4166-4403-81E6-E661EA38BED0}")]
class IArrayInt_DG : public IUnknown
{
public:
	ICALLTYPE GetCount(_retval_ int* count) = 0;
	ICALLTYPE IsEmpty(_retval_ VARIANT_BOOL* result) = 0;
	ICALLTYPE GetAt(int index, _retval_ int* val) = 0;
	ICALLTYPE SetAt(int index, int val) = 0;
	ICALLTYPE InsertAt(int indexAt, int val) = 0;
	ICALLTYPE Add(int val) = 0;
	ICALLTYPE RemoveAt(int index) = 0;
	ICALLTYPE RemoveAll() = 0;
	ICALLTYPE Find(int val, _retval_ int* index) = 0;
	ICALLTYPE Copy(IArrayInt_DG* iArray) = 0;
	ICALLTYPE Append(IArrayInt_DG* iArray) = 0;
	ICALLTYPE SetCount(int count) = 0;
	IUNKNOWN_
};

[uuid("{14A3C904-6286-4CE1-A9A8-829E8AB3D481}")]
class IArrayBool_DG : public IUnknown
{
public:
	ICALLTYPE GetCount(_retval_ int* count) = 0;
	ICALLTYPE IsEmpty(_retval_ VARIANT_BOOL* result) = 0;
	ICALLTYPE GetAt(int index, _retval_ VARIANT_BOOL* val) = 0;
	ICALLTYPE SetAt(int index, VARIANT_BOOL val) = 0;
	ICALLTYPE InsertAt(int indexAt, VARIANT_BOOL val) = 0;
	ICALLTYPE Add(VARIANT_BOOL val) = 0;
	ICALLTYPE RemoveAt(int index) = 0;
	ICALLTYPE RemoveAll() = 0;
	ICALLTYPE Find(VARIANT_BOOL val, _retval_ int* index) = 0;
	ICALLTYPE Copy(IArrayBool_DG* iArray) = 0;
	ICALLTYPE Append(IArrayBool_DG* iArray) = 0;
	IUNKNOWN_
};

[uuid("{176B3C56-52AD-46E8-A6D4-61848016873A}")]
class I3DBugger_DG : public IUnknown
{
public:
	ICALLTYPE DumpObject(IUnknown* representation, POSN objectHash, VARIANT_BOOL writeThrough, VARIANT_BOOL transient) = 0;
	ICALLTYPE Dump() = 0;
	ICALLTYPE BeginSession() = 0;
	ICALLTYPE BeginDump() = 0;
	IUNKNOWN_
};

[uuid("{05BA8D60-DA8E-4275-8AF8-09AC7CA329CD}")]
class ISetR1_DG : public IUnknown
{
public:
	ICALLTYPE IsEmpty(_retval_ VARIANT_BOOL* result) = 0;
	ICALLTYPE GetRangeCount(_retval_ int* count) = 0;
	ICALLTYPE GetRange(int index, _retval_ Range_DG* range) = 0;
	IUNKNOWN_
};

[uuid("{5530AAF7-1EB7-4CFC-959B-B24F6A4CF96C}")]
class IList_DG : public IUnknown
{
public:
	ICALLTYPE GetCount(_retval_ POSN* count) = 0;
	ICALLTYPE IsEmpty(_retval_ VARIANT_BOOL* result) = 0;
	ICALLTYPE GetAt(POSN position, _retval_ IUnknown** item) = 0;
	ICALLTYPE SetAt(POSN position, IUnknown* item) = 0;
	ICALLTYPE GetHeadPosition(_retval_ POSN* head) = 0;
	ICALLTYPE GetTailPosition(_retval_ POSN* tail) = 0;
	ICALLTYPE GetNext(_inout_ POSN* position, _retval_ IUnknown** item) = 0;
	ICALLTYPE GetPrev(_inout_ POSN* position, _retval_ IUnknown** item) = 0;
	ICALLTYPE AddHead(IUnknown* item, _retval_ POSN* positionItem) = 0;
	ICALLTYPE AddTail(IUnknown* item, _retval_ POSN* positionItem) = 0;
	ICALLTYPE GetHead(_retval_ IUnknown** item) = 0;
	ICALLTYPE GetTail(_retval_ IUnknown** item) = 0;
	ICALLTYPE RemoveAt(POSN position) = 0;
	ICALLTYPE Clear() = 0;
	ICALLTYPE InsertBefore(POSN position, IUnknown* item, _retval_ POSN* positionItem) = 0;
	ICALLTYPE InsertAfter(POSN position, IUnknown* item, _retval_ POSN* positionItem) = 0;
	IUNKNOWN_
};

[uuid("{79B549FF-EEB0-4AFD-A84F-1CB4180189FE}")]
class IDictionary_DG : public IUnknown
{
public:
	ICALLTYPE GetItemCount(EDictionaryType_DG type, _retval_ int* count) = 0;
	ICALLTYPE GetItemName(int id, _retval_ BSTR* name) = 0;
	ICALLTYPE GetItemDescription(char* name, _retval_ BSTR* description) = 0;
	ICALLTYPE GetItemType(char* name, _retval_ EDictionaryType_DG* type) = 0;
	ICALLTYPE GetInt(char* name, _retval_ int* val) = 0;
	ICALLTYPE SetInt(char* name, int val) = 0;
	ICALLTYPE GetUint64(char* name, _retval_ unsigned __int64* val) = 0;
	ICALLTYPE SetUint64(char* name, unsigned __int64 val) = 0;
	ICALLTYPE GetDouble(char* name, _retval_ double* val) = 0;
	ICALLTYPE SetDouble(char* name, double val) = 0;
	ICALLTYPE GetBool(char* name, _retval_ VARIANT_BOOL* val) = 0;
	ICALLTYPE SetBool(char* name, VARIANT_BOOL val, _retval_ ThreeState_DG* modified) = 0;
	ICALLTYPE Get3State(char* name, _retval_ ThreeState_DG* val) = 0;
	ICALLTYPE Set3State(char* name, ThreeState_DG val) = 0;
	ICALLTYPE GetString(char* name, _retval_ BSTR* val) = 0;
	ICALLTYPE SetString(char* name, char* val) = 0;
	ICALLTYPE Get(char* name, _retval_ VARIANT* param) = 0;
	ICALLTYPE Set(char* name, VARIANT* param) = 0;
	ICALLTYPE GetInterface(char* name, _retval_ IUnknown** interf) = 0;
	ICALLTYPE SetInterface(char* name, IUnknown* interf) = 0;
	ICALLTYPE HasItem(char* name, _retval_ VARIANT_BOOL* result) = 0;
	ICALLTYPE RemoveItem(char* name) = 0;
	IUNKNOWN_
};

[uuid("{44EDBF3B-CDA1-4B84-AB11-96E6096300BB}")]
class IMapUnkn_DG : public IUnknown
{
public:
	ICALLTYPE GetCount(_retval_ int* count) = 0;
	ICALLTYPE IsEmpty(_retval_ VARIANT_BOOL* empty) = 0;
	ICALLTYPE IsIn(IUnknown* key, _retval_ VARIANT_BOOL* in) = 0;
	ICALLTYPE GetAt(IUnknown* key, _retval_ IUnknown** value) = 0;
	ICALLTYPE SetAt(IUnknown* key, IUnknown* value) = 0;
	ICALLTYPE RemoveAt(IUnknown* key) = 0;
	ICALLTYPE Clear() = 0;
	ICALLTYPE CurrentKey(_retval_ IUnknown** key) = 0;
	ICALLTYPE CurrentValue(_retval_ IUnknown** value) = 0;
	ICALLTYPE MoveNext(_retval_ VARIANT_BOOL* success) = 0;
	ICALLTYPE ResetCurrentPosition() = 0;
	ICALLTYPE CloneRef(_retval_ IMapUnkn_DG** shallowCopy) = 0;
	IUNKNOWN_
};

[uuid("{702CC1F6-D30E-4130-BAAB-C50FCB292314}")]
class IMapUint64_DG : public IUnknown
{
public:
	ICALLTYPE GetCount(_retval_ int* count) = 0;
	ICALLTYPE IsEmpty(_retval_ VARIANT_BOOL* empty) = 0;
	ICALLTYPE SetAt(POSN key, POSN value) = 0;
	ICALLTYPE Lookup(POSN key, _out_ POSN* value, _retval_ VARIANT_BOOL* found) = 0;
	ICALLTYPE RemoveKey(POSN key, _retval_ VARIANT_BOOL* found) = 0;
	ICALLTYPE Clear() = 0;
	ICALLTYPE CurrentKey(_retval_ POSN* key) = 0;
	ICALLTYPE CurrentValue(_retval_ POSN* value) = 0;
	ICALLTYPE MoveNext(_retval_ VARIANT_BOOL* success) = 0;
	ICALLTYPE ResetCurrentPosition() = 0;
	ICALLTYPE CloneRef(_retval_ IMapUint64_DG** shallowCopy) = 0;
	IUNKNOWN_
};

[uuid("{39189F25-F9FB-4556-85D3-C221D44129A4}")]
class IContext_DG : public IUnknown
{
public:
	ICALLTYPE GetParamCount(ContextParamType_DG type, _retval_ int* count) = 0;
	ICALLTYPE GetInt(int id, _retval_ int* val) = 0;
	ICALLTYPE SetInt(int id, int val) = 0;
	ICALLTYPE GetDouble(int id, _retval_ double* val) = 0;
	ICALLTYPE SetDouble(int id, double val) = 0;
	ICALLTYPE GetBool(int id, _retval_ VARIANT_BOOL* val) = 0;
	ICALLTYPE SetBool(int id, VARIANT_BOOL val) = 0;
	ICALLTYPE GetString(int id, _retval_ BSTR* val) = 0;
	ICALLTYPE SetString(int id, char* val) = 0;
	ICALLTYPE Get(int id, _retval_ VARIANT* param) = 0;
	ICALLTYPE Set(int id, VARIANT* param) = 0;
	ICALLTYPE GetColor(int id, _retval_ Color_DG* color) = 0;
	ICALLTYPE SetColor(int id, Color_DG* color) = 0;
	ICALLTYPE Reset() = 0;
	IUNKNOWN_
};

[uuid("{F4A8BDB9-1BB7-4F9D-8E6F-966D7DE9FB40}")]
class IFont_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetSize(_retval_ int* size) = 0;
	ICALLTYPE _set_ SetSize(int size) = 0;
	ICALLTYPE _get_ GetFaceName(_retval_ BSTR* name) = 0;
	ICALLTYPE _set_ SetFaceName(char* name) = 0;
	ICALLTYPE Copy(IFont_DG* font) = 0;
	IUNKNOWN_
};

[uuid("{9E149CE4-CB18-4744-98B6-DE29072FD095}")]
class IObject_DG : public IUnknown
{
public:
	ICALLTYPE IsSameInstance(IObject_DG* obj, _retval_ VARIANT_BOOL* result) = 0;
	ICALLTYPE IsSame(IObject_DG* obj, IDictionary_DG* filterOrNull, _retval_ ThreeState_DG* result) = 0;
	ICALLTYPE GetHash(_retval_ int* hash) = 0;
	ICALLTYPE Copy(IObject_DG* obj, IDictionary_DG* filterOrNull) = 0;
	ICALLTYPE Clone(_retval_ IObject_DG** objectNew) = 0;
	ICALLTYPE Execute(char* operation, IDictionary_DG* context, _retval_ VARIANT_BOOL* success) = 0;
	IUNKNOWN_
};

[uuid("{2AD64E57-8FD9-4C76-A305-2AD75FDFF229}")]
class IObjectGenerator_DG : public IUnknown
{
public:
	ICALLTYPE Create(char* type, _retval_ IUnknown** iResult) = 0;
	ICALLTYPE Create1(char* type, IUnknown* iParam, _retval_ IUnknown** iResult) = 0;
	ICALLTYPE Create2(char* type, IDictionary_DG* context, _retval_ IUnknown** iResult) = 0;
	IUNKNOWN_
};

[uuid("{4CB0B057-3A7A-46D9-B1EB-68460FE5F465}")]
class IUserData_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetData(_retval_ __int64* data) = 0;
	ICALLTYPE _set_ SetData(__int64 data) = 0;
	ICALLTYPE _get_ GetLayerName(_retval_ BSTR* name) = 0;
	ICALLTYPE _set_ SetLayerName(char* name) = 0;
	IUNKNOWN_
};

[uuid("{4C545453-C7FE-4C59-9469-ECC6C81BF6BF}")]
class IAppearance_DG : public IUnknown
{
public:
	ICALLTYPE GetColor(_out_ float* red, _out_ float* green, _out_ float* blue) = 0;
	ICALLTYPE SetColor(float red, float green, float blue) = 0;
	ICALLTYPE _get_ GetPointWidth(_retval_ float* width) = 0;
	ICALLTYPE _set_ SetPointWidth(float width) = 0;
	ICALLTYPE GetDimension(EDim_DG* dim) = 0;
	IUNKNOWN_
};

[uuid("{31D6B048-5BB1-4C50-8D9E-67CAF8949B43}")]
class IError_DG : public IUnknown
{
public:
	ICALLTYPE GetError(_retval_ BSTR* err) = 0;
	ICALLTYPE GetErrorEx(int index, _retval_ BSTR* err) = 0;
	ICALLTYPE GetCount(_retval_ int* count) = 0;
	IUNKNOWN_
};

[uuid("{B84E7B93-9295-4607-96A5-99FDA9D84C76}")]
class IRectangleColor_DG : public IUnknown
{
public:
	ICALLTYPE SetStockStyle(int style, Color_DG* color0, Color_DG* color1) = 0;
	ICALLTYPE SetColorCount(int side, int count) = 0;
	ICALLTYPE GetColorCount(int side, int* count) = 0;
	ICALLTYPE SetColor(int side, int index, float location, Color_DG* color) = 0;
	ICALLTYPE GetColor(int side, int index, float* location, Color_DG* color) = 0;
	IUNKNOWN_
};

[uuid("{EAE198E4-3EA0-4B95-B830-B37081C41BC1}")]
class I2DPointArray_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetCount(_retval_ int* count) = 0;
	ICALLTYPE _set_ SetCount(int count) = 0;
	ICALLTYPE GetPoint(int index, _out_ double* x, _out_ double* y) = 0;
	ICALLTYPE GetPoint1(int index, _retval_ DG2D* pt) = 0;
	ICALLTYPE SetPoint(int index, double x, double y) = 0;
	ICALLTYPE SetPoint1(int index, DG2D* pt) = 0;
	ICALLTYPE Add(double x, double y) = 0;
	ICALLTYPE InsertAt(int indexAt, double x, double y) = 0;
	ICALLTYPE RemoveAt(int index) = 0;
	ICALLTYPE RemoveAll() = 0;
	ICALLTYPE FindPoint(double x, double y, double tolerance, _retval_ int* index) = 0;
	ICALLTYPE Copy(I2DPointArray_DG* iArray) = 0;
	ICALLTYPE Append(I2DPointArray_DG* iArray) = 0;
	ICALLTYPE InsertArrayAt(int indexAt, I2DPointArray_DG* iArray) = 0;
	IUNKNOWN_
};

[uuid("{B0C851E5-7AD9-49E7-A3AB-97C07640C3C1}")]
class IPointArray_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetCount(_retval_ int* count) = 0;
	ICALLTYPE _set_ SetCount(int count) = 0;
	ICALLTYPE GetPoint(int index, _retval_ Point_DG* pt) = 0;
	ICALLTYPE SetPoint(int index, Point_DG* pt) = 0;
	ICALLTYPE SetPoint1(int index, double x, double y, double z) = 0;
	ICALLTYPE Add(Point_DG* pt) = 0;
	ICALLTYPE Add1(double x, double y, double z) = 0;
	ICALLTYPE InsertAt(int indexAt, Point_DG* pt) = 0;
	ICALLTYPE RemoveAt(int index) = 0;
	ICALLTYPE RemoveAll() = 0;
	ICALLTYPE FindPoint(Point_DG* pt, double tolerance, _retval_ int* index) = 0;
	ICALLTYPE Copy(IPointArray_DG* iArray) = 0;
	ICALLTYPE Append(IPointArray_DG* iArray) = 0;
	ICALLTYPE InsertArrayAt(int indexAt, IPointArray_DG* iArray) = 0;
	IUNKNOWN_
};

[uuid("{4B02AA11-BBA4-499D-AB22-CC379ADEF18C}")]
class IPointMatrix_DG : public IUnknown
{
public:
	ICALLTYPE GetSize(_out_ int* rows, _out_ int* columns) = 0;
	ICALLTYPE SetSize(int rows, int columns) = 0;
	ICALLTYPE GetPoint(int row, int column, _retval_ Point_DG* pt) = 0;
	ICALLTYPE GetPoint1(int row, int column, _out_ double* x, _out_ double* y, _out_ double* z) = 0;
	ICALLTYPE SetPoint(int row, int column, Point_DG* pt) = 0;
	ICALLTYPE SetPoint1(int row, int column, double x, double y, double z) = 0;
	ICALLTYPE Copy(IPointMatrix_DG* iArray) = 0;
	ICALLTYPE GetRows(_retval_ int* rows) = 0;
	ICALLTYPE GetColumns(_retval_ int* columns) = 0;
	IUNKNOWN_
};

[uuid("{6F68B1A2-69F9-4e3e-B8BC-7D3E17E9CC2B}")]
class IFrame_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetOrigin(_retval_ Point_DG* origin) = 0;
	ICALLTYPE GetOrigin1(_out_ double* x, _out_ double* y, _out_ double* z) = 0;
	ICALLTYPE _set_ SetOrigin(Point_DG* origin) = 0;
	ICALLTYPE SetOrigin1(double x, double y, double z) = 0;
	ICALLTYPE GetAxis(int index, _retval_ Vect_DG* axis) = 0;
	ICALLTYPE GetAxisRay(int index, _retval_ Line_DG* axis) = 0;
	ICALLTYPE GetPlane(int index, _retval_ Plane_DG* plane) = 0;
	ICALLTYPE Translate(Vect_DG* vectBy) = 0;
	ICALLTYPE Translate1(double vx, double vy, double vz) = 0;
	ICALLTYPE TranslateGlobal(Vect_DG* vectBy) = 0;
	ICALLTYPE TranslateGlobal1(double vx, double vy, double vz) = 0;
	ICALLTYPE Rotate(double angle, Vect_DG* axis) = 0;
	ICALLTYPE Rotate1(double angle, double vx, double vy, double vz) = 0;
	ICALLTYPE Rotate2(double angle, Line_DG* axis) = 0;
	ICALLTYPE Rotate3(double angle, double xLocnAxis, double yLocnAxis, double zLocnAxis, double xDirAxis, double yDirAxis, double zDirAxis) = 0;
	ICALLTYPE Rotate4(double angle, int axis) = 0;
	ICALLTYPE RotateGlobal(double angle, Vect_DG* axisGlobal) = 0;
	ICALLTYPE RotateGlobal1(double angle, Line_DG* axisGlobal) = 0;
	ICALLTYPE RotateGlobal2(double angle, int axis) = 0;
	ICALLTYPE SetAxes(int axisInd0, Vect_DG* axis0, int axisInd1, Vect_DG* axis1) = 0;
	ICALLTYPE SetupAxes(int axis0, Vect_DG* axis, int axis1) = 0;
	ICALLTYPE Reset() = 0;
	ICALLTYPE ResetOrientation() = 0;
	ICALLTYPE Copy(IFrame_DG* frame) = 0;
	ICALLTYPE Push() = 0;
	ICALLTYPE Pop() = 0;
	ICALLTYPE ToLocal(Point_DG* point, _retval_ Point_DG* pointLocal) = 0;
	ICALLTYPE ToLocal1(Point_DG* point) = 0;
	ICALLTYPE ToGlobal(Point_DG* point, _retval_ Point_DG* pointGlobal) = 0;
	ICALLTYPE ToGlobal1(Point_DG* point) = 0;
	ICALLTYPE ToLocalVector(Vect_DG* vect, _retval_ Vect_DG* vectLocal) = 0;
	ICALLTYPE ToLocalVector1(Vect_DG* vect) = 0;
	ICALLTYPE ToGlobalVector(Vect_DG* vect, _retval_ Vect_DG* vectGlobal) = 0;
	ICALLTYPE ToGlobalVector1(Vect_DG* vect) = 0;
	ICALLTYPE ToLocalFrame(IFrame_DG* frame) = 0;
	ICALLTYPE ToGlobalFrame(IFrame_DG* frame) = 0;
	ICALLTYPE Invert() = 0;
	ICALLTYPE Clone(_retval_ IFrame_DG** frame) = 0;
	ICALLTYPE IsSame(IFrame_DG* frame, double tolerance, _retval_ VARIANT_BOOL* result) = 0;
	ICALLTYPE IsIdentity(double tolerance, _retval_ VARIANT_BOOL* result) = 0;
	IUNKNOWN_
};

[uuid("{455071BB-A960-48BA-A0B4-A90A066B27AE}")]
class IObjectOriented_DG : public IUnknown
{
public:
	ICALLTYPE GetLocation(_retval_ IFrame_DG** frame) = 0;
	IUNKNOWN_
};

[uuid("{E53DEB68-BDC6-40E2-BD25-B61B39469B6E}")]
class IFrameArray_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetCount(_retval_ int* count) = 0;
	ICALLTYPE _set_ SetCount(int count) = 0;
	ICALLTYPE GetFrame(int index, _retval_ IFrame_DG** frame) = 0;
	ICALLTYPE SetFrame(int index, IFrame_DG* frame) = 0;
	ICALLTYPE Add(IFrame_DG* frame) = 0;
	ICALLTYPE InsertAt(int indexAt, IFrame_DG* frame) = 0;
	ICALLTYPE RemoveAt(int index) = 0;
	ICALLTYPE RemoveAll() = 0;
	ICALLTYPE Copy(IFrameArray_DG* iArray) = 0;
	ICALLTYPE Append(IFrameArray_DG* iArray) = 0;
	ICALLTYPE InsertArrayAt(int indexAt, IFrameArray_DG* iArray) = 0;
	IUNKNOWN_
};

[uuid("{39D1DB89-CBE7-48a3-B79B-62C8C77F9669}")]
class ILine2d_DG : public IUnknown
{
public:
	ICALLTYPE Init(DG2D* origin, DG2D* direction) = 0;
	ICALLTYPE Init1(DG2D* end0, DG2D* end1) = 0;
	ICALLTYPE _get_ GetOrigin(_retval_ DG2D* origin) = 0;
	ICALLTYPE _set_ SetOrigin(DG2D* origin) = 0;
	ICALLTYPE _get_ GetDirection(_retval_ DG2D* direction) = 0;
	ICALLTYPE _set_ SetDirection(DG2D* direction) = 0;
	ICALLTYPE DirectTowards(DG2D* target, _retval_ VARIANT_BOOL* success) = 0;
	ICALLTYPE GetPoint(double u, _retval_ DG2D* point) = 0;
	ICALLTYPE ReverseDirection() = 0;
	ICALLTYPE GetDistance(DG2D* point, _out_ DG2D* pointNearestOnThis, _out_ double* paramOnThis, _retval_ double* dist) = 0;
	ICALLTYPE GetAngle(ILine2d_DG* line, _retval_ double* angle) = 0;
	ICALLTYPE GetPointLocation(DG2D* point, double tolerance, _retval_ PointVs2dLineLocation_DG* location) = 0;
	ICALLTYPE IsCollinear(ILine2d_DG* line, double tolerance, _retval_ VARIANT_BOOL* collinear) = 0;
	ICALLTYPE Copy(ILine2d_DG* ray) = 0;
	ICALLTYPE Clone(_retval_ ILine2d_DG** newCopy) = 0;
	IUNKNOWN_
};

[uuid("{B49F519D-B6E9-4742-8B4D-29BA767E48DC}")]
class IFrame2d_DG : public IUnknown
{
public:
	ICALLTYPE Init(DG2D* origin, DG2D* directionX) = 0;
	ICALLTYPE _get_ GetOrigin(_retval_ DG2D* origin) = 0;
	ICALLTYPE _set_ SetOrigin(DG2D* origin) = 0;
	ICALLTYPE _get_ GetXDirection(_retval_ DG2D* direction) = 0;
	ICALLTYPE _set_ SetXDirection(DG2D* direction) = 0;
	ICALLTYPE _get_ GetYDirection(_retval_ DG2D* direction) = 0;
	ICALLTYPE _set_ SetYDirection(DG2D* direction) = 0;
	ICALLTYPE Translate(DG2D* vBy) = 0;
	ICALLTYPE Translate1(double vx, double vy) = 0;
	ICALLTYPE Rotate(double angle) = 0;
	ICALLTYPE Reset() = 0;
	ICALLTYPE ResetOrientation() = 0;
	ICALLTYPE Copy(IFrame2d_DG* frame) = 0;
	ICALLTYPE Clone(_retval_ IFrame2d_DG** newCopy) = 0;
	ICALLTYPE ToLocal(DG2D* point2d) = 0;
	ICALLTYPE ToGlobal(DG2D* point2d) = 0;
	ICALLTYPE ToLocalVector(DG2D* vect2d) = 0;
	ICALLTYPE ToGlobalVector(DG2D* vect2d) = 0;
	ICALLTYPE ToLocalLine(ILine2d_DG* ray) = 0;
	ICALLTYPE ToGlobalLine(ILine2d_DG* ray) = 0;
	ICALLTYPE ToLocalFrame(IFrame2d_DG* frame) = 0;
	ICALLTYPE ToGlobalFrame(IFrame2d_DG* frame) = 0;
	ICALLTYPE Invert() = 0;
	ICALLTYPE IsIdentity(double tolerance, _retval_ VARIANT_BOOL* result) = 0;
	IUNKNOWN_
};

[uuid("{ACDAE16C-BAF0-4F44-82BA-274DD19443F9}")]
class ILabel_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetText(_retval_ BSTR* text) = 0;
	ICALLTYPE _set_ SetText(char* text) = 0;
	ICALLTYPE _get_ GetFont(_retval_ IFont_DG** font) = 0;
	ICALLTYPE _set_ SetFont(IFont_DG* font) = 0;
	ICALLTYPE _get_ GetColor(_retval_ Color_DG* color) = 0;
	ICALLTYPE _set_ SetColor(Color_DG* color) = 0;
	ICALLTYPE _get_ GetBackgroundColor(_retval_ Color_DG* color) = 0;
	ICALLTYPE _set_ SetBackgroundColor(Color_DG* color) = 0;
	ICALLTYPE _get_ GetLocation(_retval_ Point_DG* location) = 0;
	ICALLTYPE _set_ SetLocation(Point_DG* location) = 0;
	ICALLTYPE _get_ GetOrientation(float* angleRadians) = 0;
	ICALLTYPE _set_ SetOrientation(float angleRadians) = 0;
	ICALLTYPE _get_ GetShowBox(_retval_ VARIANT_BOOL* show) = 0;
	ICALLTYPE _set_ SetShowBox(VARIANT_BOOL show) = 0;
	ICALLTYPE _get_ GetShowPointer(_retval_ VARIANT_BOOL* show) = 0;
	ICALLTYPE _set_ SetShowPointer(VARIANT_BOOL show) = 0;
	ICALLTYPE _get_ GetShowText(_retval_ VARIANT_BOOL* show) = 0;
	ICALLTYPE _set_ SetShowText(VARIANT_BOOL show) = 0;
	ICALLTYPE GetBoxLineStyle(_retval_ ILineStyle_DG** style) = 0;
	ICALLTYPE _get_ GetViewFrameType(_retval_ ViewFrame_DG* frame) = 0;
	ICALLTYPE _set_ SetViewFrameType(ViewFrame_DG frame) = 0;
	ICALLTYPE _get_ GetDepthPositionType(_retval_ ModelEntity_DG* type) = 0;
	ICALLTYPE _set_ SetDepthPositionType(ModelEntity_DG type) = 0;
	IUNKNOWN_
};

[uuid("{A51C7EFD-EE17-494C-86AB-A2CF61A6FB5C}")]
class ILabelGeometry_DG : public IUnknown
{
public:
	ICALLTYPE GetLabel(_retval_ ILabel_DG** label) = 0;
	ICALLTYPE GetGeometricSize(_retval_ DG2D* size) = 0;
	ICALLTYPE SetGeometricHeight(double height) = 0;
	IUNKNOWN_
};

[uuid("{256A2D37-5D86-48C2-9BAD-46E87E1441E3}")]
class IDynamicScreenItem_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetSize(_retval_ DG2D* size) = 0;
	ICALLTYPE _set_ SetSize(DG2D* size) = 0;
	ICALLTYPE _get_ GetAttachmentPoint(_retval_ Point_DG* pt) = 0;
	ICALLTYPE _set_ SetAttachmentPoint(Point_DG* pt) = 0;
	IUNKNOWN_
};

[uuid("{61D7749A-65CB-4DB6-ADB0-5BA5B67536AD}")]
class IDynamicScreenItemManager_DG : public IUnknown
{
public:
	ICALLTYPE _get_ IsEnabled(_retval_ VARIANT_BOOL* enabled) = 0;
	ICALLTYPE _set_ SetEnabled(VARIANT_BOOL enable) = 0;
	ICALLTYPE GetItemCount(_retval_ int* count) = 0;
	ICALLTYPE GetItem(int index, _retval_ IDynamicScreenItem_DG** item) = 0;
	ICALLTYPE _get_ GetSpacing(_retval_ int* pixels) = 0;
	ICALLTYPE _set_ SetSpacing(int pixels) = 0;
	ICALLTYPE _get_ GetSpacingItemToObjects(_retval_ int* pixels) = 0;
	ICALLTYPE _set_ SetSpacingItemToObjects(int pixels) = 0;
	ICALLTYPE RemoveItem(int item) = 0;
	ICALLTYPE RemoveAll() = 0;
	ICALLTYPE _get_ IsEnabledOnTop(_retval_ VARIANT_BOOL* enabled) = 0;
	ICALLTYPE _set_ SetEnabledOnTop(VARIANT_BOOL enable) = 0;
	ICALLTYPE _get_ IsEnabledOutside(_retval_ VARIANT_BOOL* enabled) = 0;
	ICALLTYPE _set_ SetEnabledOutside(VARIANT_BOOL enable) = 0;
	ICALLTYPE _get_ IsEnabledHiddenItemRemoval(VARIANT_BOOL* enabled) = 0;
	ICALLTYPE _set_ SetEnabledHiddenItemRemoval(VARIANT_BOOL enable) = 0;
	ICALLTYPE Update() = 0;
	IUNKNOWN_
};

[uuid("{DB84FBFD-74A8-4FCA-BADF-82431ED3A9F8}")]
class ISmartLabelManager_DG : public IUnknown
{
public:
	ICALLTYPE GetLabel(int index, _retval_ ILabel_DG** label) = 0;
	ICALLTYPE CreateLabelsAutomatic() = 0;
	ICALLTYPE CreateObjectLabelAutomatic(IEntity_DG* object, VARIANT_BOOL includeChildren, VARIANT_BOOL childrenOnly) = 0;
	ICALLTYPE _get_ GetStringSource(_retval_ StringSource_DG* type) = 0;
	ICALLTYPE _set_ SetStringSource(StringSource_DG type) = 0;
	ICALLTYPE _get_ GetTextToRectangleMargin(_retval_ float* textHeightToMarginRatio) = 0;
	ICALLTYPE _set_ SetTextToRectangleMargin(float textHeightToMarginRatio) = 0;
	ICALLTYPE AddNewLabel(IEntity_DG* parent, _retval_ ILabel_DG** label) = 0;
	ICALLTYPE GetLabelCreationTemplate(_retval_ ILabel_DG** label) = 0;
	ICALLTYPE GetExtendedProperties(_retval_ IContext_DG** context) = 0;
	IUNKNOWN_
};

[uuid("{4F8D9B7D-1A58-4DC0-B994-35F2022B815A}")]
class ICurve2d_DG : public IUnknown
{
public:
	ICALLTYPE GetParameterRange(_out_ double* min, _out_ double* max) = 0;
	ICALLTYPE GetParameterRange1(_retval_ Range_DG* range) = 0;
	ICALLTYPE SetParameterRange(double min, double max) = 0;
	ICALLTYPE IsFiniteParameterRange(_retval_ VARIANT_BOOL* retVal) = 0;
	ICALLTYPE IsClosed(_retval_ VARIANT_BOOL* retVal) = 0;
	ICALLTYPE IsPeriodic(_retval_ VARIANT_BOOL* retVal) = 0;
	ICALLTYPE GetPeriod(_retval_ double* period) = 0;
	ICALLTYPE GetPoint(double u, _retval_ DG2D* point) = 0;
	ICALLTYPE GetPointAtRatio(double ratio, _retval_ DG2D* point) = 0;
	ICALLTYPE GetTangent(double u, _retval_ DG2D* tangent) = 0;
	ICALLTYPE GetEndPoint(int end, _retval_ DG2D* point) = 0;
	ICALLTYPE SlideEndPoint(int end, DG2D* point, _retval_ VARIANT_BOOL* success) = 0;
	ICALLTYPE GetNearestPoint(DG2D* point, _out_ DG2D* pointNearest, _retval_ double* paramNearest) = 0;
	ICALLTYPE GetPointLocation(DG2D* point, double tolerance, _retval_ PointVs2dCurveLocation_DG* location) = 0;
	ICALLTYPE GetLength(_retval_ double* length) = 0;
	ICALLTYPE GetLengthAt(double u, _retval_ double* length) = 0;
	ICALLTYPE GetParameterAtLength(double length, _retval_ double* u) = 0;
	ICALLTYPE GetParameterAtRatio(double ratio, _retval_ double* u) = 0;
	ICALLTYPE GetRatioAt(double u, _retval_ double* ratio) = 0;
	ICALLTYPE GetIntersection(ICurve2d_DG* curve, double tolerance, _out_ IArrayDouble_DG** paramsThis, _out_ IArrayDouble_DG** paramsCurve, _out_ VARIANT_BOOL* haveTangentialIntersection, _retval_ int* intersections) = 0;
	ICALLTYPE GetIntersection1(ICurve2d_DG* curve, double tolerance, _out_ ISetR1_DG** paramsThis, _out_ ISetR1_DG** paramsCurve, _out_ IArrayBool_DG** flagsTangential, _retval_ VARIANT_BOOL* haveIntersection) = 0;
	IUNKNOWN_
};

[uuid("{0E354FCE-E525-4D53-916A-37E4901B0EB7}")]
class IArc_DG : public IUnknown
{
public:
	ICALLTYPE GetEndPoint(int end, _retval_ DG2D* point) = 0;
	ICALLTYPE GetEndPoint1(int end, _out_ double* x, _out_ double* y) = 0;
	ICALLTYPE SetEndPoint(int end, DG2D* point) = 0;
	ICALLTYPE SetEndPoint1(int end, double x, double y) = 0;
	ICALLTYPE _get_ GetCurvature(_retval_ double* curv) = 0;
	ICALLTYPE _set_ SetCurvature(double curv) = 0;
	ICALLTYPE Init(_retval_ VARIANT_BOOL* success) = 0;
	ICALLTYPE IsValid(_retval_ VARIANT_BOOL* valid) = 0;
	ICALLTYPE MakeValid(_retval_ VARIANT_BOOL* valid) = 0;
	ICALLTYPE GetPoint(double t, _retval_ DG2D* point) = 0;
	ICALLTYPE GetPoint1(double t, _out_ double* x, _out_ double* y) = 0;
	ICALLTYPE _get_ GetRadius(_retval_ double* r) = 0;
	ICALLTYPE _set_ SetRadius(double r) = 0;
	ICALLTYPE GetCenter(_retval_ DG2D* center) = 0;
	ICALLTYPE GetCenter1(_out_ double* x, _out_ double* y) = 0;
	ICALLTYPE GetAngleRange(_out_ double* min, _out_ double* max) = 0;
	ICALLTYPE PassThroughPoint(double x, double y, _retval_ int* result) = 0;
	IUNKNOWN_
};

[uuid("{84e4ec17-66e7-4a48-a0cb-bd3a05a15ed8}")]
class IGeometricObject2d_DG : public IUnknown
{
public:
	ICALLTYPE Translate(DG2D* vectBy) = 0;
	ICALLTYPE Translate1(double vx, double vy) = 0;
	ICALLTYPE Rotate(double angle, DG2D* center) = 0;
	ICALLTYPE Rotate1(double angle, double xCenter, double yCenter) = 0;
	ICALLTYPE Scale(DG2D* center, double factor) = 0;
	ICALLTYPE Mirror(int axis, double position) = 0;
	ICALLTYPE Mirror1(Ray2d_DG* line) = 0;
	ICALLTYPE ToGlobal(IFrame2d_DG* frameOfThis) = 0;
	ICALLTYPE ToLocal(IFrame2d_DG* frameOfOther) = 0;
	ICALLTYPE GetGeomLocation(_retval_ Ray2d_DG** ray) = 0;
	IUNKNOWN_
};

[uuid("{345BED64-9F1B-4CE7-AF2C-9D46BF388921}")]
class IBSplineCurve2d_DG : public IUnknown
{
public:
	ICALLTYPE Init(I2DPointArray_DG* poles, IArrayDouble_DG* knots, IArrayInt_DG* multiplicities, int degree, VARIANT_BOOL periodic) = 0;
	ICALLTYPE Init1(I2DPointArray_DG* poles, IArrayDouble_DG* weights, IArrayDouble_DG* knots, IArrayInt_DG* multiplicities, int degree, VARIANT_BOOL periodic) = 0;
	ICALLTYPE InitFromPoints(I2DPointArray_DG* points, int degreeMin, int degreeMax, Continuity_DG continuity, double tolerance) = 0;
	ICALLTYPE InitFromPoints1(I2DPointArray_DG* points, IArrayDouble_DG* parameters, int degreeMin, int degreeMax, Continuity_DG continuity, double tolerance) = 0;
	ICALLTYPE InitFromPoints2(I2DPointArray_DG* points, double smoothingWeight0, double smoothingWeight1, double smoothingWeight2, int degreeMax, Continuity_DG continuity, double tolerance) = 0;
	ICALLTYPE Interpolate(I2DPointArray_DG* points, VARIANT_BOOL periodic, double tolerance) = 0;
	ICALLTYPE Interpolate1(I2DPointArray_DG* points, IArrayDouble_DG* parameters, VARIANT_BOOL periodic, double tolerance) = 0;
	ICALLTYPE Interpolate2(I2DPointArray_DG* points, DG2D* tangentStart, DG2D* tangentEnd, IArrayDouble_DG* paramsOrNull, VARIANT_BOOL periodic, double tolerance) = 0;
	ICALLTYPE Interpolate3(I2DPointArray_DG* points, I2DPointArray_DG* tangents, IArrayBool_DG* tangentFlags, IArrayDouble_DG* paramsOrNull, VARIANT_BOOL periodic, double tolerance) = 0;
	ICALLTYPE _get_ GetDegree(_retval_ int* degree) = 0;
	ICALLTYPE _set_ SetDegree(int degree) = 0;
	ICALLTYPE GetKnotCount(_retval_ int* count) = 0;
	ICALLTYPE GetKnot(int index, _retval_ double* u) = 0;
	ICALLTYPE GetKnots(_retval_ IArrayDouble_DG** knots) = 0;
	ICALLTYPE SetKnot(int index, double knot) = 0;
	ICALLTYPE SetKnot1(int index, double knot, int multiplicity) = 0;
	ICALLTYPE SetKnots(IArrayDouble_DG* knots) = 0;
	ICALLTYPE GetMultiplicity(int indexKnot, _retval_ int* multiplicity) = 0;
	ICALLTYPE GetMultiplicities(_retval_ IArrayInt_DG** iArr) = 0;
	ICALLTYPE SetMultiplicity(int indexKnot, int multiplicity) = 0;
	ICALLTYPE SetMultiplicity1(int indexKnot0, int indexKnot1, int multiplicity) = 0;
	ICALLTYPE GetPoleCount(_retval_ int* count) = 0;
	ICALLTYPE GetPole(int index, _retval_ DG2D* pt) = 0;
	ICALLTYPE GetPoles(_retval_ I2DPointArray_DG** iArr) = 0;
	ICALLTYPE SetPole(int index, DG2D* pt) = 0;
	ICALLTYPE SetPole1(int index, DG2D* pt, double weight) = 0;
	ICALLTYPE GetWeight(int indexPole, _retval_ double* weight) = 0;
	ICALLTYPE SetWeight(int indexPole, double weight) = 0;
	ICALLTYPE GetWeights(_retval_ IArrayDouble_DG** weights) = 0;
	ICALLTYPE IsClosed(_retval_ VARIANT_BOOL* closed) = 0;
	ICALLTYPE IsPeriodic(_retval_ VARIANT_BOOL* periodic) = 0;
	ICALLTYPE SetPeriodic(VARIANT_BOOL periodic) = 0;
	ICALLTYPE IsRational(_retval_ VARIANT_BOOL* rational) = 0;
	ICALLTYPE GetPoint(double u, _retval_ DG2D* pt) = 0;
	ICALLTYPE GetJet1(double u, _out_ DG2D* pt, _out_ DG2D* v1) = 0;
	ICALLTYPE GetJet2(double u, DG2D* pt, _out_ DG2D* v1, _out_ DG2D* v2) = 0;
	ICALLTYPE GetJetN(double u, int n, _retval_ DG2D* v) = 0;
	ICALLTYPE GetContinuity(_retval_ Continuity_DG* continuity) = 0;
	ICALLTYPE GetEndParameter(VARIANT_BOOL first, _retval_ double* u) = 0;
	ICALLTYPE GetEndPoint(VARIANT_BOOL first, _retval_ DG2D* pt) = 0;
	ICALLTYPE InsertKnot(double u, int multiplicity, double tolerance) = 0;
	ICALLTYPE InsertKnots(IArrayDouble_DG* knots, IArrayInt_DG* multiplicities, double tolerance, VARIANT_BOOL add) = 0;
	ICALLTYPE RemoveKnot(int index, int multiplicity) = 0;
	ICALLTYPE Reverse() = 0;
	ICALLTYPE SetRange(double min, double max) = 0;
	ICALLTYPE NormalizePeriodic(_inout_ double* u) = 0;
	ICALLTYPE SetOrigin(int indexKnot) = 0;
	ICALLTYPE ModifyPoint(double u, DG2D* pt, int indexPoleFrom, int indexPoleTo, _out_ int* firstModifiedPole, _out_ int* lastModifiedPole) = 0;
	ICALLTYPE ModifyPointAndTangent(double u, DG2D* pt, DG2D* tangent, double tolerance, int startingCondition, int endingCondition, _retval_ int* errorStatus) = 0;
	ICALLTYPE GetEndKnotIndex(VARIANT_BOOL first, _retval_ int* ind) = 0;
	ICALLTYPE GetKnotSequence(_retval_ IArrayDouble_DG** knots) = 0;
	ICALLTYPE GetKnotDistributionType(_retval_ int* retValEnum) = 0;
	ICALLTYPE FindParameter(double u, double tolerance, _out_ int* i0, _out_ int* i1, VARIANT_BOOL withKnotRepetition) = 0;
	IUNKNOWN_
};

[uuid("{A14F8FC3-37E5-4EE3-8671-5FC902E1DACF}")]
class ICircle2d_DG : public IUnknown
{
public:
	ICALLTYPE Init(DG2D* center, double radius) = 0;
	ICALLTYPE Init1(DG2D* center, DG2D* axisX, double radius) = 0;
	ICALLTYPE Init2(IFrame2d_DG* frame, double radius) = 0;
	ICALLTYPE Init3(DG2D* point0, DG2D* point1, double radius) = 0;
	ICALLTYPE Init4(DG2D* point0, DG2D* point1, DG2D* point2) = 0;
	ICALLTYPE _get_ GetRadius(_retval_ double* ret) = 0;
	ICALLTYPE _set_ SetRadius(double radius) = 0;
	ICALLTYPE _get_ GetCenter(_retval_ DG2D* center) = 0;
	ICALLTYPE _set_ SetCenter(DG2D* center) = 0;
	ICALLTYPE _get_ GetLocation(_retval_ IFrame2d_DG** frame) = 0;
	ICALLTYPE _set_ SetLocation(IFrame2d_DG* frame) = 0;
	ICALLTYPE GetPoint(double angle, _retval_ DG2D* point) = 0;
	ICALLTYPE GetTangent(double angle, _retval_ DG2D* v) = 0;
	ICALLTYPE GetNormal(double angle, _retval_ DG2D* v) = 0;
	ICALLTYPE Copy(ICircle2d_DG* circle) = 0;
	IUNKNOWN_
};

[uuid("{1EE9E5FE-CD6B-4DF0-A2BA-55401CC55D7C}")]
class IEntity2d_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetName(_retval_ BSTR* name) = 0;
	ICALLTYPE _set_ SetName(char* name) = 0;
	ICALLTYPE _get_ GetType(_retval_ BSTR* type) = 0;
	ICALLTYPE GetPrimaryInterfaceType(_retval_ BSTR* interfaceName) = 0;
	ICALLTYPE GetPrimaryInterface(_retval_ IUnknown** interf) = 0;
	ICALLTYPE GetLocation(_retval_ IFrame2d_DG** frame) = 0;
	ICALLTYPE GetAppearance(_retval_ IAppearance_DG** appearance) = 0;
	ICALLTYPE SetColor(float red, float green, float blue) = 0;
	ICALLTYPE _get_ IsVisible(_retval_ VARIANT_BOOL* visible) = 0;
	ICALLTYPE _set_ SetVisible(VARIANT_BOOL visible) = 0;
	ICALLTYPE GetBoundingRectangle(_retval_ Rectangle_DG* rect) = 0;
	ICALLTYPE Copy(IEntity2d_DG* entity) = 0;
	ICALLTYPE Clone(_retval_ IEntity2d_DG** entity) = 0;
	ICALLTYPE GetExtendedProperties(_retval_ IDictionary_DG** properties) = 0;
	IUNKNOWN_
};

[uuid("{0F85A31F-E996-4D7E-9879-E90BDCA801DC}")]
class IModel2d_DG : public IUnknown
{
public:
	ICALLTYPE GetEntityCount(_retval_ int* count) = 0;
	ICALLTYPE GetEntityAt(int index, _retval_ IEntity2d_DG** entity) = 0;
	ICALLTYPE AddEntity(IEntity2d_DG* entity) = 0;
	ICALLTYPE AddNewEntity(char* type, _retval_ IEntity2d_DG** entity) = 0;
	ICALLTYPE RemoveAt(int index) = 0;
	ICALLTYPE RemoveEntity(IEntity2d_DG* entity, _retval_ VARIANT_BOOL* success) = 0;
	ICALLTYPE RemoveAll() = 0;
	ICALLTYPE Find(IEntity2d_DG* entity, _retval_ int* index) = 0;
	ICALLTYPE FindEntity(IDictionary_DG* query, _retval_ IEntity2d_DG** entity) = 0;
	ICALLTYPE GetBoundingRectangle(_retval_ Rectangle_DG* rect) = 0;
	ICALLTYPE Copy(IModel2d_DG* model) = 0;
	ICALLTYPE Clone(_retval_ IModel2d_DG** model) = 0;
	IUNKNOWN_
};

[uuid("{B15AE83E-8EE8-4876-9DCB-6D58F314505F}")]
class ICurve_DG : public IUnknown
{
public:
	ICALLTYPE GetParameterRange(_out_ double* min, _out_ double* max) = 0;
	ICALLTYPE GetParameterRange1(_retval_ Range_DG* range) = 0;
	ICALLTYPE SetParameterRange(double min, double max) = 0;
	ICALLTYPE IsFiniteParameterRange(_retval_ VARIANT_BOOL* retVal) = 0;
	ICALLTYPE IsClosed(_retval_ VARIANT_BOOL* retVal) = 0;
	ICALLTYPE IsPeriodic(_retval_ VARIANT_BOOL* retVal) = 0;
	ICALLTYPE GetPeriod(_retval_ double* period) = 0;
	ICALLTYPE GetPoint(double u, _retval_ Point_DG* point) = 0;
	ICALLTYPE GetPointAtRatio(double ratio, _retval_ Point_DG* point) = 0;
	ICALLTYPE GetTangent(double u, _retval_ Vect_DG* tangent) = 0;
	ICALLTYPE GetEndPoint(int end, _retval_ Point_DG* point) = 0;
	ICALLTYPE SlideEndPoint(int end, Point_DG* point, _retval_ VARIANT_BOOL* success) = 0;
	ICALLTYPE GetNearestPoint(Point_DG* point, _out_ Point_DG* pointNearest, _retval_ double* paramNearest) = 0;
	ICALLTYPE GetLength(_retval_ double* length) = 0;
	ICALLTYPE GetLengthAt(double u, _retval_ double* length) = 0;
	ICALLTYPE GetParameterAtLength(double length, _retval_ double* u) = 0;
	ICALLTYPE GetParameterAtRatio(double ratio, _retval_ double* u) = 0;
	ICALLTYPE GetRatioAt(double u, _retval_ double* ratio) = 0;
	ICALLTYPE GetIntersection(ICurve_DG* curve, double tolerance, _out_ IArrayDouble_DG** paramsThis, _out_ IArrayDouble_DG** paramsCurve, _out_ VARIANT_BOOL* haveTangentialIntersection, _retval_ int* intersections) = 0;
	ICALLTYPE GetIntersection1(ICurve_DG* curve, double tolerance, _out_ ISetR1_DG** paramsThis, _out_ ISetR1_DG** paramsCurve, _out_ IArrayBool_DG** flagsTangential, _retval_ VARIANT_BOOL* haveIntersection) = 0;
	ICALLTYPE GetPointLocation(Point_DG* point, double tolerance, _retval_ PointVsCurveLocation_DG* location) = 0;
	ICALLTYPE Reverse() = 0;
	IUNKNOWN_
};

[uuid("{7DFA0CD4-6114-4B57-8D57-A39AB8ECC486}")]
class IArcSpline3DCurve_DG : public IUnknown
{
public:
	ICALLTYPE  GetSplineNormals(_retval_ IPointArray_DG** normals) = 0;
	ICALLTYPE  GetCurvatureArray(_retval_ IArrayDouble_DG** curvatures) = 0;
	ICALLTYPE  GetSpline(int index, _retval_ IArc_DG** iArc) = 0;
	ICALLTYPE  MakeSmoothModifyCurvatures() = 0;
	ICALLTYPE  MakeSmoothAlternating(double curvature) = 0;
	IUNKNOWN_
};

[uuid("{9278DEAD-00FB-47A0-AC23-9156C265F6CC}")]
class ICurveFreeForm_DG : public IUnknown
{
public:
	ICALLTYPE GetData(_retval_ IPointArray_DG** points) = 0;
	ICALLTYPE _get_ GetInterpolationDegree(_retval_ int* degree) = 0;
	ICALLTYPE _set_ SetInterpolationDegree(int degree) = 0;
	ICALLTYPE Extend(ICurveFreeForm_DG* curve) = 0;
	ICALLTYPE ConstructFilletedLineStrip(double radius, _retval_ IArcSpline3DCurve_DG** curve) = 0;
	ICALLTYPE ConstructFilletedLineStrip1(IArrayDouble_DG* radii, _retval_ IArcSpline3DCurve_DG** curve) = 0;
	IUNKNOWN_
};

[uuid("{0AF5B1FA-A1F1-46E9-B82E-FAB8ECD176FC}")]
class ICurveArray_DG : public IUnknown
{
public:
	ICALLTYPE GetCount(_retval_ int* count) = 0;
	ICALLTYPE IsEmpty(_retval_ VARIANT_BOOL* result) = 0;
	ICALLTYPE GetAt(int index, _retval_ ICurve_DG** curve) = 0;
	ICALLTYPE RemoveAt(int index) = 0;
	ICALLTYPE RemoveAll() = 0;
	ICALLTYPE Add(ICurve_DG* curve) = 0;
	IUNKNOWN_
};

[uuid("{06A76568-E008-4075-863D-3F2F3FCE39BD}")]
class ICircle_DG : public IUnknown
{
public:
	ICALLTYPE Init(Point_DG* center, Vect_DG* normal, double radius) = 0;
	ICALLTYPE Init1(IFrame_DG* frame, double radius) = 0;
	ICALLTYPE Init2(Point_DG* point0, Point_DG* point1, Point_DG* point2) = 0;
	ICALLTYPE Init3(Point_DG* endArc0, Point_DG* endArc1, Vect_DG* normal, double radius) = 0;
	ICALLTYPE Init4(Point_DG* center, Vect_DG* normal, Vect_DG* axisX, double radius) = 0;
	ICALLTYPE _get_ GetRadius(_retval_ double* ret) = 0;
	ICALLTYPE _set_ SetRadius(double radius) = 0;
	ICALLTYPE _get_ GetCenter(_retval_ Point_DG* center) = 0;
	ICALLTYPE _set_ SetCenter(Point_DG* center) = 0;
	ICALLTYPE _get_ GetLocation(_retval_ IFrame_DG** frame) = 0;
	ICALLTYPE _set_ SetLocation(IFrame_DG* frame) = 0;
	ICALLTYPE GetPoint(double angle, _retval_ Point_DG* point) = 0;
	ICALLTYPE GetTangent(double angle, _retval_ Vect_DG* v) = 0;
	ICALLTYPE GetNormal(_retval_ Vect_DG* normal) = 0;
	ICALLTYPE Copy(ICircle_DG* circle) = 0;
	ICALLTYPE Clone(_retval_ ICircle_DG** newCopy) = 0;
	IUNKNOWN_
};

[uuid("{56BE06FA-C68D-4357-B0FA-FB7602309917}")]
class IEllipse_DG : public IUnknown
{
public:
	ICALLTYPE Init(double R, double r) = 0;
	ICALLTYPE Init1(Point_DG* center, Vect_DG* normal, double R, double r) = 0;
	ICALLTYPE Init2(IFrame_DG* frame, double R, double r) = 0;
	ICALLTYPE Init3(Point_DG* center, Vect_DG* normal, Vect_DG* axisX, double R, double r) = 0;
	ICALLTYPE _get_ GetMajorRadius(_retval_ double* R) = 0;
	ICALLTYPE _set_ SetMajorRadius(double R) = 0;
	ICALLTYPE _get_ GetMinorRadius(_retval_ double* r) = 0;
	ICALLTYPE _set_ SetMinorRadius(double r) = 0;
	ICALLTYPE _get_ GetCenter(_retval_ Point_DG* center) = 0;
	ICALLTYPE _set_ SetCenter(Point_DG* center) = 0;
	ICALLTYPE _get_ GetLocation(_retval_ IFrame_DG** frame) = 0;
	ICALLTYPE _set_ SetLocation(IFrame_DG* frame) = 0;
	ICALLTYPE GetEccentricity(_retval_ double* val) = 0;
	ICALLTYPE GetFocalDistance(_retval_ double* val) = 0;
	ICALLTYPE GetFocus(int index0or1, _retval_ Point_DG* focus) = 0;
	ICALLTYPE GetPoint(double angle, _retval_ Point_DG* point) = 0;
	ICALLTYPE GetTangent(double angle, _retval_ Vect_DG* v) = 0;
	ICALLTYPE GetNormal(_retval_ Vect_DG* normal) = 0;
	ICALLTYPE Copy(IEllipse_DG* ellipse) = 0;
	ICALLTYPE Clone(_retval_ IEllipse_DG** newCopy) = 0;
	IUNKNOWN_
};

[uuid("{738DB013-4BA9-4501-9BB5-2CF64ABBFC41}")]
class IBSplineCurve_DG : public IUnknown
{
public:
	ICALLTYPE Init(IPointArray_DG* poles, IArrayDouble_DG* knots, IArrayInt_DG* multiplicities, int degree, VARIANT_BOOL periodic) = 0;
	ICALLTYPE Init1(IPointArray_DG* poles, IArrayDouble_DG* weights, IArrayDouble_DG* knots, IArrayInt_DG* multiplicities, int degree, VARIANT_BOOL periodic, VARIANT_BOOL checkRational) = 0;
	ICALLTYPE InitFromPoints(IPointArray_DG* points, int degreeMin, int degreeMax, Continuity_DG continuity, double tolerance) = 0;
	ICALLTYPE InitFromPoints1(IPointArray_DG* points, IArrayDouble_DG* parameters, int degreeMin, int degreeMax, Continuity_DG continuity, double tolerance) = 0;
	ICALLTYPE InitFromPoints2(IPointArray_DG* points, double smoothingWeight0, double smoothingWeight1, double smoothingWeight2, int degreeMax, Continuity_DG continuity, double tolerance) = 0;
	ICALLTYPE Interpolate(IPointArray_DG* points, VARIANT_BOOL periodic, double tolerance) = 0;
	ICALLTYPE Interpolate1(IPointArray_DG* points, IArrayDouble_DG* parameters, VARIANT_BOOL periodic, double tolerance) = 0;
	ICALLTYPE Interpolate2(IPointArray_DG* points, Vect_DG* tangentStart, Vect_DG* tangentEnd, VARIANT_BOOL scale, IArrayDouble_DG* paramsOrNull, VARIANT_BOOL periodic, double tolerance) = 0;
	ICALLTYPE Interpolate3(IPointArray_DG* points, IPointArray_DG* tangents, IArrayBool_DG* tangentFlags, VARIANT_BOOL scale, IArrayDouble_DG* paramsOrNull, VARIANT_BOOL periodic, double tolerance) = 0;
	ICALLTYPE _get_ GetDegree(_retval_ int* degree) = 0;
	ICALLTYPE _set_ SetDegree(int degree) = 0;
	ICALLTYPE GetKnotCount(_retval_ int* count) = 0;
	ICALLTYPE GetKnot(int index, _retval_ double* u) = 0;
	ICALLTYPE GetKnots(_retval_ IArrayDouble_DG** knots) = 0;
	ICALLTYPE SetKnot(int index, double knot) = 0;
	ICALLTYPE SetKnot1(int index, double knot, int multiplicity) = 0;
	ICALLTYPE SetKnots(IArrayDouble_DG* knots) = 0;
	ICALLTYPE GetMultiplicity(int indexKnot, _retval_ int* multiplicity) = 0;
	ICALLTYPE GetMultiplicities(_retval_ IArrayInt_DG** iArr) = 0;
	ICALLTYPE SetMultiplicity(int indexKnot, int multiplicity) = 0;
	ICALLTYPE SetMultiplicity1(int indexKnot0, int indexKnot1, int multiplicity) = 0;
	ICALLTYPE GetPoleCount(_retval_ int* count) = 0;
	ICALLTYPE GetPole(int index, _retval_ Point_DG* pt) = 0;
	ICALLTYPE GetPoles(_retval_ IPointArray_DG** iArr) = 0;
	ICALLTYPE SetPole(int index, Point_DG* pt) = 0;
	ICALLTYPE SetPole1(int index, Point_DG* pt, double weight) = 0;
	ICALLTYPE GetWeight(int indexPole, _retval_ double* weight) = 0;
	ICALLTYPE SetWeight(int indexPole, double weight) = 0;
	ICALLTYPE GetWeights(_retval_ IArrayDouble_DG** weights) = 0;
	ICALLTYPE IsClosed(_retval_ VARIANT_BOOL* closed) = 0;
	ICALLTYPE _get_ IsPeriodic(_retval_ VARIANT_BOOL* periodic) = 0;
	ICALLTYPE _set_ SetPeriodic(VARIANT_BOOL periodic) = 0;
	ICALLTYPE IsRational(_retval_ VARIANT_BOOL* rational) = 0;
	ICALLTYPE GetPoint(double u, _retval_ Point_DG* pt) = 0;
	ICALLTYPE GetJet1(double u, _out_ Point_DG* pt, _out_ Vect_DG* v1) = 0;
	ICALLTYPE GetJet2(double u, _out_ Point_DG* pt, _out_ Vect_DG* v1, _out_ Vect_DG* v2) = 0;
	ICALLTYPE GetJetN(double u, int n, _retval_ Vect_DG* v) = 0;
	ICALLTYPE GetContinuity(_retval_ Continuity_DG* continuity) = 0;
	ICALLTYPE GetEndParameter(VARIANT_BOOL first, _retval_ double* u) = 0;
	ICALLTYPE GetEndPoint(VARIANT_BOOL first, _retval_ Point_DG* pt) = 0;
	ICALLTYPE InsertKnot(double u, int multiplicity, double tolerance, VARIANT_BOOL add) = 0;
	ICALLTYPE InsertKnots(IArrayDouble_DG* knots, IArrayInt_DG* multiplicities, double tolerance, VARIANT_BOOL add) = 0;
	ICALLTYPE RemoveKnot(int index, int multiplicity) = 0;
	ICALLTYPE Reverse() = 0;
	ICALLTYPE SetRange(double min, double max) = 0;
	ICALLTYPE NormalizePeriodic(_inout_ double* u) = 0;
	ICALLTYPE SetOrigin(int indexKnot) = 0;
	ICALLTYPE SetOrigin1(double u, double tolerance) = 0;
	ICALLTYPE ModifyPoint(double u, Point_DG* pt, int indexPoleFrom, int indexPoleTo, _out_ int* firstModifiedPole, _out_ int* lastModifiedPole) = 0;
	ICALLTYPE ModifyPointAndTangent(double u, Point_DG* pt, Vect_DG* tangent, double tolerance, int startingCondition, int endingCondition, _retval_ int* errorStatus) = 0;
	ICALLTYPE GetEndKnotIndex(VARIANT_BOOL first, _retval_ int* ind) = 0;
	ICALLTYPE GetKnotSequence(_retval_ IArrayDouble_DG** knots) = 0;
	ICALLTYPE GetKnotDistributionType(_retval_ int* retValEnum) = 0;
	ICALLTYPE FindParameter(double u, double tolerance, _out_ int* i0, _out_ int* i1, VARIANT_BOOL withKnotRepetition) = 0;
	IUNKNOWN_
};

[uuid("{0E935047-4961-4ED1-9A78-B57FCB2CCDB0}")]
class IBSplineCurveInterpolator_DG : public IUnknown
{
public:
	ICALLTYPE Init(IPointArray_DG* points, VARIANT_BOOL periodic, double tolerance) = 0;
	ICALLTYPE Init1(IPointArray_DG* points, IArrayDouble_DG* parameters, VARIANT_BOOL periodic, double tolerance) = 0;
	ICALLTYPE InitEx(Vect_DG* initialTangent, Vect_DG* finalTangent, VARIANT_BOOL scale) = 0;
	ICALLTYPE InitEx1(IPointArray_DG* tangents, IArrayInt_DG* tangentFlags, VARIANT_BOOL scale) = 0;
	ICALLTYPE Build(_retval_ IBSplineCurve_DG** curve) = 0;
	IUNKNOWN_
};

// A straight line defined by a point on it and direction. Is not assumed to have length. Can be used as a ray
// assumed all coordinates are related either to global axes or some axes known from the context.
[uuid("{A4054E29-5A6B-4515-A46D-0CB38276FBE7}")]
class ILine_DG : public IUnknown
{
public:
	ICALLTYPE Init(Point_DG* origin, Vect_DG* direction) = 0;
	ICALLTYPE Init1(Point_DG* end0, Point_DG* end1) = 0;
	ICALLTYPE Init2(Line_DG* line) = 0;
	ICALLTYPE _get_ GetOrigin(_retval_ Point_DG* origin) = 0;
	ICALLTYPE _set_ SetOrigin(Point_DG* origin) = 0;
	ICALLTYPE _get_ GetDirection(_retval_ Vect_DG* direction) = 0;
	ICALLTYPE _set_ SetDirection(Vect_DG* direction) = 0;
	ICALLTYPE DirectTowards(Point_DG* target, _retval_ VARIANT_BOOL* success) = 0;
	ICALLTYPE GetPoint(double u, _retval_ Point_DG* point) = 0;
	ICALLTYPE ReverseDirection() = 0;
	ICALLTYPE GetDistance(Point_DG* point, _out_ Point_DG* pointNearestOnThis, _out_ double* paramOnThis, _retval_ double* dist) = 0;
	ICALLTYPE GetDistanceLine(ILine_DG* line, _out_ double* paramNearestThis, _out_ double* paramNearestLine, _retval_ double* dist) = 0;
	ICALLTYPE GetLineIntersection(ILine_DG* line, double tolerance, _out_ double* paramThis, _out_ double* paramLine, _out_ Point_DG* intersection, _retval_ VARIANT_BOOL* success) = 0;
	ICALLTYPE GetAngle(ILine_DG* line, _retval_ double* angle) = 0;
	ICALLTYPE GetPointLocation(Point_DG* point, double tolerance, _retval_ PointVsLineLocation_DG* location) = 0;
	ICALLTYPE GetPointPosition(Point_DG* point, _retval_ double* u) = 0;
	ICALLTYPE IsCollinear(ILine_DG* line, double tolerance, _retval_ VARIANT_BOOL* collinear) = 0;
	ICALLTYPE IsCoplanar(ILine_DG* line, double tolerance, _retval_ VARIANT_BOOL* coplanar) = 0;
	ICALLTYPE GetLineLocation(ILine_DG* line, double tolerance, _retval_ LineVsLineLocation_DG* location) = 0;
	ICALLTYPE Rotate(ILine_DG* axis, double angleBy) = 0;
	ICALLTYPE Slide(double dist) = 0;
	ICALLTYPE Copy(ILine_DG* line) = 0;
	ICALLTYPE Clone(_retval_ ILine_DG** newCopy) = 0;
	ICALLTYPE GetPointProjection(Point_DG* point, _retval_ Point_DG* pointProjected) = 0;
	ICALLTYPE GetPointProjection1(Point_DG* point, _retval_ double* paramProjected) = 0;
	ICALLTYPE GetVectorProjection(Vect_DG* vector, _retval_ Vect_DG* vectorProjected) = 0;
	IUNKNOWN_
};

[uuid("{47316CFA-EFCD-4D16-9466-5581F2693F07}")]
class IPlane_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetOrigin(_retval_ Point_DG* origin) = 0;
	ICALLTYPE _set_ SetOrigin(Point_DG* origin) = 0;
	ICALLTYPE _get_ GetNormal(_retval_ Vect_DG* normal) = 0;
	ICALLTYPE _set_ SetNormal(Vect_DG* normal) = 0;
	ICALLTYPE Init(Point_DG* point0, Point_DG* point1, Point_DG* point2, _retval_ VARIANT_BOOL* retValOK) = 0;
	ICALLTYPE _get_ GetLocation(_retval_ IFrame_DG** frame) = 0;
	ICALLTYPE _set_ SetLocation(IFrame_DG* frame) = 0;
	ICALLTYPE GetDistance(Point_DG* point, _out_ Point_DG* pointNearestInPlane, _retval_ double* dist) = 0;
	ICALLTYPE GetPointLocation(Point_DG* point, double tolerance, _retval_ PointVsSurfaceLocation_DG* location) = 0;
	ICALLTYPE GetLineIntersection(ILine_DG* line, _out_ Point_DG* intersection, _out_ double* positionLine, _retval_ VARIANT_BOOL* success) = 0;
	ICALLTYPE GetPlaneIntersection(IPlane_DG* plane, _retval_ ILine_DG** intersection) = 0;
	ICALLTYPE Mirror(Point_DG* point) = 0;
	ICALLTYPE MirrorVector(Vect_DG* vector) = 0;
	ICALLTYPE MirrorLine(ILine_DG* line) = 0;
	ICALLTYPE Copy(IPlane_DG* plane) = 0;
	ICALLTYPE Clone(_retval_ IPlane_DG** newCopy) = 0;
	ICALLTYPE GetPointProjection(Point_DG* point, _retval_ Point_DG* pointProjected) = 0;
	ICALLTYPE GetVectorProjection(Vect_DG* vector, _retval_ Vect_DG* vectorProjected) = 0;
	ICALLTYPE GetNormalRay(_retval_ ILine_DG** normal) = 0;
	IUNKNOWN_
};

[uuid("{C255EB59-9D9C-4FE8-B1FA-92884DAA7DF8}")]
class IGeometricObject_DG : public IUnknown
{
public:
	ICALLTYPE IsSame(IGeometricObject_DG* obj, double tolerance, _retval_ VARIANT_BOOL* result) = 0;
	ICALLTYPE IsSameInstance(IGeometricObject_DG* obj, _retval_ VARIANT_BOOL* result) = 0;
	ICALLTYPE Copy(IGeometricObject_DG* obj) = 0;
	ICALLTYPE Clone(_retval_ IGeometricObject_DG** newCopy) = 0;
	ICALLTYPE Translate(Vect_DG* vectBy) = 0;
	ICALLTYPE Translate1(double vx, double vy, double vz) = 0;
	ICALLTYPE Rotate(double angle, Vect_DG* axis) = 0;
	ICALLTYPE Rotate1(double angle, double vx, double vy, double vz) = 0;
	ICALLTYPE Rotate2(double angle, Line_DG* axis) = 0;
	ICALLTYPE Rotate3(double angle, double xLocnAxis, double yLocnAxis, double zLocnAxis, double xDirAxis, double yDirAxis, double zDirAxis) = 0;
	ICALLTYPE Scale(Point_DG* center, double factor) = 0;
	ICALLTYPE Scale1(Point_DG* center, double factorX, double factorY, double factorZ) = 0;
	ICALLTYPE ToGlobal(IFrame_DG* frameOfThis) = 0;
	ICALLTYPE ToLocal(IFrame_DG* frameOfOther) = 0;
	ICALLTYPE ChangeFrame(IFrame_DG* frameOfThisOld, IFrame_DG* frameNew) = 0;
	ICALLTYPE Transform(IFrame_DG* transform) = 0;
	ICALLTYPE Mirror(int axis, double position) = 0;
	ICALLTYPE Mirror1(Plane_DG* plane) = 0;
	IUNKNOWN_
};

[uuid("{0751782B-FFCA-40F1-AB72-2EA2C589F4A6}")]
class IBox_DG : public IUnknown
{
public:
	ICALLTYPE Init(double minx, double maxx, double miny, double maxy, double minz, double maxz) = 0;
	ICALLTYPE GetRange(int axis, _out_ double* min, _out_ double* max) = 0;
	ICALLTYPE GetRange1(int axis, _retval_ Range_DG* range) = 0;
	ICALLTYPE SetRange(int axis, double min, double max) = 0;
	ICALLTYPE SetRange1(int axis, Range_DG* range) = 0;
	ICALLTYPE SetAll(double min, double max) = 0;
	ICALLTYPE _get_ GetLocation(_retval_ IFrame_DG** frame) = 0;
	ICALLTYPE _set_ SetLocation(IFrame_DG* frame) = 0;
	ICALLTYPE GetLimit(int axis, VARIANT_BOOL min, _retval_ double* limit) = 0;
	ICALLTYPE IsEmpty(_retval_ VARIANT_BOOL* empty) = 0;
	ICALLTYPE SetEmpty() = 0;
	ICALLTYPE IsIn(Point_DG* point, double tolerance, _retval_ VARIANT_BOOL* in) = 0;
	ICALLTYPE IsIn1(double x, double y, double z, double tolerance, _retval_ VARIANT_BOOL* in) = 0;
	ICALLTYPE GetPointLocation(Point_DG* point, double tolerance, _retval_ PointVsSolidLocation_DG* location) = 0;
	ICALLTYPE Include(Point_DG* point) = 0;
	ICALLTYPE Include1(double x, double y, double z) = 0;
	ICALLTYPE Expand(double by) = 0;
	ICALLTYPE Translate(double vx, double vy, double vz) = 0;
	ICALLTYPE GetCentre(_retval_ Point_DG* point) = 0;
	ICALLTYPE GetCorner(int index, _retval_ Point_DG* point) = 0;
	ICALLTYPE GetPoint(Point_DG* ratiosAt, _retval_ Point_DG* point) = 0;
	ICALLTYPE GetRatios(Point_DG* point, _retval_ Point_DG* ratios) = 0;
	ICALLTYPE GetSize(int axis, _retval_ double* length) = 0;
	ICALLTYPE GetMaxSize(VARIANT_BOOL maxNotMin, _retval_ double* size) = 0;
	ICALLTYPE GetDiagonalLength(_retval_ double* length) = 0;
	ICALLTYPE GetVolume(_retval_ double* volume) = 0;
	ICALLTYPE GetPlane(int axis, VARIANT_BOOL min, _retval_ IPlane_DG** plane) = 0;
	ICALLTYPE GetDist(Point_DG* point, _retval_ double* distance) = 0;
	ICALLTYPE GetDist1(Point_DG* point, _out_ Point_DG* pointNearest, _retval_ double* distance) = 0;
	ICALLTYPE GetDistBox(IBox_DG* box, _retval_ double* distance) = 0;
	ICALLTYPE GetLineIntersection(ILine_DG* line, _out_ Range_DG* uInside, _retval_ int* count) = 0;
	ICALLTYPE Copy(IBox_DG* box) = 0;
	ICALLTYPE Clone(_retval_ IBox_DG** newCopy) = 0;
	IUNKNOWN_
};

[uuid("{AD3695EE-E945-4A41-B3C0-CDC9451D6ECF}")]
class IPointCloud_DG : public IUnknown
{
public:
	ICALLTYPE GetAxisAlignedBoundingBox(VARIANT_BOOL localAxes, _retval_ IBox_DG** box) = 0;
	ICALLTYPE GetOrientedBoundingBox(IFrame_DG* orientation, _retval_ IBox_DG** box) = 0;
	ICALLTYPE GetMinimumOrientedBoundingBox(float tolerance, int performanceVsPrecision, _retval_ IBox_DG** box) = 0;
	ICALLTYPE GetMeanPoint(_retval_ Point_DG* mean) = 0;
	ICALLTYPE ReduceData(VARIANT_BOOL leave, int start, int step, int end) = 0;
	IUNKNOWN_
};

[uuid("{7DE6E514-7C1B-48F3-AEF5-41013EBBB9E2}")]
class IMetrics_DG : public IUnknown
{
public:
	ICALLTYPE DistPoint(Point_DG* point, _out_ Point_DG* pointNearest, _retval_ double* distance) = 0;
	ICALLTYPE Dist(IMetrics_DG* metricObjectOther, _out_ Point_DG* pointThis, _out_ Point_DG* pointOther, _retval_ double* distance) = 0;
	ICALLTYPE Dist1(IMetrics_DG* metricObjectOther, MetrDistContext_DG* context, _out_ IMapUnkn_DG** nearestThisToOtherMap, _retval_ double* distance) = 0;
	ICALLTYPE IsCloserThan(IMetrics_DG* metricObjectOther, double distance, MetrIsCloserThanContext_DG* context, _retval_ VARIANT_BOOL* closer) = 0;
	ICALLTYPE GetDimensions(_retval_ Box_DG* boundingBox) = 0;
	ICALLTYPE GetLocalDimensions(Box_DG* localBox, Box_DG* dims) = 0;
	ICALLTYPE GetPointLocation(Point_DG* point, double tolerance, _retval_ int* location) = 0;
	ICALLTYPE GetSize(_retval_ double* size) = 0;
	IUNKNOWN_
};

[uuid("{89881CAF-DCB2-4B5B-9ED6-1981F55DFF22}")]
class ICylinder_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetRadius(_retval_ double* ret) = 0;
	ICALLTYPE _set_ SetRadius(double radius) = 0;
	ICALLTYPE _get_ GetLocation(_retval_ IFrame_DG** frame) = 0;
	ICALLTYPE _set_ SetLocation(IFrame_DG* frame) = 0;
	ICALLTYPE Init(IFrame_DG* frame, double radius) = 0;
	ICALLTYPE Copy(ICylinder_DG* cylinder) = 0;
	ICALLTYPE Clone(_retval_ ICylinder_DG** newCopy) = 0;
	IUNKNOWN_
};

// Deprecated. Bad name. Use ICylinder_DG instead
[uuid("{9A37797C-0828-4725-AF5C-F70D29B20483}")]
class ICylindricalSurface_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetRadius(_retval_ double* ret) = 0;
	ICALLTYPE _set_ SetRadius(double radius) = 0;
	ICALLTYPE _get_ GetLocation(_retval_ IFrame_DG** frame) = 0;
	ICALLTYPE _set_ SetLocation(IFrame_DG* frame) = 0;
	ICALLTYPE Init(IFrame_DG* frame, double radius) = 0;
	IUNKNOWN_
};

[uuid("{84CA7C63-3BD2-4603-8486-96FF24BA44DA}")]
class ICone_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetSemiAngle(_retval_ double* ret) = 0;
	ICALLTYPE _set_ SetSemiAngle(double semiAngle) = 0;
	ICALLTYPE _get_ GetLocation(_retval_ IFrame_DG** frame) = 0;
	ICALLTYPE _set_ SetLocation(IFrame_DG* frame) = 0;
	ICALLTYPE Init(IFrame_DG* frame, double semiAngle) = 0;
	ICALLTYPE _get_ GetApex(_retval_ Point_DG* apex) = 0;
	ICALLTYPE _set_ SetApex(Point_DG* apex) = 0;
	ICALLTYPE _get_ GetAxis(_retval_ ILine_DG** axis) = 0;
	ICALLTYPE _set_ SetAxis(ILine_DG* axis) = 0;
	ICALLTYPE _get_ GetAxisDirection(_retval_ Vect_DG* direction) = 0;
	ICALLTYPE _set_ SetAxisDirection(Vect_DG* direction) = 0;
	ICALLTYPE GetRadiusAt(double z, _retval_ double* ret) = 0;
	ICALLTYPE SetRadiusAt(double z, double radius) = 0;
	ICALLTYPE Copy(ICone_DG* cone) = 0;
	ICALLTYPE Clone(_retval_ ICone_DG** newCopy) = 0;
	IUNKNOWN_
};

[uuid("{4CC0EFE3-5BAE-4744-A3A5-6A05DA4894B1}")]
class ISphere_DG : public IUnknown
{
public:
	ICALLTYPE Init(Point_DG* center, double radius) = 0;
	ICALLTYPE Init1(IFrame_DG* frame, double radius) = 0;
	ICALLTYPE _get_ GetRadius(_retval_ double* radius) = 0;
	ICALLTYPE _set_ SetRadius(double radius) = 0;
	ICALLTYPE _get_ GetCenter(_retval_ Point_DG* center) = 0;
	ICALLTYPE _set_ SetCenter(Point_DG* center) = 0;
	ICALLTYPE _get_ GetLocation(_retval_ IFrame_DG** frame) = 0;
	ICALLTYPE _set_ SetLocation(IFrame_DG* frame) = 0;
	ICALLTYPE GetArea(_retval_ double* area) = 0;
	ICALLTYPE GetVolume(_retval_ double* volume) = 0;
	ICALLTYPE Copy(ISphere_DG* sphere) = 0;
	ICALLTYPE Clone(_retval_ ISphere_DG** newCopy) = 0;
	IUNKNOWN_
};

[uuid("{A036159F-398F-49F4-81E2-1728DBA3EC84}")]
class IPolygon3D_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetPoints(_retval_ IPointArray_DG** points) = 0;
	ICALLTYPE _set_ SetPoints(IPointArray_DG* points) = 0;
	ICALLTYPE GetPointCount(_retval_ int* count) = 0;
	ICALLTYPE IsClosed(_retval_ VARIANT_BOOL* closed) = 0;
	ICALLTYPE _get_ GetParameters(_retval_ IArrayDouble_DG** parameters) = 0;
	ICALLTYPE _set_ SetParameters(IArrayDouble_DG* parameters) = 0;
	IUNKNOWN_
};

[uuid("{51E54228-5F28-4611-86BC-09EF44A0B29F}")]
class ITorus_DG : public IUnknown
{
public:
	ICALLTYPE Init(IFrame_DG* frame, double majorRadius, double minorRadius) = 0;
	ICALLTYPE _get_ GetMajorRadius(_retval_ double* radius) = 0;
	ICALLTYPE _set_ SetMajorRadius(double radius) = 0;
	ICALLTYPE _get_ GetMinorRadius(_retval_ double* radius) = 0;
	ICALLTYPE _set_ SetMinorRadius(double radius) = 0;
	ICALLTYPE _get_ GetLocation(_retval_ IFrame_DG** frame) = 0;
	ICALLTYPE _set_ SetLocation(IFrame_DG* frame) = 0;
	ICALLTYPE _get_ GetAxis(_retval_ ILine_DG** axis) = 0;
	ICALLTYPE _set_ SetAxis(ILine_DG* axis) = 0;
	ICALLTYPE _get_ GetCenter(_retval_ Point_DG* apex) = 0;
	ICALLTYPE _set_ SetCenter(Point_DG* apex) = 0;
	ICALLTYPE _get_ GetDirectionAxis(_retval_ Vect_DG* direction) = 0;
	ICALLTYPE _set_ SetDirectionAxis(Vect_DG* direction) = 0;
	ICALLTYPE GetArea(_retval_ double* area) = 0;
	ICALLTYPE GetVolume(_retval_ double* volume) = 0;
	ICALLTYPE Copy(ITorus_DG* torus) = 0;
	ICALLTYPE Clone(_retval_ ITorus_DG** newCopy) = 0;
	IUNKNOWN_
};

[uuid("{43F30623-6F90-463c-8297-4A4A8F33C71B}")]
class IUVSurface_DG : public IUnknown
{
public:
	ICALLTYPE GetSurfaceType(_retval_ ESurfaceType_DG* type) = 0;
	ICALLTYPE GetParameterRange(VARIANT_BOOL u, _out_ double* min, _out_ double* max) = 0;
	ICALLTYPE GetRanges(_retval_ Rectangle_DG* ranges) = 0;
	ICALLTYPE IsClosed(VARIANT_BOOL u, _retval_ VARIANT_BOOL* retVal) = 0;
	ICALLTYPE IsPeriodic(VARIANT_BOOL u, _retval_ VARIANT_BOOL* retVal) = 0;
	ICALLTYPE GetPeriod(VARIANT_BOOL u, _retval_ double* retVal) = 0;
	ICALLTYPE GetIsometricCurve(VARIANT_BOOL u, double parameterAt, _retval_ ICurve_DG** curve) = 0;
	ICALLTYPE GetPoint(DG2D* uv, _retval_ Point_DG* pt) = 0;
	ICALLTYPE GetNormal(DG2D* uv, _retval_ Vect_DG* normal) = 0;
	ICALLTYPE GetTangent(DG2D* uv, VARIANT_BOOL inUDirection, _retval_ Vect_DG* tangent) = 0;
	ICALLTYPE GetJet1(DG2D* uv, _out_ Point_DG* point, _out_ Vect_DG* d1u, _out_ Vect_DG* d1v) = 0;
	ICALLTYPE GetJet2(DG2D* uv, _out_ Point_DG* point, _out_ Vect_DG* d1u, _out_ Vect_DG* d1v, _out_ Vect_DG* d2u, _out_ Vect_DG* d2v, _out_ Vect_DG* d2uv) = 0;
	ICALLTYPE GetJetN(DG2D* uv, int Nu, int Nv, _retval_ Vect_DG* retV) = 0;
	ICALLTYPE GetPointUV(Point_DG* point, _retval_ DG2D* uv) = 0;
	ICALLTYPE GetNearestPoints(Point_DG* point, _retval_ I2DPointArray_DG** uvNearest) = 0;
	ICALLTYPE GetCurveUV(ICurve_DG* curve, _retval_ ICurve2d_DG** curve2D) = 0;
	ICALLTYPE GetCurveUV1(ICurve_DG* curve, double parameterFrom, double parameterTo, _retval_ ICurve2d_DG** curve2D) = 0;
	ICALLTYPE GetSurfaceIntersection(IUVSurface_DG* surface, _retval_ ICurveArray_DG** intersection) = 0;
	ICALLTYPE GetCurveIntersection(ICurve_DG* curve, _out_ IPointArray_DG** points, _out_ IPointArray_DG** params, _out_ ICurveArray_DG** segments, _out_ I2DPointArray_DG** segmentParams) = 0;
	ICALLTYPE GetCurveProjection(ICurve_DG* curve, _retval_ ICurve_DG** curveProjected) = 0;
	ICALLTYPE GetCurveUVProjection(ICurve_DG* curve, _retval_ ICurve2d_DG** curve2D) = 0;
	ICALLTYPE GetRatiosAt(DG2D* uv, _retval_ DG2D* ratios) = 0;
	ICALLTYPE GetParametersAtRatios(DG2D* ratios, _retval_ DG2D* uv) = 0;
	ICALLTYPE GetPointLocation(Point_DG* point, double tolerance, _retval_ PointVsSurfaceLocation_DG* location) = 0;
	ICALLTYPE GetCurveLocation(ICurve_DG* curve, double tolerance, int algorithm, _retval_ CurveVsSurfaceLocation_DG* location) = 0;
	ICALLTYPE GetSurfaceLocation(IUVSurface_DG* surface, double tolerance, int algorithm, _retval_ SurfaceVsSurfaceLocation_DG* location) = 0;
	ICALLTYPE GetUVAlignedFrame(DG2D* uv, _retval_ IFrame_DG** frame) = 0;
	IUNKNOWN_
};

[uuid("{AA99D072-95B4-407E-A80F-7B5D01E65AC0}")]
class IRectangularTrimmedSurface_DG : public IUnknown
{
public:
	ICALLTYPE GetTrimRange(VARIANT_BOOL u, _out_ double* min, _out_ double* max) = 0;
	ICALLTYPE SetTrimRange(VARIANT_BOOL u, double min, double max) = 0;
	ICALLTYPE _get_ GetTrim(_retval_ Rectangle_DG* ranges) = 0;
	ICALLTYPE _set_ SetTrim(Rectangle_DG* ranges) = 0;
	ICALLTYPE _get_ GetSurface(IUVSurface_DG** surface) = 0;
	ICALLTYPE _set_ SetSurface(IUVSurface_DG* surface) = 0;
	IUNKNOWN_
};

[uuid("{B5857A50-003C-4B0B-8062-1C3A0C312614}")]
class ISurfaceOfRevolution_DG : public IUnknown
{
public:
	ICALLTYPE Init(ICurve_DG* generatrix, Line_DG* axis) = 0;
	ICALLTYPE _get_ GetGeneratrix(ICurve_DG** generatrix) = 0;
	ICALLTYPE _set_ SetGeneratrix(ICurve_DG* generatrix) = 0;
	ICALLTYPE _get_ GetAxis(Line_DG* axis) = 0;
	ICALLTYPE _set_ SetAxis(Line_DG* axis) = 0;
	ICALLTYPE _get_ GetOrigin(Point_DG* origin) = 0;
	ICALLTYPE _set_ SetOrigin(Point_DG* origin) = 0;
	ICALLTYPE _get_ GetDirection(Vect_DG* direction) = 0;
	ICALLTYPE _set_ SetDirection(Vect_DG* direction) = 0;
	ICALLTYPE GetLocation(_retval_ IFrame_DG** frame) = 0;
	ICALLTYPE GetUIso(double angle, _retval_ ICurve_DG** curve) = 0;
	ICALLTYPE GetVIso(double v, _retval_ ICircle_DG** circle) = 0;
	ICALLTYPE GetPoint(DG2D* uv, _retval_ Point_DG* pt) = 0;
	ICALLTYPE GetNormal(DG2D* uv, _retval_ Vect_DG* normal) = 0;
	ICALLTYPE GetTangent(DG2D* uv, VARIANT_BOOL inUDirection, _retval_ Vect_DG* tangent) = 0;
	ICALLTYPE GetJet1(DG2D* uv, _out_ Point_DG* point, _out_ Vect_DG* d1u, _out_ Vect_DG* d1v) = 0;
	ICALLTYPE GetJet2(DG2D* uv, _out_ Point_DG* point, _out_ Vect_DG* d1u, _out_ Vect_DG* d1v, _out_ Vect_DG* d2u, _out_ Vect_DG* d2v, _out_ Vect_DG* d2uv) = 0;
	ICALLTYPE GetJetN(DG2D* uv, int Nu, int Nv, _retval_ Vect_DG* retV) = 0;
	ICALLTYPE Transform(IFrame_DG* transform) = 0;
	ICALLTYPE Clone(_retval_ ISurfaceOfRevolution_DG** newCopy) = 0;
	IUNKNOWN_
};

[uuid("{A8FD632F-49E1-48A9-8566-A1BE27CF2CFB}")]
class IPartialBezierProps_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetDegree(int* degree) = 0;
	ICALLTYPE _set_ SetDegree(int degree) = 0;
	ICALLTYPE GetPoleCount(_retval_ int* count) = 0;
	ICALLTYPE IsClosed(_retval_ VARIANT_BOOL* closed) = 0;
	ICALLTYPE Reverse() = 0;
	IUNKNOWN_
};

[uuid("{80988C88-2522-4EEA-93BA-3AAAC0680A3B}")]
class IBezierSurface_DG : public IUnknown
{
public:
	ICALLTYPE Init(IPointMatrix_DG* poles) = 0;
	ICALLTYPE Init1(IPointMatrix_DG* poles, IMatrix_DG* weights) = 0;
	ICALLTYPE GetAxialProps(VARIANT_BOOL u, _retval_ IPartialBezierProps_DG** iProps1D) = 0;
	ICALLTYPE GetPoleMatrixSize(_retval_ PairInt_DG* size) = 0;
	ICALLTYPE GetPole(int indexU, int indexV, _retval_ Point_DG* point) = 0;
	ICALLTYPE SetPole(int indexU, int indexV, Point_DG* point) = 0;
	ICALLTYPE SetPole1(int indexU, int indexV, Point_DG* point, double weight) = 0;
	ICALLTYPE GetPoles(_retval_ IPointMatrix_DG** poles) = 0;
	ICALLTYPE GetWeight(int indexU, int indexV, _retval_ double* retVal) = 0;
	ICALLTYPE SetWeight(int indexU, int indexV, double weight) = 0;
	ICALLTYPE GetWeights(_retval_ IMatrix_DG** weights) = 0;
	ICALLTYPE GetPoint(DG2D* uv, _retval_ Point_DG* point) = 0;
	ICALLTYPE GetNormal(DG2D* uv, _retval_ Vect_DG* normal) = 0;
	ICALLTYPE GetJet1(DG2D* uv, _out_ Point_DG* point, _out_ Vect_DG* d1u, _out_ Vect_DG* d1v) = 0;
	ICALLTYPE GetJet2(DG2D* uv, _out_ Point_DG* point, _out_ Vect_DG* d1u, _out_ Vect_DG* d1v, _out_ Vect_DG* d2u, _out_ Vect_DG* d2v, _out_ Vect_DG* d2uv) = 0;
	ICALLTYPE GetJetN(DG2D* uv, int Nu, int Nv, _retval_ Vect_DG* retV) = 0;
	ICALLTYPE GetIsoCurve(VARIANT_BOOL u, double paramAt, _retval_ ICurve_DG** curve) = 0;
	ICALLTYPE SwapUV() = 0;
	ICALLTYPE Transform(IFrame_DG* transform) = 0;
	ICALLTYPE Clone(_retval_ IBezierSurface_DG** newCopy) = 0;
	IUNKNOWN_
};

[uuid("{DBEF1811-E1C3-4C60-83E0-5D80E695C20A}")]
class IPartialSplineProps_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetDegree(_retval_ int* degree) = 0;
	ICALLTYPE _set_ SetDegree(int degree) = 0;
	ICALLTYPE GetKnotCount(_retval_ int* count) = 0;
	ICALLTYPE GetKnot(int index, _retval_ double* u) = 0;
	ICALLTYPE GetKnots(_retval_ IArrayDouble_DG** knots) = 0;
	ICALLTYPE SetKnot(int index, double knot) = 0;
	ICALLTYPE SetKnot1(int index, double knot, int multiplicity) = 0;
	ICALLTYPE SetKnots(IArrayDouble_DG* knots) = 0;
	ICALLTYPE GetMultiplicity(int indexKnot, _retval_ int* multiplicity) = 0;
	ICALLTYPE GetMultiplicities(_retval_ IArrayInt_DG** iArr) = 0;
	ICALLTYPE SetMultiplicity(int indexKnot, int multiplicity) = 0;
	ICALLTYPE SetMultiplicity1(int indexKnot0, int indexKnot1, int multiplicity) = 0;
	ICALLTYPE GetPoleCount(_retval_ int* count) = 0;
	ICALLTYPE IsClosed(_retval_ VARIANT_BOOL* closed) = 0;
	ICALLTYPE IsPeriodic(_retval_ VARIANT_BOOL* periodic) = 0;
	ICALLTYPE SetPeriodic(VARIANT_BOOL periodic) = 0;
	ICALLTYPE IsRational(_retval_ VARIANT_BOOL* rational) = 0;
	ICALLTYPE GetEndParameter(VARIANT_BOOL first, _retval_ double* u) = 0;
	ICALLTYPE InsertKnot(double u, int multiplicity, double tolerance, VARIANT_BOOL add) = 0;
	ICALLTYPE InsertKnots(IArrayDouble_DG* knots, IArrayInt_DG* multiplicities, double tolerance, VARIANT_BOOL add) = 0;
	ICALLTYPE RemoveKnot(int index, int multiplicity, double tolerance) = 0;
	ICALLTYPE Reverse() = 0;
	ICALLTYPE SetRange(double min, double max) = 0;
	ICALLTYPE SetOrigin(int indexKnot) = 0;
	ICALLTYPE GetEndKnotIndex(VARIANT_BOOL first, _retval_ int* ind) = 0;
	ICALLTYPE GetKnotSequence(_retval_ IArrayDouble_DG** knots) = 0;
	ICALLTYPE GetKnotDistributionType(_retval_ int* retValEnum) = 0;
	ICALLTYPE FindParameter(double u, double tolerance, _out_ int* i0, _out_ int* i1, VARIANT_BOOL withKnotRepetition) = 0;
	IUNKNOWN_
};

[uuid("{9A2CDB0F-6527-48F1-BC9C-5CA68B7FB1E3}")]
class IBSplineSurface_DG : public IUnknown
{
public:
	ICALLTYPE Init(IPointMatrix_DG* poles, IArrayDouble_DG* knotsU, IArrayDouble_DG* knotsV, IArrayInt_DG* multiplicitiesU, IArrayInt_DG* multiplicitiesV, int degreeU, int degreeV, VARIANT_BOOL periodicU, VARIANT_BOOL periodicV) = 0;
	ICALLTYPE Init1(IPointMatrix_DG* poles, IMatrix_DG* weights, IArrayDouble_DG* knotsU, IArrayDouble_DG* knotsV, IArrayInt_DG* multiplicitiesU, IArrayInt_DG* multiplicitiesV, int degreeU, int degreeV, VARIANT_BOOL periodicU, VARIANT_BOOL periodicV) = 0;
	ICALLTYPE GetAxialSplineProps(VARIANT_BOOL u, _retval_ IPartialSplineProps_DG** iProps1D) = 0;
	ICALLTYPE GetPoleMatrixSize(_retval_ PairInt_DG* size) = 0;
	ICALLTYPE GetPole(int indexU, int indexV, _retval_ Point_DG* point) = 0;
	ICALLTYPE SetPole(int indexU, int indexV, Point_DG* point) = 0;
	ICALLTYPE SetPole1(int indexU, int indexV, Point_DG* point, double weight) = 0;
	ICALLTYPE GetPoles(_retval_ IPointMatrix_DG** poles) = 0;
	ICALLTYPE GetWeight(int indexU, int indexV, _retval_ double* retVal) = 0;
	ICALLTYPE SetWeight(int indexU, int indexV, double weight) = 0;
	ICALLTYPE GetWeights(_retval_ IMatrix_DG** weights) = 0;
	ICALLTYPE GetPoint(DG2D* uv, _retval_ Point_DG* point) = 0;
	ICALLTYPE GetNormal(DG2D* uv, _retval_ Vect_DG* normal) = 0;
	ICALLTYPE GetJet1(DG2D* uv, _out_ Point_DG* point, _out_ Vect_DG* d1u, _out_ Vect_DG* d1v) = 0;
	ICALLTYPE GetJet2(DG2D* uv, _out_ Point_DG* point, _out_ Vect_DG* d1u, _out_ Vect_DG* d1v, _out_ Vect_DG* d2u, _out_ Vect_DG* d2v, _out_ Vect_DG* d2uv) = 0;
	ICALLTYPE GetJetN(DG2D* uv, int Nu, int Nv, _retval_ Vect_DG* retV) = 0;
	ICALLTYPE GetIsoCurve(VARIANT_BOOL u, double paramAt, _retval_ ICurve_DG** curve) = 0;
	ICALLTYPE ModifyPoint(DG2D* uv, Point_DG* point, _inout_ int* firstIndexU, _inout_ int* lastIndexU, _inout_ int* firstIndexV, _inout_ int* lastIndexV) = 0;
	ICALLTYPE SwapUV() = 0;
	IUNKNOWN_
};

[uuid("{998B321C-E52D-49FF-9D71-36C3FF3F03C0}")]
class IShapeArray_DG : public IUnknown
{
public:
	ICALLTYPE GetCount(_retval_ int* count) = 0;
	ICALLTYPE IsEmpty(_retval_ VARIANT_BOOL* result) = 0;
	ICALLTYPE GetAt(int index, _retval_ IBRepShape_DG** shape) = 0;
	ICALLTYPE SetAt(int index, IBRepShape_DG* shape) = 0;
	ICALLTYPE Add(IBRepShape_DG* shape) = 0;
	ICALLTYPE InsertAt(int indexAt, IBRepShape_DG* shape) = 0;
	ICALLTYPE Find(IBRepShape_DG* shape, _retval_ int* index) = 0;
	ICALLTYPE RemoveAt(int index) = 0;
	ICALLTYPE RemoveAll() = 0;
	ICALLTYPE RemoveShape(IBRepShape_DG* shape, _retval_ VARIANT_BOOL* success) = 0;
	IUNKNOWN_
};

[uuid("{4E73A56C-009A-4E33-BF51-3404826FA61B}")]
class IBRepShape_DG : public IUnknown
{
public:
	ICALLTYPE GetShapeType(_retval_ ShapeType_DG* type) = 0;
	ICALLTYPE GetLocation(_retval_ IFrame_DG** frame) = 0;
	ICALLTYPE SetLocation(IFrame_DG* frame) = 0;
	ICALLTYPE GetSubShapes(ShapeType_DG type, _retval_ IShapeArray_DG** shapes) = 0;
	ICALLTYPE GetAncestors(ShapeType_DG type, _retval_ IShapeArray_DG** shapes) = 0;
	ICALLTYPE IsPartner(IBRepShape_DG* other, _retval_ VARIANT_BOOL* ret) = 0;
	ICALLTYPE IsSame(IBRepShape_DG* other, _retval_ VARIANT_BOOL* ret) = 0;
	ICALLTYPE IsEqual(IBRepShape_DG* other, _retval_ VARIANT_BOOL* ret) = 0;
	ICALLTYPE GetHash(_retval_ int* hash) = 0;
	ICALLTYPE GetTolerance(_retval_ double* tolerance) = 0;
	ICALLTYPE IsValid(_retval_ VARIANT_BOOL* ret) = 0;
	ICALLTYPE RemoveSubShape(IBRepShape_DG* shape) = 0;
	ICALLTYPE GetDimension(EDim_DG* dim) = 0;
	ICALLTYPE GetColor(_retval_ Color_DG* color) = 0;
	ICALLTYPE SetColor(Color_DG* color) = 0;
	ICALLTYPE GetAppearance(VARIANT_BOOL create, IAppearance_DG** appearance) = 0;
	ICALLTYPE DeleteAppearance() = 0;
	IUNKNOWN_
};

[uuid("{7CE667BA-895D-4911-8F01-A8DC33A8C841}")]
class IBRepVertex_DG : public IUnknown
{
public:
	ICALLTYPE GetPosition(_out_ double* x, _out_ double* y, _out_ double* z) = 0;
	ICALLTYPE GetPosition1(_retval_ Point_DG* position) = 0;
	ICALLTYPE SetPosition(double x, double y, double z) = 0;
	ICALLTYPE SetPosition1(Point_DG* position) = 0;
	IUNKNOWN_
};

class IBRepFace_DG;

[uuid("{9A6861BB-BDF8-46f9-A030-914172F93606}")]
class IBRepEdge_DG : public IUnknown
{
public:
	ICALLTYPE GetCurve(_retval_ ICurve_DG** curve) = 0;
	ICALLTYPE SetCurve(ICurve_DG* curve) = 0;
	ICALLTYPE SetCurve1(ICurve_DG* curve, Point_DG* endFirst, Point_DG* endLast) = 0;
	ICALLTYPE SetCurve2(ICurve_DG* curve, double uFirst, double uLast) = 0;
	ICALLTYPE GetEndVertex(int end, _retval_ IBRepVertex_DG** vertex) = 0;
	ICALLTYPE SetEndVertex(int end, IBRepVertex_DG* vertex) = 0;
	ICALLTYPE GetPCurve(int side, _out_ double* outMinParam, _out_ double* outMaxParam, _retval_ ICurve2d_DG** curveUV) = 0;
	ICALLTYPE SetPCurve(int side, ICurve2d_DG* curveUV) = 0;
	ICALLTYPE SetPCurve1(int side, ICurve2d_DG* curveUV, DG2D* endFirst, DG2D* endLast) = 0;
	ICALLTYPE GetRange(_out_ double* outMinParam, _out_ double* outMaxParam) = 0;
	ICALLTYPE SetRange(double minParam, double maxParam, _retval_ VARIANT_BOOL* success) = 0;
	ICALLTYPE GetPoint(double u, _retval_ Point_DG* point) = 0;
	ICALLTYPE GetPointRatio(double ratio, _retval_ Point_DG* point) = 0;
	ICALLTYPE FindEnd(IBRepVertex_DG* vertex, _retval_ int* end) = 0;
	ICALLTYPE GetOtherEnd(IBRepVertex_DG* vertex, _retval_ IBRepVertex_DG** vertexOther) = 0;
	ICALLTYPE GetFace(int side, _retval_ IBRepFace_DG** face) = 0;
	ICALLTYPE GetOtherFace(IBRepFace_DG* face, _retval_ IBRepFace_DG** faceOther) = 0;
	ICALLTYPE FindFace(IBRepFace_DG* face, _retval_ int* side) = 0;
	ICALLTYPE FindSurface(IUVSurface_DG* surface, _retval_ int* side) = 0;
	IUNKNOWN_
};

[uuid("{583C0D34-55AB-4383-AB41-76BFD0E79A1F}")]
class IBRepWire_DG : public IUnknown
{
public:
	ICALLTYPE GetVertexCount(_retval_ int* count) = 0;
	ICALLTYPE GetVertex(int index, _retval_ IBRepVertex_DG** vertex) = 0;
	ICALLTYPE GetEdgeCount(_retval_ int* count) = 0;
	ICALLTYPE GetEdge(int index, _retval_ IBRepEdge_DG** edge) = 0;
	ICALLTYPE AddNewEdge(VARIANT_BOOL tail, _retval_ IBRepEdge_DG** edge) = 0;
	ICALLTYPE AddEdge(IBRepEdge_DG* edge, _retval_ VARIANT_BOOL* success) = 0;
	ICALLTYPE AddVertex(IBRepVertex_DG* vertex, _retval_ IBRepEdge_DG** edge) = 0;
	ICALLTYPE IsClosed(_retval_ VARIANT_BOOL* closed) = 0;
	ICALLTYPE CloseWire(_retval_ IBRepEdge_DG** edge) = 0;
	ICALLTYPE InitFromPoints(IPointArray_DG* points, VARIANT_BOOL closed) = 0;
	ICALLTYPE IsEdgeReversed(int index, _retval_ ThreeState_DG* reversed) = 0;
	ICALLTYPE FindVertex(IBRepVertex_DG* vertex, _retval_ int* idx) = 0;
	ICALLTYPE FindEdge(IBRepEdge_DG* edge, _retval_ int* idx) = 0;
	IUNKNOWN_
};

[uuid("{1CCDEE6A-9373-4289-8968-4DA45290924C}")]
class IBRepFace_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetSurface(_retval_ IUVSurface_DG** surface) = 0;
	ICALLTYPE _set_ SetSurface(IUVSurface_DG* surface) = 0;
	ICALLTYPE IsSurfaceReversed(_retval_ VARIANT_BOOL* reversed) = 0;
	ICALLTYPE SwapExternalSide() = 0;
	ICALLTYPE GetWireCount(_retval_ int* count) = 0;
	ICALLTYPE GetWire(int index, _retval_ IBRepWire_DG** wire) = 0;
	ICALLTYPE AddWire(IBRepWire_DG* wire) = 0;
	ICALLTYPE AddWire1(I2DPointArray_DG* uvLoop, _retval_ IBRepWire_DG** wire) = 0;
	ICALLTYPE AddNewWire(_retval_ IBRepWire_DG** wire) = 0;
	ICALLTYPE RemoveWire(IBRepWire_DG* wire) = 0;
	ICALLTYPE GetWires(_retval_ IShapeArray_DG** wires) = 0;
	ICALLTYPE GetEdges(_retval_ IShapeArray_DG** edges) = 0;
	ICALLTYPE GetVertices(_retval_ IShapeArray_DG** vertices) = 0;
	ICALLTYPE IsTrimmed(_retval_ VARIANT_BOOL* trimmed) = 0;
	ICALLTYPE GetParameterRange(VARIANT_BOOL u, _out_ double* min, _out_ double* max) = 0;
	ICALLTYPE GetRanges(_retval_ Rectangle_DG* ranges) = 0;
	ICALLTYPE GetPoint(DG2D* uv, _retval_ Point_DG* pt) = 0;
	ICALLTYPE GetNormal(DG2D* uv, _retval_ Vect_DG* normal) = 0;
	ICALLTYPE GetRatiosAt(DG2D* uv, _retval_ DG2D* ratios) = 0;
	ICALLTYPE GetParametersAtRatios(DG2D* ratios, _retval_ DG2D* uv) = 0;
	ICALLTYPE GetPointAtRatios(DG2D* ratios, _retval_ Point_DG* pt) = 0;
	ICALLTYPE GetNormalAtRatios(DG2D* ratios, _retval_ Vect_DG* normal) = 0;
	ICALLTYPE GetVertexUV(IBRepVertex_DG* vertex, _retval_ DG2D* returnUV) = 0;
	ICALLTYPE GetEdgeUV(IBRepEdge_DG* edge, double ratioAlongEdge, _retval_ DG2D* returnUV) = 0;
	ICALLTYPE FindWire(IBRepWire_DG* wire, _retval_ int* idx) = 0;
	ICALLTYPE FindEdge(IBRepEdge_DG* edge, _out_ int* idxEdgeInWire, _retval_ int* idxWire) = 0;
	ICALLTYPE FindVertex(IBRepVertex_DG* vertex, _out_ int* idxVertexInWire, _retval_ int* idxWire) = 0;
	IUNKNOWN_
};

[uuid("{1560A524-FDA1-49dd-AFCB-78BC454B98F7}")]
class IBRepShell_DG : public IUnknown
{
public:
	ICALLTYPE CreateVertex(double x, double y, double z, _retval_ IBRepVertex_DG** vertex) = 0;
	ICALLTYPE CreateEdge(IBRepVertex_DG* vertex0, IBRepVertex_DG* vertex1, _retval_ IBRepEdge_DG** edge) = 0;
	ICALLTYPE GetFaceCount(_retval_ int* count) = 0;
	ICALLTYPE GetFace(int index, _retval_ IBRepFace_DG** face) = 0;
	ICALLTYPE AddFace(IBRepFace_DG* face) = 0;
	ICALLTYPE AddNewFace(_retval_ IBRepFace_DG** face) = 0;
	ICALLTYPE RemoveFace(IBRepFace_DG* face) = 0;
	ICALLTYPE GetFaces(_retval_ IShapeArray_DG** faces) = 0;
	ICALLTYPE IsFaceReversed(int indexFace, _retval_ VARIANT_BOOL* reversed) = 0;
	ICALLTYPE SwapExternalSide() = 0;
	ICALLTYPE GetEdges(_retval_ IShapeArray_DG** edges) = 0;
	ICALLTYPE GetVertices(_retval_ IShapeArray_DG** vertices) = 0;
	IUNKNOWN_
};

[uuid("{F89D2950-53A1-4a49-BA96-753E7D48FE77}")]
class IBRepSolid_DG : public IUnknown
{
public:
	ICALLTYPE GetOuterShell(VARIANT_BOOL create, _retval_ IBRepShell_DG** shell) = 0;
	ICALLTYPE SetOuterShell(IBRepShell_DG* shell) = 0;
	ICALLTYPE GetInnerShellCount(_retval_ int* count) = 0;
	ICALLTYPE GetInnerShell(int index, _retval_ IBRepShell_DG** shell) = 0;
	ICALLTYPE AddInnerShell(IBRepShell_DG* shell) = 0;
	ICALLTYPE AddNewInnerShell(_retval_ IBRepShell_DG** shell) = 0;
	ICALLTYPE RemoveShell(IBRepShell_DG* shell) = 0;
	IUNKNOWN_
};

[uuid("{533070DB-C4CE-46E5-ACAD-4B7AC91AB43F}")]
class IBRepCompositeSolid_DG : public IUnknown
{
public:
	ICALLTYPE GetSolidCount(_retval_ int* count) = 0;
	ICALLTYPE GetSolid(int index, _retval_ IBRepSolid_DG** solid) = 0;
	ICALLTYPE AddSolid(IBRepSolid_DG* solid) = 0;
	ICALLTYPE AddNewSolid(_retval_ IBRepSolid_DG** solid) = 0;
	ICALLTYPE RemoveSolid(IBRepSolid_DG* solid) = 0;
	IUNKNOWN_
};

[uuid("{94AF27F8-A6B7-4C46-8836-D46E49E65D5E}")]
class IBRepCompound_DG : public IUnknown
{
public:
	ICALLTYPE GetShapeCount(_retval_ int* count) = 0;
	ICALLTYPE GetShape(int index, _retval_ IBRepShape_DG** shape) = 0;
	ICALLTYPE AddShape(IBRepShape_DG* shape) = 0;
	ICALLTYPE AddNewShape(ShapeType_DG type, _retval_ IBRepShape_DG** shape) = 0;
	ICALLTYPE RemoveShape(IBRepShape_DG* shape) = 0;
	IUNKNOWN_
};

[uuid("{0F2EFBD8-E0A3-4809-BE19-3580DE7D5DF7}")]
class IBRepBuilder_DG : public IUnknown
{
public:
	ICALLTYPE CreateVertex(_retval_ IBRepVertex_DG** vertex) = 0;
	ICALLTYPE CreateVertex1(Point_DG* position, _retval_ IBRepVertex_DG** vertex) = 0;
	ICALLTYPE CreateEdge(_retval_ IBRepEdge_DG** edge) = 0;
	ICALLTYPE CreateEdge1(Point_DG* end0, Point_DG* end1, _retval_ IBRepEdge_DG** edge) = 0;
	ICALLTYPE CreateEdge2(ILine_DG* line, _retval_ IBRepEdge_DG** edge) = 0;
	ICALLTYPE CreateEdge3(ILine_DG* line, IBRepVertex_DG* vertex0, IBRepVertex_DG* vertex1, _retval_ IBRepEdge_DG** edge) = 0;
	ICALLTYPE CreateEdge4(ICircle_DG* circle, _retval_ IBRepEdge_DG** edge) = 0;
	ICALLTYPE CreateEdge5(ICircle_DG* circle, IBRepVertex_DG* vertex0, IBRepVertex_DG* vertex1, _retval_ IBRepEdge_DG** edge) = 0;
	ICALLTYPE CreateEdge6(ICurve_DG* curve, _retval_ IBRepEdge_DG** edge) = 0;
	ICALLTYPE CreateEdge7(ICurve_DG* curve, IBRepVertex_DG* vertex0, IBRepVertex_DG* vertex1, _retval_ IBRepEdge_DG** edge) = 0;
	ICALLTYPE CreateEdge8(ICurve2d_DG* curveUV, IUVSurface_DG* surface, _retval_ IBRepEdge_DG** edge) = 0;
	ICALLTYPE CreateEdge9(ICurve2d_DG* curveUV, IUVSurface_DG* surface, Range_DG* rangeCurveUVParam, _retval_ IBRepEdge_DG** edge) = 0;
	ICALLTYPE CreateEdge10(ICurve2d_DG* curveUV, IUVSurface_DG* surface, Point_DG* end0, Point_DG* end1, _retval_ IBRepEdge_DG** edge) = 0;
	ICALLTYPE CreateEdge11(ICurve2d_DG* curveUV, IUVSurface_DG* surface, IBRepVertex_DG* vertex0, IBRepVertex_DG* vertex1, _retval_ IBRepEdge_DG** edge) = 0;
	ICALLTYPE CreateEdge12(ICurve2d_DG* curveUV, IUVSurface_DG* surface, Point_DG* end0, Point_DG* end1, Range_DG* rangeCurveUVParam, _retval_ IBRepEdge_DG** edge) = 0;
	ICALLTYPE CreateEdge13(ICurve2d_DG* curveUV, IUVSurface_DG* surface, IBRepVertex_DG* vertex0, IBRepVertex_DG* vertex1, Range_DG* rangeCurveUVParam, _retval_ IBRepEdge_DG** edge) = 0;
	ICALLTYPE CreateWire(_retval_ IBRepWire_DG** wire) = 0;
	ICALLTYPE CreateWire1(Point_DG* end0, Point_DG* end1, _retval_ IBRepWire_DG** wire) = 0;
	ICALLTYPE CreateWire2(Point_DG* point0, Point_DG* point1, Point_DG* point2, VARIANT_BOOL closed, _retval_ IBRepWire_DG** wire) = 0;
	ICALLTYPE CreateWire3(IPointArray_DG* points, VARIANT_BOOL closed, _retval_ IBRepWire_DG** wire) = 0;
	ICALLTYPE CreateWire4(IBRepVertex_DG* vertex0, IBRepVertex_DG* vertex1, _retval_ IBRepWire_DG** wire) = 0;
	ICALLTYPE CreateWire5(IBRepVertex_DG* vertex0, IBRepVertex_DG* vertex1, IBRepVertex_DG* vertex2, VARIANT_BOOL closed, _retval_ IBRepWire_DG** wire) = 0;
	ICALLTYPE CreateWire6(IShapeArray_DG* vertices, VARIANT_BOOL closed, _retval_ IBRepWire_DG** wire) = 0;
	ICALLTYPE CreateFace(_retval_ IBRepFace_DG** face) = 0;
	ICALLTYPE CreateFace1(IPlane_DG* plane, _retval_ IBRepFace_DG** face) = 0;
	ICALLTYPE CreateFace2(ICylinder_DG* cylinder, _retval_ IBRepFace_DG** face) = 0;
	ICALLTYPE CreateFace3(ICone_DG* cone, _retval_ IBRepFace_DG** face) = 0;
	ICALLTYPE CreateFace4(ISphere_DG* sphere, _retval_ IBRepFace_DG** face) = 0;
	ICALLTYPE CreateFace5(ITorus_DG* torus, _retval_ IBRepFace_DG** face) = 0;
	ICALLTYPE CreateFace6(IUVSurface_DG* surface, _retval_ IBRepFace_DG** face) = 0;
	ICALLTYPE CreateFace7(IBRepWire_DG* wire, _retval_ IBRepFace_DG** face) = 0;
	ICALLTYPE CreateFace8(ISphere_DG* sphere, IBRepWire_DG* wire, VARIANT_BOOL inside, _retval_ IBRepFace_DG** face) = 0;
	ICALLTYPE CreateFace9(ITorus_DG* torus, IBRepWire_DG* wire, VARIANT_BOOL inside, _retval_ IBRepFace_DG** face) = 0;
	ICALLTYPE CreateShell(_retval_ IBRepShell_DG** shell) = 0;
	ICALLTYPE CreateSolid(_retval_ IBRepSolid_DG** solid) = 0;
	ICALLTYPE CreateCompositeSolid(_retval_ IBRepCompositeSolid_DG** compSolid) = 0;
	ICALLTYPE CreateCompound(_retval_ IBRepCompound_DG** compound) = 0;
	ICALLTYPE CreateShape(ShapeType_DG type, _retval_ IBRepShape_DG** shape) = 0;
	ICALLTYPE Add(IBRepShape_DG* shapeTo, IBRepShape_DG* shapeBeingAdded) = 0;
	ICALLTYPE Remove(IBRepShape_DG* shapeFrom, IBRepShape_DG* shapeToRemove) = 0;
	ICALLTYPE ModifyVertex(IBRepVertex_DG* vertex, Point_DG* position) = 0;
	ICALLTYPE ModifyVertex1(IBRepVertex_DG* vertex, double position, IBRepEdge_DG* edge) = 0;
	ICALLTYPE ModifyVertex2(IBRepVertex_DG* vertex, double position, IBRepEdge_DG* edge, IBRepFace_DG* face) = 0;
	ICALLTYPE ModifyVertex3(IBRepVertex_DG* vertex, DG2D* uv, IBRepFace_DG* face) = 0;
	ICALLTYPE ModifyEdge(IBRepEdge_DG* edge, ICurve2d_DG* curve, IBRepFace_DG* face) = 0;
	ICALLTYPE ModifyEdge1(IBRepEdge_DG* edge, ICurve2d_DG* curve1, ICurve2d_DG* curve2, IBRepFace_DG* face) = 0;
	ICALLTYPE ModifyFace(IBRepFace_DG* face, IUVSurface_DG* surface, VARIANT_BOOL naturalBounds) = 0;
	ICALLTYPE ModifyFace1(IBRepFace_DG* face, IUVSurface_DG* surface, Range_DG* rangeU, Range_DG* rangeV) = 0;
	IUNKNOWN_
};

[uuid("{30C409D5-F69E-47D7-B472-033983B1CFA0}")]
class IBRepBuilderEx_DG : public IUnknown
{
public:
	ICALLTYPE Extrude(IBRepShape_DG* shape, Vect_DG* direction, _retval_ IBRepShape_DG** shapeExtruded) = 0;
	ICALLTYPE Evolve(IBRepWire_DG* base, IBRepWire_DG* profile, JoinType_DG join, VARIANT_BOOL global, VARIANT_BOOL solid, _retval_ IBRepShape_DG** result) = 0;
	ICALLTYPE EvolveFace(IBRepFace_DG* base, IBRepWire_DG* profile, JoinType_DG join, VARIANT_BOOL global, VARIANT_BOOL solid, _retval_ IBRepShape_DG** result) = 0;
	ICALLTYPE CreatePipe(IBRepWire_DG* spine, IBRepShape_DG* profile, _retval_ IBRepShape_DG** pipe) = 0;
	IUNKNOWN_
};

[uuid("{36B3C24F-16D3-492E-A3CF-1648DEB50254}")]
class IWireArrayToSurfaceBuilder_DG : public IUnknown
{
public:
	ICALLTYPE Init(VARIANT_BOOL ruled, double precision) = 0;
	ICALLTYPE AddWire(IBRepWire_DG* wire) = 0;
	ICALLTYPE Build(VARIANT_BOOL solid, _retval_ IBRepShape_DG** shape) = 0;
	IUNKNOWN_
};

[uuid("{C3FA01E9-276E-47F3-BC8F-82356982087A}")]
class IBRepDraftAngle_DG : public IUnknown
{
public:
	ICALLTYPE Init(IBRepShape_DG* shape) = 0;
	ICALLTYPE Add(IBRepFace_DG* face, Vect_DG* direction, double angle, IPlane_DG* neutralPlane, _retval_ VARIANT_BOOL* success) = 0;
	ICALLTYPE Build(_retval_ IBRepShape_DG** shapeResult) = 0;
	IUNKNOWN_
};

[uuid("{3AAE97DB-D55B-4210-939E-C7649E8D277D}")]
class IBRepFeaturePrism_DG : public IUnknown
{
public:
	ICALLTYPE Init(IBRepGeometry_DG* workpiece, IBRepShape_DG* shapeBase, IBRepFace_DG* sketchFace, Vect_DG* offset, VARIANT_BOOL fuse) = 0;
	ICALLTYPE Add(IBRepEdge_DG* edge, IBRepFace_DG* faceAlong) = 0;
	ICALLTYPE Perform(double length) = 0;
	ICALLTYPE Perform1(IBRepShape_DG* shapeUntil) = 0;
	ICALLTYPE Perform2(IBRepShape_DG* shapeFrom, IBRepShape_DG* shapeUntil) = 0;
	ICALLTYPE PerformUntilEnd() = 0;
	ICALLTYPE PerformFromEnd(IBRepShape_DG* faceUntil) = 0;
	ICALLTYPE PerformThruAll() = 0;
	ICALLTYPE PerformUntilHeight(IBRepShape_DG* shapeUntil, double length) = 0;
	IUNKNOWN_
};

[uuid("{EB8AF875-00C0-4A46-A430-0D5A5975AEBC}")]
class IBRepFillet_DG : public IUnknown
{
public:
	ICALLTYPE BuildAll(IBRepShape_DG* shape, double radius, int Rational0_Angular1_Polinomial2, _retval_ IBRepShape_DG** shapeResult) = 0;
	ICALLTYPE Init(IBRepShape_DG* shape, int Rational0_Angular1_Polinomial2) = 0;
	ICALLTYPE SetContinuity(Continuity_DG internalContinuity, double toleranceAngular) = 0;
	ICALLTYPE Add(double radius, IBRepEdge_DG* edge) = 0;
	ICALLTYPE Add1(double radius0, double radius1, IBRepEdge_DG* edge) = 0;
	ICALLTYPE Add2(I2DPointArray_DG* UandR, IBRepEdge_DG* edge) = 0;
	ICALLTYPE Build(_retval_ IBRepShape_DG** shapeResult) = 0;
	IUNKNOWN_
};

[uuid("{EA645687-43F6-416E-BDD4-EFFD3A03FBFF}")]
class IBRepChamfer_DG : public IUnknown
{
public:
	ICALLTYPE BuildAll(IBRepShape_DG* shape, double distance, _retval_ IBRepShape_DG** shapeResult) = 0;
	ICALLTYPE Init(IBRepShape_DG* shape) = 0;
	ICALLTYPE Add(double distance, IBRepEdge_DG* edge) = 0;
	ICALLTYPE Add1(double distanceLeft, double distanceRight, IBRepEdge_DG* edge) = 0;
	ICALLTYPE Add2(double distance, double angle, IBRepEdge_DG* edge) = 0;
	ICALLTYPE Build(_retval_ IBRepShape_DG** shapeResult) = 0;
	IUNKNOWN_
};

[uuid("{BE7304A1-BB23-4395-A52B-DFB8C5C51824}")]
class ILineStyle_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetColor(_retval_ Color_DG* color) = 0;
	ICALLTYPE _set_ SetColor(Color_DG* color) = 0;
	ICALLTYPE _get_ GetLineWidth(_retval_ float* width) = 0;
	ICALLTYPE _set_ SetLineWidth(float width) = 0;
	ICALLTYPE _get_ GetStippleFlag(_retval_ VARIANT_BOOL* stipple) = 0;
	ICALLTYPE _set_ SetStippleFlag(VARIANT_BOOL stipple) = 0;
	ICALLTYPE _get_ GetStipplePattern(_retval_ int* pattern) = 0;
	ICALLTYPE _set_ SetStipplePattern(int pattern) = 0;
	ICALLTYPE _get_ GetStippleFactor(_retval_ int* factor) = 0;
	ICALLTYPE _set_ SetStippleFactor(int factor) = 0;
	ICALLTYPE _get_ GetShowPoints(_retval_ VARIANT_BOOL* show) = 0;
	ICALLTYPE _set_ SetShowPoints(VARIANT_BOOL show) = 0;
	IUNKNOWN_
};

[uuid("{557E97B7-EDC0-4D01-A947-9977A9C2487A}")]
class IMaterial_DG : public IUnknown
{
public:
	ICALLTYPE GetColor(LightComponent_DG component, _out_ float* red, _out_ float* green, _out_ float* blue) = 0;
	ICALLTYPE SetColor(LightComponent_DG component, float red, float green, float blue) = 0;
	ICALLTYPE GetAlpha(LightComponent_DG component, _retval_ float* pfAlpha) = 0;
	ICALLTYPE SetAlpha(LightComponent_DG component, float fAlpha) = 0;
	ICALLTYPE GetShininess(_retval_ float* pfShininess) = 0;
	ICALLTYPE SetShininess(float fShininess) = 0;
	ICALLTYPE IsLightingEnabled(_retval_ VARIANT_BOOL* enabled) = 0;
	ICALLTYPE SetLightingEnabled(VARIANT_BOOL enabled) = 0;
	ICALLTYPE _get_ GetUseForWire(_retval_ VARIANT_BOOL* enabled) = 0;
	ICALLTYPE _set_ SetUseForWire(VARIANT_BOOL enabled) = 0;
	ICALLTYPE GetWireFrameColor(_out_ float* red, _out_ float* green, _out_ float* blue) = 0;
	ICALLTYPE SetWireFrameColor(float red, float green, float blue) = 0;
	ICALLTYPE _get_ GetUseGlobalWireColor(_retval_ VARIANT_BOOL* bUse) = 0;
	ICALLTYPE _set_ SetUseGlobalWireColor(VARIANT_BOOL bUse) = 0;
	IUNKNOWN_
};

[uuid("{D6C48BB4-A70C-45DF-AB6C-70A1E48F5A03}")]
class IGeometry_DG : public IUnknown
{
public:
	ICALLTYPE GetGeometryType(_retval_ BSTR* type) = 0;
	ICALLTYPE GetBoundingBox(_retval_ Box_DG* boxDimensions) = 0;
	ICALLTYPE IsEmpty(_retval_ VARIANT_BOOL* empty) = 0;
	ICALLTYPE Clear() = 0;
	ICALLTYPE Copy(IGeometry_DG* geometry) = 0;
	ICALLTYPE Clone(_retval_ IGeometry_DG** geometry) = 0;
	ICALLTYPE SetModified() = 0;
	ICALLTYPE GetDimension(_retval_ EDim_DG* dim) = 0;
	IUNKNOWN_
};

[uuid("{C2F72036-D71F-45C2-9F3D-2259F3032328}")]
class IEntityArray_DG : public IUnknown
{
public:
	ICALLTYPE GetCount(_retval_ int* count) = 0;
	ICALLTYPE IsEmpty(_retval_ VARIANT_BOOL* result) = 0;
	ICALLTYPE GetAt(int index, _retval_ IEntity_DG** entity) = 0;
	ICALLTYPE SetAt(int index, IEntity_DG* entity) = 0;
	ICALLTYPE Add(IEntity_DG* entity) = 0;
	ICALLTYPE AddNew(_retval_ IEntity_DG** entity) = 0;
	ICALLTYPE InsertAt(int indexAt, IEntity_DG* entity) = 0;
	ICALLTYPE Find(IEntity_DG* entity, _retval_ int* index) = 0;
	ICALLTYPE GetFlatDescendantArray(VARIANT_BOOL includeThis, _retval_ IEntityArray_DG** descendants) = 0;
	ICALLTYPE ListDescendants(IDictionary_DG* query, _retval_ IEntityArray_DG** descendants) = 0;
	ICALLTYPE RemoveAt(int index) = 0;
	ICALLTYPE Clear() = 0;
	ICALLTYPE RemoveAll(IDictionary_DG* filter) = 0;
	ICALLTYPE RemoveEntity(IEntity_DG* entity, VARIANT_BOOL searchDescendants, _retval_ VARIANT_BOOL* success) = 0;
	ICALLTYPE RemoveEntities(IEntityArray_DG* entities) = 0;
	ICALLTYPE Append(IEntityArray_DG* entities) = 0;
	IUNKNOWN_
};

[uuid("{9D12AAAE-48C2-454d-9B05-DD987D68D87D}")]
class IEntity_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetName(_retval_ BSTR* name) = 0;
	ICALLTYPE _set_ SetName(char* name) = 0;
	ICALLTYPE _get_ GetGeometryType(_retval_ BSTR* type) = 0;
	ICALLTYPE _set_ SetGeometryType(char* type, _retval_ IGeometry_DG** geometry) = 0;
	ICALLTYPE GetGeometry(_retval_ IGeometry_DG** geometry) = 0;
	ICALLTYPE AttachGeometry(IGeometry_DG* geometry) = 0;
	ICALLTYPE GetLocation(_retval_ IFrame_DG** frame) = 0;
	ICALLTYPE GetLocationDetached(_retval_ IFrame_DG** frame) = 0;
	ICALLTYPE GetAppearance(_retval_ IAppearance_DG** appearance) = 0;
	ICALLTYPE SetColor(float red, float green, float blue) = 0;
	ICALLTYPE _get_ IsVisible(_retval_ VARIANT_BOOL* visible) = 0;
	ICALLTYPE _set_ SetVisible(VARIANT_BOOL visible) = 0;
	ICALLTYPE SetVisible1(VARIANT_BOOL visible, VARIANT_BOOL includeDescendents) = 0;
	ICALLTYPE _get_ IsTransient(_retval_ VARIANT_BOOL* transient) = 0;
	ICALLTYPE _set_ SetTransient(VARIANT_BOOL transient) = 0;
	ICALLTYPE GetChildCount(_retval_ int* count) = 0;
	ICALLTYPE GetChildAt(int index, _retval_ IEntity_DG** entity) = 0;
	ICALLTYPE GetEntity(char* path, _retval_ IEntity_DG** entity) = 0;
	ICALLTYPE GetLastChild(_retval_ IEntity_DG** entity) = 0;
	ICALLTYPE AddChild(IEntity_DG* entity) = 0;
	ICALLTYPE Add(IEntityArray_DG* entities, int insertAtOrNegative) = 0;
	ICALLTYPE AddNewChild(_retval_ IEntity_DG** entity) = 0;
	ICALLTYPE AddNewChild1(char* type, _retval_ IEntity_DG** entity) = 0;
	ICALLTYPE AddChildBRepShape(IBRepShape_DG* shape, _retval_ IEntity_DG** entity) = 0;
	ICALLTYPE AddNewChildBRepShape(ShapeType_DG type, _retval_ IEntity_DG** entity) = 0;
	ICALLTYPE AddNewChildBRepSolid(_retval_ IEntity_DG** entity) = 0;
	ICALLTYPE GetChildArray(VARIANT_BOOL includeDescendents, _retval_ IEntityArray_DG** entities) = 0;
	ICALLTYPE GetEntities(char* path, VARIANT_BOOL includeDescendents, _retval_ IEntityArray_DG** entities) = 0;
	ICALLTYPE GetEntityPath(IEntity_DG* entity, _retval_ BSTR* path) = 0;
	ICALLTYPE RemoveAt(int index) = 0;
	ICALLTYPE RemoveEntity(IEntity_DG* entity, _retval_ VARIANT_BOOL* success) = 0;
	ICALLTYPE RemoveEntities(IEntityArray_DG* entities) = 0;
	ICALLTYPE RemoveAll(VARIANT_BOOL includingDescendantsFromParents) = 0;
	ICALLTYPE Find(IEntity_DG* entity, _retval_ int* index) = 0;
	ICALLTYPE BuildChildToParentMap(_retval_ IMapUnkn_DG** map) = 0;
	ICALLTYPE GetBoundingBox(VARIANT_BOOL includeDescendants, _retval_ Box_DG* boxDimensions) = 0;
	ICALLTYPE SaveAs(char* filePath, VARIANT_BOOL includeChildren, _retval_ VARIANT_BOOL* success) = 0;
	ICALLTYPE Copy(IEntity_DG* entity) = 0;
	ICALLTYPE Clone(_retval_ IEntity_DG** entity) = 0;
	ICALLTYPE GetExtendedProperties(_retval_ IDictionary_DG** properties) = 0;
	ICALLTYPE SetGeometryTypeEx(char* type, IDictionary_DG* context, _retval_ IGeometry_DG** geometry) = 0;
	IUNKNOWN_
};

[uuid("{9F53224C-1A78-4591-A502-B68B4FD7FB74}")]
class IModel_DG : public IUnknown
{
public:
	ICALLTYPE GetEntityCount(_retval_ int* count) = 0;
	ICALLTYPE GetEntityAt(int index, _retval_ IEntity_DG** entity) = 0;
	ICALLTYPE GetEntity(char* path, _retval_ IEntity_DG** entity) = 0;
	ICALLTYPE GetLastEntity(_retval_ IEntity_DG** entity) = 0;
	ICALLTYPE AddEntity(IEntity_DG* entity) = 0;
	ICALLTYPE InsertEntity(IEntity_DG* entity, int indexAt) = 0;
	ICALLTYPE Add(IEntityArray_DG* entities, int insertAtOrNegative) = 0;
	ICALLTYPE AddNewEntity(_retval_ IEntity_DG** entity) = 0;
	ICALLTYPE AddNewEntity1(char* type, _retval_ IEntity_DG** entity) = 0;
	ICALLTYPE AddBRepShape(IBRepShape_DG* shape, _retval_ IEntity_DG** entity) = 0;
	ICALLTYPE AddNewBRepShape(ShapeType_DG type, _retval_ IEntity_DG** entity) = 0;
	ICALLTYPE AddNewBRepSolid(_retval_ IEntity_DG** entity) = 0;
	ICALLTYPE GetEntityArray(VARIANT_BOOL includeDescendents, _retval_ IEntityArray_DG** entities) = 0;
	ICALLTYPE GetEntities(char* path, VARIANT_BOOL includeDescendents, _retval_ IEntityArray_DG** entities) = 0;
	ICALLTYPE GetEntityPath(IEntity_DG* entity, _retval_ BSTR* path) = 0;
	ICALLTYPE RemoveAt(int index) = 0;
	ICALLTYPE RemoveEntity(IEntity_DG* entity, _retval_ VARIANT_BOOL* success) = 0;
	ICALLTYPE RemoveEntities(IEntityArray_DG* entities) = 0;
	ICALLTYPE RemoveEntities1(char* geometryType, VARIANT_BOOL topLevelOnly, _retval_ int* countRemoved) = 0;
	ICALLTYPE RemoveAll(VARIANT_BOOL includingDescendantsFromParents) = 0;
	ICALLTYPE Find(IEntity_DG* entity, _retval_ int* index) = 0;
	ICALLTYPE Find1(IDictionary_DG* query, _retval_ IEntityArray_DG** entities) = 0;
	ICALLTYPE FindEntity(IDictionary_DG* query, _retval_ BSTR* path) = 0;
	ICALLTYPE BuildChildToParentMap(_retval_ IMapUnkn_DG** map) = 0;
	ICALLTYPE GetBoundingBox(_retval_ Box_DG* boxDimensions) = 0;
	ICALLTYPE Load(char* filePath, _retval_ VARIANT_BOOL* success) = 0;
	ICALLTYPE LoadEx(char* filePath, IDictionary_DG* options, _retval_ VARIANT_BOOL* success) = 0;
	ICALLTYPE LoadFromMemory(IBlob_DG* data, CADFormat_DG format, _retval_ VARIANT_BOOL* success) = 0;
	ICALLTYPE LoadFromMemory1(SAFEARRAY* data, CADFormat_DG format, _retval_ VARIANT_BOOL* success) = 0;
	ICALLTYPE Save(char* filePath, _retval_ VARIANT_BOOL* success) = 0;
	ICALLTYPE SaveEx(char* filePath, IDictionary_DG* options, _retval_ VARIANT_BOOL* success) = 0;
	ICALLTYPE SaveToMemory(CADFormat_DG format, _retval_ IBlob_DG** data) = 0;
	ICALLTYPE SaveToMemory1(CADFormat_DG format, _retval_ SAFEARRAY** data) = 0;
	ICALLTYPE DetectFormat(char* filePath, _retval_ CADFormat_DG* format) = 0;
	ICALLTYPE _get_ IsPersistModified(VARIANT_BOOL* modified) = 0;
	ICALLTYPE _set_ SetPersistModified(VARIANT_BOOL modified) = 0;
	ICALLTYPE _get_ GetName(_retval_ BSTR* name) = 0;
	ICALLTYPE _set_ SetName(char* name) = 0;
	ICALLTYPE _get_ GetDescription(_retval_ BSTR* description) = 0;
	ICALLTYPE _set_ SetDescription(char* description) = 0;
	ICALLTYPE Copy(IModel_DG* model) = 0;
	ICALLTYPE Clone(_retval_ IModel_DG** model) = 0;
	ICALLTYPE UpdateDeep() = 0;
	IUNKNOWN_
};

[uuid("{AF3E47D5-D102-4A0C-9B9C-53B5A23DD333}")]
class IBooleanEntity_DG : public IUnknown
{
public:
	ICALLTYPE Subtract(IEntity_DG* entity) = 0;
	ICALLTYPE Unite(IEntity_DG* entity) = 0;
	ICALLTYPE Intersect(IEntity_DG* entity) = 0;
	ICALLTYPE SurfaceIntersection(IEntity_DG* entity, _retval_ IEntity_DG** intersectionWires) = 0;
	IUNKNOWN_
};

[uuid("{A92574D5-B146-48D7-830E-044DB6CDC8D1}")]
class ISurfacePoint_DG : public IUnknown
{
public:
	ICALLTYPE GetLocation(_retval_ Point_DG* point) = 0;
	ICALLTYPE GetEntity(_retval_ IEntity_DG** entity) = 0;
	ICALLTYPE GetElement(_retval_ IUnknown** element) = 0;
	ICALLTYPE GetElementDimension(_retval_ EDim_DG* dim) = 0;
	ICALLTYPE GetElementType(_retval_ BSTR* type) = 0;
	ICALLTYPE GetElementType1(EDim_DG dim, _retval_ BSTR* type) = 0;
	ICALLTYPE GetParentElement(EDim_DG dim, _retval_ IUnknown** element) = 0;
	ICALLTYPE GetParentElementCount(EDim_DG dim, _retval_ int* count) = 0;
	ICALLTYPE GetNormalCount(_retval_ int* count) = 0;
	ICALLTYPE GetNormal(int i, _retval_ Vect_DG* normal) = 0;
	ICALLTYPE GetParameter(_out_ DG2D* uv, _retval_ EDim_DG* dim) = 0;
	IUNKNOWN_
};

[uuid("{35ABFF8E-8994-427D-B480-C08CAB5117AF}")]
class ISurfacePointArray_DG : public IUnknown
{
public:
	ICALLTYPE GetCount(_retval_ int* count) = 0;
	ICALLTYPE GetPoint(int i, _retval_ ISurfacePoint_DG** point) = 0;
	ICALLTYPE Extend(ISurfacePointArray_DG* extension) = 0;
	ICALLTYPE Offset(double offset) = 0;
	IUNKNOWN_
};

[uuid("{1CB41F9E-72E5-4B77-BE4A-DCE2233911FF}")]
class IPick_DG : public IUnknown
{
public:
	ICALLTYPE GetEntityAt(int xWnd, int yWnd, _retval_ IEntity_DG** entity) = 0;
	ICALLTYPE GetEntityAt1(int xWnd, int yWnd, _out_ Point_DG* point, _retval_ IEntity_DG** entity) = 0;
	ICALLTYPE GetSurfacePointAt(int xWnd, int yWnd, _retval_ ISurfacePoint_DG** surfPoint) = 0;
	IUNKNOWN_
};

[uuid("{976ABD82-B2BC-400D-BBF5-5785FD6A115A}")]
class IStdShape_DG : public IUnknown
{
public:
	ICALLTYPE Cylinder(double baseRadius, double topRadius, double height, _retval_ IEntity_DG** cylinder) = 0;
	ICALLTYPE Disk(double innerRadius, double outerRadius, _retval_ IEntity_DG** disk) = 0;
	ICALLTYPE Sphere(double radius, _retval_ IEntity_DG** sphere) = 0;
	ICALLTYPE Box(double width, double height, double length, _retval_ IEntity_DG** box) = 0;
	ICALLTYPE Torus(double radius, double radiusTube, _retval_ IEntity_DG** torus) = 0;
	ICALLTYPE Triangle(Point_DG* pt0, Point_DG* pt1, Point_DG* pt2, _retval_ IEntity_DG** obj) = 0;
	ICALLTYPE Rectangle(double width, double height, _retval_ IEntity_DG** obj) = 0;
	ICALLTYPE Polygon(Point_DG* pt0, Point_DG* pt1, Point_DG* pt2, Point_DG* pt3, _retval_ IEntity_DG** obj) = 0;
	ICALLTYPE Line(Point_DG* pt0, Point_DG* pt1, _retval_ IEntity_DG** obj) = 0;
	ICALLTYPE LineInf(Point_DG* origin, Vect_DG* direction, VARIANT_BOOL ray, _retval_ IEntity_DG** obj) = 0;
	ICALLTYPE Circle(double radius, _retval_ IEntity_DG** obj) = 0;
	ICALLTYPE Arc(double radius, double angle, _retval_ IEntity_DG** obj) = 0;
	ICALLTYPE Ellipse(double a, double b, _retval_ IEntity_DG** obj) = 0;
	IUNKNOWN_
};

[uuid("{9D8CE87E-712D-462C-9D15-528F472799D5}")]
class IStdShapeRef_DG : public IUnknown
{
public:
	ICALLTYPE Cylinder(double baseRadius, double topRadius, double height, _inout_ IEntity_DG** cylinder) = 0;
	ICALLTYPE Disk(double innerRadius, double outerRadius, _inout_ IEntity_DG** disk) = 0;
	ICALLTYPE Sphere(double radius, _inout_ IEntity_DG** sphere) = 0;
	ICALLTYPE Box(double width, double height, double length, _inout_ IEntity_DG** box) = 0;
	ICALLTYPE Torus(double radius, double radiusTube, _inout_ IEntity_DG** torus) = 0;
	ICALLTYPE Triangle(Point_DG* pt0, Point_DG* pt1, Point_DG* pt2, _inout_ IEntity_DG** obj) = 0;
	ICALLTYPE Rectangle(double width, double height, _inout_ IEntity_DG** obj) = 0;
	ICALLTYPE Polygon(Point_DG* pt0, Point_DG* pt1, Point_DG* pt2, Point_DG* pt3, _inout_ IEntity_DG** obj) = 0;
	ICALLTYPE Line(Point_DG* pt0, Point_DG* pt1, _inout_ IEntity_DG** obj) = 0;
	ICALLTYPE LineInf(Point_DG* origin, Vect_DG* direction, VARIANT_BOOL ray, _inout_ IEntity_DG** obj) = 0;
	ICALLTYPE Circle(double radius, _inout_ IEntity_DG** obj) = 0;
	ICALLTYPE Arc(double radius, double angle, _inout_ IEntity_DG** obj) = 0;
	ICALLTYPE Ellipse(double a, double b, _inout_ IEntity_DG** obj) = 0;
	IUNKNOWN_
};

[uuid("{DE8A7CCF-8E0C-48D5-AF9A-4912E5AF41AC}")]
class IDraw_DG : public IUnknown
{
public:
	ICALLTYPE Begin(DrawPrimitive_DG mode) = 0;
	ICALLTYPE End(_retval_ IEntity_DG** result) = 0;
	ICALLTYPE BeginUpdate(IEntity_DG* obj) = 0;
	ICALLTYPE EndUpdate() = 0;
	ICALLTYPE Vertex(double x, double y, double z) = 0;
	ICALLTYPE Normal(double nx, double ny, double nz) = 0;
	ICALLTYPE Color(double red, double green, double blue, double alpha) = 0;
	ICALLTYPE LineWidth(float width) = 0;
	ICALLTYPE PointSize(float size) = 0;
	ICALLTYPE PushAttrib() = 0;
	ICALLTYPE PopAttrib() = 0;
	ICALLTYPE PushMatrix() = 0;
	ICALLTYPE PopMatrix() = 0;
	ICALLTYPE Translate(double vx, double vy, double vz) = 0;
	ICALLTYPE Rotate(double angle, double vx, double vy, double vz) = 0;
	ICALLTYPE LoadIdentity() = 0;
	ICALLTYPE SetCurrentFrame(IFrame_DG* frame) = 0;
	ICALLTYPE IsEyeFrameSpace(_retval_ VARIANT_BOOL* val) = 0;
	ICALLTYPE SetEyeFrameSpace(VARIANT_BOOL val) = 0;
	ICALLTYPE IsTransient(_retval_ VARIANT_BOOL* val) = 0;
	ICALLTYPE SetTransient(VARIANT_BOOL val) = 0;
	IUNKNOWN_
};

[uuid("{5A394BB0-8520-46BE-A1DA-7A07041FBCDE}")]
class IBRepGeometry_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetShape(_retval_ IBRepShape_DG** shape) = 0;
	ICALLTYPE _set_ SetShape(IBRepShape_DG* shape) = 0;
	ICALLTYPE CreateShape(ShapeType_DG type, _retval_ IBRepShape_DG** shape) = 0;
	ICALLTYPE Clear() = 0;
	IUNKNOWN_
};

[uuid("{93C3BA6F-E0EE-4ED4-8456-2BAED8027E08}")]
class IPointSetGeometry_DG : public IUnknown
{
public:
	ICALLTYPE GetPoints(_retval_ IPointArray_DG** points) = 0;
	ICALLTYPE _get_ GetColorPerVertex(_retval_ VARIANT_BOOL* val) = 0;
	ICALLTYPE _set_ SetColorPerVertex(VARIANT_BOOL val) = 0;
	ICALLTYPE GetColors(_retval_ IPointArray_DG** colors) = 0;
	IUNKNOWN_
};

[uuid("{13A0D366-49A3-44B7-BE50-0745FF97AF9C}")]
class ISegmentStripGeometry_DG : public IUnknown
{
public:
	ICALLTYPE GetPointSet(_retval_ IPointSetGeometry_DG** points) = 0;
	ICALLTYPE GetIndex(_retval_ IArrayInt_DG** index) = 0;
	IUNKNOWN_
};

[uuid("{9A5A9948-E53E-46BA-A64F-7F57E11F7529}")]
class ICurveGeometry_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetCurve(_retval_ ICurve_DG** curve) = 0;
	ICALLTYPE _set_ SetCurve(ICurve_DG* curve) = 0;
	IUNKNOWN_
};

[uuid("{9535E6C3-ED70-4F22-8020-0A8B5F88BD8D}")]
class IVertex_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetPosition(Point_DG* pt) = 0;
	ICALLTYPE _set_ SetPosition(Point_DG* pt) = 0;
	ICALLTYPE GetPosition1(_out_ double* x, _out_ double* y, _out_ double* z) = 0;
	ICALLTYPE SetPosition1(double x, double y, double z) = 0;
	ICALLTYPE _get_ GetNormalCount(int* count) = 0;
	ICALLTYPE _set_ SetNormalCount(int count) = 0;
	ICALLTYPE GetNormal(int which, _retval_ Vect_DG* normal) = 0;
	ICALLTYPE SetNormal(int which, Vect_DG* normal) = 0;
	ICALLTYPE GetNormal1(int which, _out_ double* vx, _out_ double* vy, _out_ double* vz) = 0;
	ICALLTYPE SetNormal1(int which, double vx, double vy, double vz) = 0;
	ICALLTYPE GetStarElementCount(MeshElementType_DG elementType, _retval_ int* count) = 0;
	ICALLTYPE GetStarVertex(int i, _retval_ IVertex_DG** vertex) = 0;
	ICALLTYPE GetStarSegment(int i, _retval_ IVertexSegment_DG** segment) = 0;
	ICALLTYPE GetStarSimplex(int i, _retval_ ISimplex_DG** simplex) = 0;
	ICALLTYPE IsInteriorVertex(VARIANT_BOOL* interior) = 0;
	ICALLTYPE GetLinkingSegment(IVertex_DG* vertex, _retval_ IVertexSegment_DG** segment) = 0;
	ICALLTYPE FindStarVertex(IVertex_DG* vertex, _retval_ int* index) = 0;
	ICALLTYPE FindStarSegment(IVertexSegment_DG* segment, _retval_ int* index) = 0;
	ICALLTYPE FindStarSimplex(ISimplex_DG* simplex, _retval_ int* index) = 0;
	IUNKNOWN_
};

[uuid("{28240400-5956-49A2-A8BE-8D702CC29310}")]
class IVertexSegment_DG : public IUnknown
{
public:
	ICALLTYPE GetEnd(int end, _retval_ IVertex_DG** vertex) = 0;
	ICALLTYPE GetAdjacentSimplex(int side, _retval_ ISimplex_DG** simplex) = 0;
	ICALLTYPE IsInterior(_retval_ VARIANT_BOOL* interior) = 0;
	IUNKNOWN_
};

[uuid("{9AD55F80-E12F-49DC-8F5F-B97745C02FA2}")]
class ISimplex_DG : public IUnknown
{
public:
	ICALLTYPE GetVertexPosition(int corner, _retval_ POSN* vertex) = 0;
	ICALLTYPE GetFaceNormal(_retval_ Vect_DG* normal) = 0;
	ICALLTYPE GetFaceNormal1(_out_ double* vx, _out_ double* vy, _out_ double* vz) = 0;
	ICALLTYPE GetNormal(int corner, _retval_ Vect_DG* normal) = 0;
	ICALLTYPE GetNormal1(int corner, _out_ double* vx, _out_ double* vy, _out_ double* vz) = 0;
	ICALLTYPE GetNormalIndex(int corner, _retval_ int* index) = 0;
	ICALLTYPE SetNormalIndex(int corner, int index) = 0;
	ICALLTYPE GetEdge(int side, _retval_ IVertexSegment_DG** edge) = 0;
	ICALLTYPE GetAdjacentSimplex(int side, _retval_ ISimplex_DG** simplex) = 0;
	ICALLTYPE IsInteriorSimplex(_retval_ VARIANT_BOOL* interior) = 0;
	IUNKNOWN_
};

[uuid("{067903EA-6D59-4720-9E08-D940500B5DBE}")]
class IMesh_DG : public IUnknown
{
public:
	ICALLTYPE GetVertexList(_retval_ IList_DG** vertices) = 0;
	ICALLTYPE GetSimplexList(_retval_ IList_DG** simplexes) = 0;
	ICALLTYPE GetVertexPosition(POSN vertex, _retval_ Point_DG* pt) = 0;
	ICALLTYPE GetVertexPosition1(POSN vertex, _out_ double* x, _out_ double* y, _out_ double* z) = 0;
	ICALLTYPE GetNormal(POSN vertex, _retval_ Vect_DG* normal) = 0;
	ICALLTYPE GetNormal1(POSN vertex, _out_ double* vx, _out_ double* vy, _out_ double* vz) = 0;
	ICALLTYPE GetSimplexVertices(POSN simplex, _out_ POSN* vert0, _out_ POSN* vert1, _out_ POSN* vert2) = 0;
	ICALLTYPE IsValid(_retval_ VARIANT_BOOL* ret) = 0;
	ICALLTYPE SetVertexPosition(POSN vertex, Point_DG* pt) = 0;
	ICALLTYPE SetVertexPosition1(POSN vertex, double x, double y, double z) = 0;
	ICALLTYPE SetNormal(POSN vertex, Vect_DG* normal) = 0;
	ICALLTYPE SetNormal1(POSN vertex, double vx, double vy, double vz) = 0;
	ICALLTYPE FixupNormals(double creaseDegrees, double tolerDegrees) = 0;
	ICALLTYPE Offset(double dist) = 0;
	ICALLTYPE Clear() = 0;
	ICALLTYPE ClearList(MeshElementType_DG dim) = 0;
	ICALLTYPE Begin() = 0;
	ICALLTYPE End(MeshModsAction_DG action) = 0;
	ICALLTYPE SwapSide() = 0;
	ICALLTYPE ToLocal(IFrame_DG* frame) = 0;
	ICALLTYPE ToGlobal(IFrame_DG* frame) = 0;
	ICALLTYPE EnableShading(VARIANT_BOOL enable) = 0;
	ICALLTYPE IsShadingEnabled(_retval_ VARIANT_BOOL* type) = 0;
	ICALLTYPE GetVertexColor(POSN vertex, _retval_ Color_DG* color) = 0;
	ICALLTYPE SetVertexColor(POSN vertex, Color_DG* color) = 0;
	ICALLTYPE IsShaderInitOK(VARIANT_BOOL* ret) = 0;
	ICALLTYPE DeleteShader() = 0;
	ICALLTYPE GetVertex(POSN vertex, _retval_ IVertex_DG** iVertex) = 0;
	ICALLTYPE GetSimplex(POSN simplex, _retval_ ISimplex_DG** iSimplex) = 0;
	ICALLTYPE GetVertexListPosition(IVertex_DG* iVertex, _retval_ POSN* position) = 0;
	ICALLTYPE GetSimplexListPosition(ISimplex_DG* iSimplex, _retval_ POSN* position) = 0;
	ICALLTYPE Upgrade() = 0;
	ICALLTYPE IsUpgraded(_retval_ VARIANT_BOOL* upgraded) = 0;
	ICALLTYPE Downgrade() = 0;
	ICALLTYPE IsClosedSurface(_retval_ VARIANT_BOOL* closed) = 0;
	ICALLTYPE Extract(IObject_DG* proximity, int elements, VARIANT_BOOL move, VARIANT_BOOL clone, _retval_ IMesh_DG** iMeshExtracted) = 0;
	ICALLTYPE Extract2(IFrame_DG* frameOfThis, IObject_DG* proximity, int elements, VARIANT_BOOL move, VARIANT_BOOL clone, _retval_ IMesh_DG** iMeshExtracted) = 0;
	ICALLTYPE Merge(IMesh_DG* mesh, int elements, VARIANT_BOOL move, VARIANT_BOOL clone) = 0;
	ICALLTYPE SplitLinkedComponents(_out_ IMapUint64_DG** map, _retval_ IArray_DG** components) = 0;
	ICALLTYPE Refine(MeshRefineType_DG type) = 0;
	ICALLTYPE SmoothLaplacian(int steps) = 0;
	ICALLTYPE AddVertex(_retval_ POSN* posnResult) = 0;
	ICALLTYPE RemoveVertex(POSN vertex) = 0;
	ICALLTYPE AddSimplex(POSN vert0, POSN vert1, POSN vert2, double creaseAngle, _retval_ POSN* posnResult) = 0;
	ICALLTYPE RemoveSimplex(POSN simplex) = 0;
	IUNKNOWN_
};

[uuid("{F7D6B69A-5404-4A98-A8F6-6E581959650E}")]
class IMeshPoint_DG : public IUnknown
{
public:
	ICALLTYPE GetPoint(_retval_ Point_DG* point) = 0;
	ICALLTYPE GetLocation(_retval_ PointVsSimplexLocation_DG* location) = 0;
	ICALLTYPE GetEdge(_retval_ int* edge) = 0;
	ICALLTYPE GetSimplexListPosition(_retval_ POSN* position) = 0;
	IUNKNOWN_
};

[uuid("{4F9CC526-C30E-48AA-ADDD-1A9ECCE82C70}")]
class IMeshAlgor_DG : public IUnknown
{
public:
	ICALLTYPE AddVertex(double x, double y, double z, _retval_ POSN* posnResult) = 0;
	ICALLTYPE BuildMesh(float Radius, float minDist, float creaseDegrees) = 0;
	ICALLTYPE GetDefaults(_out_ float* Radius, _out_ float* minDist, _out_ float* creaseDegrees) = 0;
	IUNKNOWN_
};

[uuid("{66AFCAF0-557B-45DA-85F8-10158CA4F5F8}")]
class IMeshGeometry_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetMesh(_retval_ IMesh_DG** mesh) = 0;
	ICALLTYPE _set_ SetMesh(IMesh_DG* mesh) = 0;
	IUNKNOWN_
};

[uuid("{A68E9F33-554D-4561-B829-CF45BA34456C}")]
class IDiffSurface_DG : public IUnknown
{
public:
	ICALLTYPE GetNormalAt(Point_DG* pointAt, _out_ Vect_DG* normal, _retval_ int* count) = 0;
	ICALLTYPE GetProximity(Point_DG* pointAt, _retval_ IVertex_DG** vertex) = 0;
	ICALLTYPE GetLocalParametrization(Point_DG* pointAt, _retval_ IBSplineSurface_DG** patch) = 0;
	IUNKNOWN_
};

[uuid("{3AAA38C4-76F2-476B-BECA-6E7164288A50}")]
class IEuclideanShortestPath_DG : public IUnknown
{
public:
	ICALLTYPE AddObject(IEntity_DG* obj) = 0;
	ICALLTYPE AddAllObjects(IModel_DG* objects) = 0;
	ICALLTYPE _get_ GetInputPointCount(_retval_ int* points) = 0;
	ICALLTYPE _set_ SetInputPointCount(int points) = 0;
	ICALLTYPE SetInputPoint(int i, double x, double y, double z) = 0;
	ICALLTYPE GetInputPoint(int i, _out_ double* x, _out_ double* y, _out_ double* z) = 0;
	ICALLTYPE AddInputPoint(double x, double y, double z) = 0;
	ICALLTYPE GetInputPointArray(_retval_ IPointArray_DG** iArray) = 0;
	ICALLTYPE GetInputPath(_retval_ ICurve_DG** path) = 0;
	ICALLTYPE MakeInputValid() = 0;
	ICALLTYPE Calculate(VARIANT_BOOL checkValidInput) = 0;
	ICALLTYPE GetOutputPath(_retval_ ICurve_DG** path) = 0;
	ICALLTYPE Reset(VARIANT_BOOL pathOnly) = 0;
	ICALLTYPE _get_ GetPrecision(_retval_ double* precision) = 0;
	ICALLTYPE _set_ SetPrecision(double precision) = 0;
	ICALLTYPE GetOutputPath2(_retval_ ISurfacePointArray_DG** path) = 0;
	ICALLTYPE Calculate2(Point_DG* from, Point_DG* to, _retval_ ISurfacePointArray_DG** path) = 0;
	ICALLTYPE CalculatePerSegment(_retval_ ISurfacePointArray_DG** path) = 0;
	ICALLTYPE GetObjects(_retval_ IArray_DG** objects) = 0;
	ICALLTYPE CloneNoPaths(_retval_ IEuclideanShortestPath_DG** esp) = 0;
	IUNKNOWN_
};

[uuid("{7556A432-49F0-4BDC-8418-07592C59707E}")]
class ISticky_DG : public IUnknown
{
public:
	ICALLTYPE StickTo(IEntity_DG* surface) = 0;
	ICALLTYPE Detach() = 0;
	ICALLTYPE IsAttached(_retval_ VARIANT_BOOL* state) = 0;
	IUNKNOWN_
};

[uuid("{E778F24C-E2AC-40B9-A7C8-CD7DE19ACCED}")]
class IMove_DG : public IUnknown
{
public:
	ICALLTYPE GetFrameArray(_retval_ IFrameArray_DG** frames) = 0;
	ICALLTYPE GetFrameAt(double t, _retval_ IFrame_DG** frame) = 0;
	ICALLTYPE _get_ GetOriginPath(_retval_ ICurve_DG** curve) = 0;
	ICALLTYPE _set_ SetOriginPath(ICurve_DG* curve) = 0;
	ICALLTYPE GetAxisPath(int axis, _retval_ ICurve_DG** curve) = 0;
	ICALLTYPE SetAxisPath(int axis, ICurve_DG* curve) = 0;
	ICALLTYPE CreateAttributes(MoveParametrisationType_DG type) = 0;
	ICALLTYPE DefineTangential() = 0;
	IUNKNOWN_
};

[uuid("{D2BF12B1-3B62-4BB2-871B-908B81A147C2}")]
class IKinematicSet_DG : public IUnknown
{
public:
	ICALLTYPE AddObject(IEntity_DG* entity, IMove_DG* movement, VARIANT_BOOL includeChildren) = 0;
	ICALLTYPE GetObjects(_retval_ IEntityArray_DG** entities) = 0;
	ICALLTYPE Clear() = 0;
	ICALLTYPE SetPosition(double t) = 0;
	IUNKNOWN_
};

[uuid("{67109E58-63F8-4F2B-958B-C61B84E81C4C}")]
class ICutEffect_DG : public IUnknown
{
public:
	ICALLTYPE Setup(IEntity_DG* object) = 0;
	ICALLTYPE Begin(IMove_DG* path) = 0;
	ICALLTYPE Show(float t) = 0;
	ICALLTYPE End() = 0;
	ICALLTYPE Chain(ICutEffect_DG* effectNextMove) = 0;
	IUNKNOWN_
};

[uuid("{FEA70F03-5B8A-4C5A-8FED-59987C25913B}")]
class ISpinEffect_DG : public IUnknown
{
public:
	ICALLTYPE Setup(IEntity_DG* objectSpan, IView_DG* iView) = 0;
	ICALLTYPE Begin(int durationMilliSeconds) = 0;
	ICALLTYPE End(int durationMilliSeconds) = 0;
	IUNKNOWN_
};

[uuid("{9C3008CC-B9A6-47D8-860C-47D06AB56A65}")]
class IPathCollisionDetector_DG : public IUnknown
{
public:
	ICALLTYPE AddObject(IEntity_DG* entity, IMove_DG* movement, VARIANT_BOOL includeChildren) = 0;
	ICALLTYPE GetKinematicSet(_retval_ IKinematicSet_DG** entities) = 0;
	ICALLTYPE Detect(PathDetectorContext_DG* context, _retval_ double* tCollision) = 0;
	ICALLTYPE GetCollidedObjects(_out_ IEntity_DG** object0, _out_ IEntity_DG** object1, _retval_ VARIANT_BOOL* haveMore) = 0;
	ICALLTYPE GetCollidedObjectsEx(_retval_ IEntityArray_DG** collidedEntities) = 0;
	ICALLTYPE GetCollisionCounterparts(IEntity_DG* entity, _retval_ IEntityArray_DG** others) = 0;
	IUNKNOWN_
};

[uuid("{F4E86C32-5C1F-483E-A88E-10373745831D}")]
class IKinematicEntity_DG : public IUnknown
{
public:
	ICALLTYPE CreateSweptVolume(double deviation, _retval_ IEntity_DG** entity) = 0;
	ICALLTYPE Move(double from, double to) = 0;
	ICALLTYPE MoveLocal(double from, double to) = 0;
	ICALLTYPE _get_ GetMovement(_retval_ IMove_DG** move) = 0;
	ICALLTYPE _set_ SetMovement(IMove_DG* move) = 0;
	IUNKNOWN_
};

[uuid("{A3262A99-C311-435B-8CCD-7FAD7510EE06}")]
class IConstraint_DG : public IUnknown
{
public:
	ICALLTYPE SetFreedom(ViewNavigationType_DG navigationType, int dims) = 0;
	ICALLTYPE GetFreedom(ViewNavigationType_DG navigationType, _retval_ int* dims) = 0;
	ICALLTYPE GetConstraint(ViewNavigationType_DG navigationType, _retval_ ILine_DG** axis) = 0;
	ICALLTYPE _get_ IsEnabled(_retval_ VARIANT_BOOL* enabled) = 0;
	ICALLTYPE _set_ SetEnabled(VARIANT_BOOL enabled) = 0;
	IUNKNOWN_
};

[uuid("{B6FCE6F7-A6D8-4520-AD81-CE59A59D322A}")]
class ITexture_DG : public IUnknown
{
public:
	ICALLTYPE Load(char* filePath) = 0;
	ICALLTYPE IsLoaded(_retval_ VARIANT_BOOL* loaded) = 0;
	ICALLTYPE Unload() = 0;
	ICALLTYPE _get_ IsEnabled(_retval_ VARIANT_BOOL* enabled) = 0;
	ICALLTYPE _set_ SetEnabled(VARIANT_BOOL enabled) = 0;
	ICALLTYPE _get_ IsBlend(_retval_ VARIANT_BOOL* blend) = 0;
	ICALLTYPE _set_ SetBlend(VARIANT_BOOL blend) = 0;
	ICALLTYPE UseTexture(ITexture_DG* texture) = 0;
	ICALLTYPE LoadFromHandle(POSN hBitmap) = 0;
	ICALLTYPE GetFileName(_retval_ BSTR* name) = 0;
	IUNKNOWN_
};

[uuid("{348E3418-DD48-4174-A5A5-9B15D086E17C}")]
class IDataContext_DG : public IUnknown
{
public:
	ICALLTYPE _get_ IsVerbose(_retval_ VARIANT_BOOL* verbose) = 0;
	ICALLTYPE _set_ SetVerbose(VARIANT_BOOL verbose) = 0;
	ICALLTYPE _get_ IsNoWarnings(_retval_ VARIANT_BOOL* noWarnings) = 0;
	ICALLTYPE _set_ SetNoWarnings(VARIANT_BOOL noWarnings) = 0;
	IUNKNOWN_
};

[uuid("{08C2B94E-C51B-4CD1-BDCF-8D8C30A67074}")]
class ISTLDataContext_DG : public IUnknown
{
public:
	ICALLTYPE _get_ IsBinary(_retval_ VARIANT_BOOL* binary) = 0;
	ICALLTYPE _set_ SetBinary(VARIANT_BOOL binary) = 0;
	ICALLTYPE _get_ IsSeparateObjects(_retval_ VARIANT_BOOL* separate) = 0;
	ICALLTYPE _set_ SetSeparateObjects(VARIANT_BOOL separate) = 0;
	ICALLTYPE _get_ GetCreaseAngle(_retval_ double* radians) = 0;
	ICALLTYPE _set_ SetCreaseAngle(double radians) = 0;
	ICALLTYPE _get_ IsBuildTree(_retval_ VARIANT_BOOL* build) = 0;
	ICALLTYPE _set_ SetBuildTree(VARIANT_BOOL build) = 0;
	ICALLTYPE _get_ GetAnalysisType(_retval_ STLAnalysisType_DG* type) = 0;
	ICALLTYPE _set_ SetAnalysisType(STLAnalysisType_DG type) = 0;
	IUNKNOWN_
};

[uuid("{40FE8B8C-12BF-4F4B-AC71-F8DA647F0107}")]
class ISelection_DG : public IUnknown
{
public:
	ICALLTYPE GetSelectedItems(_retval_ IArray_DG** items) = 0;
	ICALLTYPE SetSelected(IObject_DG* item, VARIANT_BOOL selected) = 0;
	ICALLTYPE ClearSelection() = 0;
	IUNKNOWN_
};

[uuid("{9A1C209D-5C20-4BA0-9C50-17ED4160FDCB}")]
class I2DEditor_DG : public IUnknown
{
public:
	ICALLTYPE Activate(VARIANT_BOOL activate) = 0;
	ICALLTYPE Init() = 0;
	ICALLTYPE _get_ GetEditableObject(_retval_ IEntity_DG** iEditableObject) = 0;
	ICALLTYPE _set_ SetEditableObject(IEntity_DG* iEditableObject) = 0;
	ICALLTYPE GetContext(_retval_ IContext_DG** context) = 0;
	IUNKNOWN_
};

[uuid("{37F78A82-FD60-4816-819C-66A5CD7A9686}")]
class IScene_DG : public IUnknown
{
public:
	ICALLTYPE CreatePresentationEntity(IObject_DG* obj, VARIANT_BOOL addToScene, IDictionary_DG* optionsOrNull, _retval_ IEntity_DG** entity) = 0;
	ICALLTYPE UpdatePresentationEntity(IObject_DG* obj, IEntity_DG* entity, IDictionary_DG* optionsOrNull) = 0;
	ICALLTYPE GetCurrentItemSet(_retval_ ISelection_DG** items) = 0;
	ICALLTYPE IsLocalFrameVisible(IEntity_DG* entity, _retval_ VARIANT_BOOL* visible) = 0;
	ICALLTYPE ShowLocalFrame(IEntity_DG* entity, VARIANT_BOOL show) = 0;
	ICALLTYPE IsVisible(IEntity_DG* entity, _retval_ VARIANT_BOOL* visible) = 0;
	ICALLTYPE Show(IEntity_DG* entity, VARIANT_BOOL show) = 0;
	IUNKNOWN_
};

[uuid("{AF48AF33-1C8B-436A-B44D-3CE2DE036C80}")]
class IBitmap_DG : public IUnknown
{
public:
	ICALLTYPE GetBitmapData(_retval_ IBlob_DG** fileData) = 0;
	ICALLTYPE GetInfo(_retval_ Bitmap_DG* info) = 0;
	ICALLTYPE GetBits(_retval_ IBlob_DG** image) = 0;
	IUNKNOWN_
};

[uuid("{F5D2839D-FA78-4AD3-8147-E1BA26656D3E}")]
class IVirtualView_DG : public IUnknown
{
public:
	ICALLTYPE Create(_nullable_ PairInt_DG* size, _retval_ IBitmap_DG** buffer) = 0;
	ICALLTYPE Render() = 0;
	ICALLTYPE Destroy() = 0;
	IUNKNOWN_
};

[uuid("{ABDD1AA8-BCCC-4CD3-97FB-E48A09E380F9}")]
class IVirtualModelView_DG : public IUnknown
{
public:
	ICALLTYPE Create(IModel_DG* model, PairInt_DG* size, _retval_ IView_DG** view) = 0;
	ICALLTYPE Render(_retval_ IBitmap_DG** buffer) = 0;
	ICALLTYPE Destroy() = 0;
	IUNKNOWN_
};

[uuid("{C6DEBF07-5201-4ABA-93E9-0E3BF68BDF3A}")]
class ILightSource_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetLocation(Point_DG* point) = 0;
	ICALLTYPE _set_ SetLocation(Point_DG* point) = 0;
	ICALLTYPE GetLocation1(_out_ float* x, _out_ float* y, _out_ float* z) = 0;
	ICALLTYPE SetLocation1(float x, float y, float z) = 0;
	ICALLTYPE GetColor(LightComponent_DG component, _retval_ Color_DG* color) = 0;
	ICALLTYPE SetColor(LightComponent_DG component, Color_DG* color) = 0;
	ICALLTYPE GetColor1(LightComponent_DG component, _out_ float* red, _out_ float* green, _out_ float* blue) = 0;
	ICALLTYPE SetColor1(LightComponent_DG component, float red, float green, float blue) = 0;
	ICALLTYPE _get_ GetType(_retval_ LightSourceType_DG* type) = 0;
	ICALLTYPE _set_ SetType(LightSourceType_DG type) = 0;
	ICALLTYPE _get_ GetPositioningType(_retval_ LightPositioningType_DG* type) = 0;
	ICALLTYPE _set_ SetPositioningType(LightPositioningType_DG type) = 0;
	IUNKNOWN_
};

[uuid("{6F0E45A6-6211-4406-A12F-E3ABC9776C83}")]
class ILighting_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetLightSourceCount(_retval_ int* count) = 0;
	ICALLTYPE _set_ SetLightSourceCount(int count) = 0;
	ICALLTYPE GetLightSource(int index, _retval_ ILightSource_DG** lightSource) = 0;
	ICALLTYPE RemoveLightSource(int index) = 0;
	ICALLTYPE Add(_retval_ ILightSource_DG** lightSource) = 0;
	ICALLTYPE RemoveAll() = 0;
	IUNKNOWN_
};

[uuid("{C77DB948-9821-45C2-A3FF-051492432326}")]
class IView_DG : public IUnknown
{
public:
	ICALLTYPE Update() = 0;
	ICALLTYPE Reset(VARIANT_BOOL redraw, VARIANT_BOOL includeOrientation) = 0;
	ICALLTYPE ShowHideAll(VARIANT_BOOL show) = 0;
	ICALLTYPE GoTo(IEntity_DG* entity) = 0;
	ICALLTYPE LookAt(Point_DG* point, Vect_DG* directionUp) = 0;
	ICALLTYPE GetModel(_retval_ IModel_DG** model) = 0;
	ICALLTYPE IsVisibleGlobalAxes(_retval_ VARIANT_BOOL* visible) = 0;
	ICALLTYPE ShowGlobalAxes(VARIANT_BOOL show) = 0;
	ICALLTYPE GetBackColor(_out_ float* red, _out_ float* green, _out_ float* blue, _out_ float* alpha) = 0;
	ICALLTYPE SetBackColor(float red, float green, float blue, float alpha) = 0;
	ICALLTYPE _get_ GetRenderType(_retval_ RenderType_DG* type) = 0;
	ICALLTYPE _set_ SetRenderType(RenderType_DG type) = 0;
	ICALLTYPE _get_ GetViewType(_retval_ ViewType_DG* type) = 0;
	ICALLTYPE _set_ SetViewType(ViewType_DG type) = 0;
	ICALLTYPE _get_ GetViewMode(_retval_ ViewMode_DG* mode) = 0;
	ICALLTYPE _set_ SetViewMode(ViewMode_DG mode) = 0;
	ICALLTYPE _get_ GetAutoViewMode(_retval_ ViewMode_DG* mode) = 0;
	ICALLTYPE _set_ SetAutoViewMode(ViewMode_DG mode) = 0;
	ICALLTYPE _get_ GetProjectionType(_retval_ ProjectionType_DG* type) = 0;
	ICALLTYPE _set_ SetProjectionType(ProjectionType_DG type) = 0;
	ICALLTYPE GetBoolAttribute(ViewBoolAttribute_DG attribute, _retval_ VARIANT_BOOL* val) = 0;
	ICALLTYPE SetBoolAttribute(ViewBoolAttribute_DG attribute, VARIANT_BOOL val) = 0;
	ICALLTYPE Translate(double vx, double vy, double vz) = 0;
	ICALLTYPE Rotate(double angle, double vx, double vy, double vz) = 0;
	ICALLTYPE Zoom(double scale) = 0;
	ICALLTYPE ZoomEx(double scale, double centerx, double centery, double centerz) = 0;
	ICALLTYPE GetEyeFrame(_retval_ IFrame_DG** frame) = 0;
	ICALLTYPE _get_ GetViewingVolume(_retval_ Box_DG* box) = 0;
	ICALLTYPE _set_ SetViewingVolume(Box_DG* box) = 0;
	ICALLTYPE ScreenTo3D(int xWnd, int yWnd, _retval_ Point_DG* point3D) = 0;
	ICALLTYPE ScreenTo3DEx(int xWnd, int yWnd, double dist, _retval_ Point_DG* point3D) = 0;
	ICALLTYPE ProjectToScreen(Point_DG* point3D, _retval_ PairInt_DG* windowPosition) = 0;
	ICALLTYPE ScreenToEyeFrame(int xWnd, int yWnd, _out_ double* x, _out_ double* y) = 0;
	ICALLTYPE GetPixelSize(_retval_ double* sizeGeometric) = 0;
	ICALLTYPE GetWindowSize(_retval_ PairInt_DG* sizePixels) = 0;
	ICALLTYPE GetContext(_retval_ IContext_DG** context) = 0;
	ICALLTYPE GetScene(_retval_ IScene_DG** scene) = 0;
	ICALLTYPE GetLighting(_retval_ ILighting_DG** lighting) = 0;
	ICALLTYPE GetExtendedProperties(_retval_ IDictionary_DG** namedProperties) = 0;
	ICALLTYPE LookAtEntity(IEntity_DG* entity, Vect_DG* directionUp) = 0;
	ICALLTYPE LookAtEntities(IEntityArray_DG* entities, Vect_DG* directionUp) = 0;
	ICALLTYPE ResetState() = 0;
	IUNKNOWN_
};

[uuid("{04878A98-CE06-42CF-89EF-32710CEC901E}")]
class IViewPoint_DG : public IUnknown
{
public:
	ICALLTYPE Store() = 0;
	ICALLTYPE SetCurrent() = 0;
	ICALLTYPE SetCurrent1(int transitionMilliseconds) = 0;
	ICALLTYPE GetViewVolumeDimensions(_out_ double* sx, _out_ double* sy, _out_ double* sz) = 0;
	ICALLTYPE SetViewVolumeDimensions(double sx, double sy) = 0;
	IUNKNOWN_
};

[uuid("{27FA7573-C7C7-491F-8A3A-5D4FE5192906}")]
class IViewPointArray_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetCount(_retval_ int* count) = 0;
	ICALLTYPE GetAt(int index, _retval_ IViewPoint_DG** vp) = 0;
	ICALLTYPE RemoveAt(int index) = 0;
	ICALLTYPE RemoveAll() = 0;
	ICALLTYPE Add(char* name) = 0;
	ICALLTYPE _get_ GetDefault(_retval_ int* index) = 0;
	ICALLTYPE _set_ SetDefault(int index) = 0;
	IUNKNOWN_
};

[uuid("{655E6CE4-5E32-49F9-AD3E-A3693AD355E2}")]
class IMeasurement_DG : public IUnknown
{
public:
	ICALLTYPE _get_ GetPointCount(_retval_ int* count) = 0;
	ICALLTYPE _set_ SetPointCount(int count) = 0;
	ICALLTYPE GetPoint(int i, _retval_ Point_DG* point) = 0;
	ICALLTYPE SetPoint(int i, Point_DG* point) = 0;
	ICALLTYPE _get_ GetText(_retval_ BSTR* text) = 0;
	ICALLTYPE _set_ SetText(char* text) = 0;
	ICALLTYPE _get_ GetDirection(_retval_ Vect_DG* direction) = 0;
	ICALLTYPE _set_ SetDirection(Vect_DG* direction) = 0;
	ICALLTYPE _get_ GetTextLocation(_retval_ double* dist) = 0;
	ICALLTYPE _set_ SetTextLocation(double dist) = 0;
	ICALLTYPE _get_ GetTextPosition(_retval_ double* ratio) = 0;
	ICALLTYPE _set_ SetTextPosition(double ratio) = 0;
	IUNKNOWN_
};

[uuid("{F1564E20-A417-45A2-B47F-2F3B655F99FB}")]
class ITechnology_DG : public IUnknown
{
public:
	ICALLTYPE GetTechnologyName(_retval_ BSTR* name) = 0;
	ICALLTYPE GetGlobalObjectPointer(char* type, POSN* pp) = 0;
	ICALLTYPE GetPointer(IUnknown* objectFrom, char* interfaceNameFrom, char* requestedPointer, _retval_ POSN* outPointer) = 0;
	ICALLTYPE GetInterface(POSN pointer, char* pointerType, char* interfaceName, _retval_ IUnknown** interf) = 0;
	ICALLTYPE Execute(char* operation, __int64 param0, __int64 param1) = 0;
	ICALLTYPE SetTechnologyToAppCallback(bool(*func)(__int64 implementationObj, const char* operation, __int64 param0, __int64 param1), __int64 implementnObj) = 0;
	ICALLTYPE GetInterface2(POSN pointer, char* pointerType, IUnknown* context, char* interfaceName, _retval_ IUnknown** interf) = 0;
	IUNKNOWN_
};

[uuid("{A65C7E6A-5053-47BD-9134-BC5D595B37F0}")]
class IControlInitialisationContext_DG : public IUnknown
{
public:
	ICALLTYPE _get_ IsActive(_retval_ VARIANT_BOOL* active) = 0;
	ICALLTYPE _set_ SetActive(VARIANT_BOOL active) = 0;
	ICALLTYPE ReleaseContext() = 0;
	ICALLTYPE GetModelPath(_retval_ BSTR* path) = 0;
	ICALLTYPE SetModelPath(char* path) = 0;
	ICALLTYPE GetShowGlobalAxes(_retval_ VARIANT_BOOL* show) = 0;
	ICALLTYPE SetShowGlobalAxes(VARIANT_BOOL show) = 0;
	ICALLTYPE GetBackgroundColor(_retval_ Color_DG* color) = 0;
	ICALLTYPE SetBackgroundColor(Color_DG* color) = 0;
	ICALLTYPE GetRenderSolid(_retval_ VARIANT_BOOL* solid) = 0;
	ICALLTYPE SetRenderSolid(VARIANT_BOOL solid) = 0;
	ICALLTYPE IsVisible(_retval_ VARIANT_BOOL* visible) = 0;
	ICALLTYPE SetVisible(VARIANT_BOOL visible) = 0;
	ICALLTYPE ResetToDefaults() = 0;
	ICALLTYPE GetExtendedProperties(_retval_ IContext_DG** context) = 0;
	ICALLTYPE GetUserDefinedProperties(_retval_ IContext_DG** context) = 0;
	IUNKNOWN_
};

[uuid("{F72F6309-7D4E-43E6-8EEB-6A7A01F796B2}")]
class IGlobalAPI_DG : public IUnknown
{
public:
	ICALLTYPE LockInitialisationContext(_retval_ IControlInitialisationContext_DG** context) = 0;
	ICALLTYPE GetGenerator(_retval_ IObjectGenerator_DG** generator) = 0;
	ICALLTYPE LaunchExplorer(IModel_DG* model, IView_DG* view) = 0;
	ICALLTYPE GetReferenceCount(IUnknown* anInterface, _retval_ int* count) = 0;
	ICALLTYPE AddRefUnsafe(IUnknown* anInterface, _retval_ int* count) = 0;
	ICALLTYPE ReleaseUnsafe(IUnknown* anInterface, _retval_ int* count) = 0;
	ICALLTYPE GetTechnology(char* name, _retval_ ITechnology_DG** technology) = 0;
	ICALLTYPE GetCoreContext(_retval_ IDictionary_DG** context) = 0;
	IUNKNOWN_
};

[uuid("{024db0ef-ce5a-4c77-9967-24edbadbb361}")]
class IEngrave_DG : public IUnknown
{
public:
	ICALLTYPE AttachWorkpiece(IEntity_DG* entity) = 0;
	ICALLTYPE GetWorkpiece(_retval_ IEntity_DG** entity) = 0;
	ICALLTYPE AddTextLine(char* line) = 0;
	ICALLTYPE _get_ GetText(_retval_ BSTR* text) = 0;
	ICALLTYPE _set_ SetText(char* text) = 0;
	ICALLTYPE _get_ GetHeight(_retval_ double* height) = 0;
	ICALLTYPE _set_ SetHeight(double height) = 0;
	ICALLTYPE _get_ GetThickness(_retval_ double* thickness) = 0;
	ICALLTYPE _set_ SetThickness(double thickness) = 0;
	ICALLTYPE _get_ GetSpacing(_retval_ double* h) = 0;
	ICALLTYPE _set_ SetSpacing(double h) = 0;
	ICALLTYPE _get_ GetLineSpacingRatio(_retval_ double* ratio) = 0;
	ICALLTYPE _set_ SetLineSpacingRatio(double ratio) = 0;
	ICALLTYPE _get_ GetFontName(_retval_ BSTR* name) = 0;
	ICALLTYPE _set_ SetFontName(char* name) = 0;
	ICALLTYPE _get_ GetDepth(_retval_ double* depth) = 0;
	ICALLTYPE _set_ SetDepth(double depth) = 0;
	ICALLTYPE _get_ GetOrientationRay(_retval_ Line_DG* ray) = 0;
	ICALLTYPE _set_ SetOrientationRay(Line_DG* ray) = 0;
	ICALLTYPE Engrave(_retval_ VARIANT_BOOL* success) = 0;
	ICALLTYPE Reset() = 0;
	IUNKNOWN_
};
