//InterfaceKO.h
#pragma once
#include <olectl.h>
#include <idispids.h>

#include "KoTypes.h"

class IKO_gp_Trsf2d;

// {E893F754-1DBD-41B4-AFC0-53D859BED941}
static const GUID IID_IKO_Standard_Object = { 0xe893f754, 0x1dbd, 0x41b4, { 0xaf, 0xc0, 0x53, 0xd8, 0x59, 0xbe, 0xd9, 0x41 } };
class IKO_Standard_Object : public IUnknown
{
public:
	ICALLTYPE GetTypeName(BSTR* name)=0;
	ICALLTYPE Replicate(IKO_Standard_Object** newCopy)=0;
	ICALLTYPE Copy(IKO_Standard_Object* other)=0;
	IUNKNOWN_
};

// {8F11E589-5B76-4FB9-9D82-E1B5BFFB4378}
static const GUID IID_IKO_IMetricsBasic = { 0x8f11e589, 0x5b76, 0x4fb9, { 0x9d, 0x82, 0xe1, 0xb5, 0xbf, 0xfb, 0x43, 0x78 } };
class IKO_IMetricsBasic : public IUnknown
{
public:
	virtual HRESULT STDMETHODCALLTYPE Dist(IKO_Standard_Object* iObj, double* dist)=0;
	virtual HRESULT STDMETHODCALLTYPE DistPoint(DIPoint* pt, double* dist)=0;
	IUNKNOWN_	//QueryInterface(), AddRef(), Release() See above
};

// {D7E48CA5-486E-4BA0-B053-F59A2A32E453}
static const GUID IID_IKO_TColStd_Array1 = { 0xd7e48ca5, 0x486e, 0x4ba0, { 0xb0, 0x53, 0xf5, 0x9a, 0x2a, 0x32, 0xe4, 0x53 } };
class IKO_TColStd_Array1 : public IUnknown
{
public:
	ICALLTYPE Create(int lower, int upper)=0;
	ICALLTYPE Assign(IKO_TColStd_Array1* iArr)=0;
	ICALLTYPE Length(int* upper)=0;
	ICALLTYPE Lower(int* lower)=0;
	ICALLTYPE Upper(int* upper)=0;
	IUNKNOWN_
};

// {4474368B-16A9-4643-8B1A-33233248E44C}
static const GUID IID_IKO_TColStd_Array2 = { 0x4474368b, 0x16a9, 0x4643, { 0x8b, 0x1a, 0x33, 0x23, 0x32, 0x48, 0xe4, 0x4c } };
class IKO_TColStd_Array2 : public IUnknown
{
public:
	ICALLTYPE Create(int R1, int R2, int C1, int C2)=0;
	ICALLTYPE Destroy()=0;
	ICALLTYPE ColLength(int* length)=0;
	ICALLTYPE RowLength(int* length)=0;
	ICALLTYPE LowerCol(int* ind)=0;
	ICALLTYPE LowerRow(int* ind)=0;
	ICALLTYPE UpperCol(int* ind)=0;
	ICALLTYPE UpperRow(int* ind)=0;
	IUNKNOWN_
};

// {C1A3CFF1-8869-4F07-96FD-523B83925961}
static const GUID IID_IKO_TColStd_Array1OfInteger = { 0xc1a3cff1, 0x8869, 0x4f07, { 0x96, 0xfd, 0x52, 0x3b, 0x83, 0x92, 0x59, 0x61 } };
class IKO_TColStd_Array1OfInteger : public IUnknown
{
public:
	ICALLTYPE Create(int lower, int upper)=0;
	ICALLTYPE SetValue(int Index, int n)=0;
	ICALLTYPE GetValue(int Index, int* n)=0;
	IUNKNOWN_
};

// {C910C260-8EC5-4279-A340-86902166437C}
static const GUID IID_IKO_TColStd_Array1OfBoolean = { 0xc910c260, 0x8ec5, 0x4279, { 0xa3, 0x40, 0x86, 0x90, 0x21, 0x66, 0x43, 0x7c } };
class IKO_TColStd_Array1OfBoolean : public IUnknown
{
public:
	ICALLTYPE Create(int lower, int upper)=0;
	ICALLTYPE SetValue(int Index, VARIANT_BOOL val)=0;
	ICALLTYPE GetValue(int Index, VARIANT_BOOL* val)=0;
	IUNKNOWN_
};

// {D89F0E73-1152-4C0D-96E7-59450597C7B9}
static const GUID IID_IKO_TColStd_Array1OfReal = { 0xd89f0e73, 0x1152, 0x4c0d, { 0x96, 0xe7, 0x59, 0x45, 0x5, 0x97, 0xc7, 0xb9 } };
class IKO_TColStd_Array1OfReal : public IUnknown
{
public:
	ICALLTYPE Create(int lower, int upper)=0;
	ICALLTYPE SetValue(int Index, double d)=0;
	ICALLTYPE GetValue(int Index, double* d)=0;
	IUNKNOWN_
};

// {7686D11B-77D7-4AB6-B625-A4DB5DA3FE2F}
static const GUID IID_IKO_TColStd_Array2OfReal = { 0x7686d11b, 0x77d7, 0x4ab6, { 0xb6, 0x25, 0xa4, 0xdb, 0x5d, 0xa3, 0xfe, 0x2f } };
class IKO_TColStd_Array2OfReal : public IUnknown
{
public:
	ICALLTYPE Create(int R1, int R2, int C1, int C2)=0;
	ICALLTYPE SetValue(int Row, int Col, double d)=0;
	ICALLTYPE Value(int Row, int Col, double* d)=0;
	IUNKNOWN_
};

// {9AACAAF6-A4FA-41BF-B580-E70E1B492B5E}
static const GUID IID_IKO_gp_Mat = { 0x9aacaaf6, 0xa4fa, 0x41bf, { 0xb5, 0x80, 0xe7, 0xe, 0x1b, 0x49, 0x2b, 0x5e } };
class IKO_gp_Mat : public IUnknown
{
public:
	IUNKNOWN_
};

// {8530821E-3660-44E5-A674-CBAC16E3562F}
static const GUID IID_IKO_gp_Mat2d = { 0x8530821e, 0x3660, 0x44e5, { 0xa6, 0x74, 0xcb, 0xac, 0x16, 0xe3, 0x56, 0x2f } };
class IKO_gp_Mat2d : public IUnknown
{
public:
	ICALLTYPE Init()=0;
	ICALLTYPE Init1(KC2D* Col1, KC2D* Col2)=0;
	ICALLTYPE SetCol(int Col, KC2D* Value)=0;
	ICALLTYPE SetCols(KC2D* Col1, KC2D* Col2)=0;
	ICALLTYPE SetDiagonal(double X1, double X2)=0;
	ICALLTYPE SetIdentity()=0;
	ICALLTYPE SetRotation(double Ang)=0;
	ICALLTYPE SetRow(int Row, KC2D* Value)=0;
	ICALLTYPE SetRows(KC2D* Row1, KC2D* Row2)=0;
	ICALLTYPE SetScale(double S)=0;
	ICALLTYPE SetValue(int Row, int Col, double Value)=0;
	ICALLTYPE Column(int Col, KC2D* ret)=0;
	ICALLTYPE Determinant(double* ret)=0;
	ICALLTYPE Diagonal(KC2D* ret)=0;
	ICALLTYPE Row(int Row, KC2D* ret)=0;
	ICALLTYPE Value(int Row, int Col, double* ret)=0;
	ICALLTYPE ChangeValue(int Row, int Col, double* ret)=0;
	ICALLTYPE IsSingular(VARIANT_BOOL* ret)=0;
	ICALLTYPE Add(IKO_gp_Mat2d* Other)=0;
	ICALLTYPE Added(IKO_gp_Mat2d* Other, IKO_gp_Mat2d** ret)=0;
	ICALLTYPE Divide(double Scalar)=0;
	ICALLTYPE Divided(double Scalar, IKO_gp_Mat2d** ret)=0;
	ICALLTYPE Invert()=0;
	ICALLTYPE Inverted(IKO_gp_Mat2d** ret)=0;
	ICALLTYPE Multiplied(IKO_gp_Mat2d* Other, IKO_gp_Mat2d** ret)=0;
	ICALLTYPE Multiply(IKO_gp_Mat2d* Other)=0;
	ICALLTYPE PreMultiply(IKO_gp_Mat2d* Other)=0;
	ICALLTYPE Multiplied1(double Scalar, IKO_gp_Mat2d** ret)=0;
	ICALLTYPE Multiply1(double Scalar)=0;
	ICALLTYPE Power(int N)=0;
	ICALLTYPE Powered(int N, IKO_gp_Mat2d** ret)=0;
	ICALLTYPE Subtract(IKO_gp_Mat2d* Other)=0;
	ICALLTYPE Subtracted(IKO_gp_Mat2d* Other, IKO_gp_Mat2d** ret)=0;
	ICALLTYPE Transpose()=0;
	ICALLTYPE Transposed(IKO_gp_Mat2d** ret)=0;
	ICALLTYPE _CSFDB_Getgp_Mat2dmatrix(int i1, int i2, double* ret)=0;
	IUNKNOWN_
};

// {36732E20-BAF2-46FB-941E-3F02A6D512E1}
static const GUID IID_IKO_gp_Quaternion = { 0x36732e20, 0xbaf2, 0x46fb, { 0x94, 0x1e, 0x3f, 0x2, 0xa6, 0xd5, 0x12, 0xe1 } };
class IKO_gp_Quaternion : public IUnknown
{
public:
	ICALLTYPE IsEqual(IKO_gp_Quaternion* theOther, VARIANT_BOOL* res)=0;
	ICALLTYPE SetRotation(DIVect* theVecFrom, DIVect* theVecTo)=0;
	ICALLTYPE SetRotation2(DIVect* theVecFrom, DIVect* theVecTo, DIVect* theHelpCrossVec)=0;
	ICALLTYPE SetVectorAndAngle(DIVect* theAxis, double theAngle)=0;
	ICALLTYPE GetVectorAndAngle(DIVect* theAxis, double* theAngle)=0;
	ICALLTYPE SetMatrix(IKO_gp_Mat* theMat)=0;
	ICALLTYPE GetMatrix(IKO_gp_Mat** theMat)=0;
	ICALLTYPE SetEulerAngles(int gp_EulerSequence_order, double theAlpha, double theBeta, double theGamma)=0;
	ICALLTYPE GetEulerAngles(int gp_EulerSequence_order, double* theAlpha, double* theBeta, double* theGamma)=0;
	ICALLTYPE Set(double x, double y, double z, double w)=0;
	ICALLTYPE Set2(IKO_gp_Quaternion* theQuaternion)=0;
	ICALLTYPE Component(int i, double* d)=0;
	ICALLTYPE SetIdent()=0;
	ICALLTYPE Reverse()=0;
	ICALLTYPE Invert()=0;
	ICALLTYPE Norm(double* norm)=0;
	ICALLTYPE Scale(double theScale)=0;
	ICALLTYPE Normalize()=0;
	ICALLTYPE Add(IKO_gp_Quaternion* theOther)=0;
	ICALLTYPE Subtract(IKO_gp_Quaternion* theOther)=0;
	ICALLTYPE Dot(IKO_gp_Quaternion* theOther, double* ret)=0;
	ICALLTYPE GetRotationAngle(double* angle)=0;
	ICALLTYPE Multiply(DIVect* V)=0;
	IUNKNOWN_
};

// {A6A5114B-494A-4A93-B55B-D6DFB4B064D7}
static const GUID IID_IKO_gp_Ax1 = { 0xa6a5114b, 0x494a, 0x4a93, { 0xb5, 0x5b, 0xd6, 0xdf, 0xb4, 0xb0, 0x64, 0xd7 } };
class IKO_gp_Ax1 : public IUnknown
{
public:
	ICALLTYPE SetDirection(DIVect* V)=0;
	ICALLTYPE Direction(DIVect* V)=0;
	ICALLTYPE SetLocation(DIPoint* pt)=0;
	ICALLTYPE Location(DIPoint* pt)=0;
	ICALLTYPE IsCoaxial(IKO_gp_Ax1* Other, double AngularTolerance, double LinearTolerance, VARIANT_BOOL* res)=0;
	ICALLTYPE IsNormal(IKO_gp_Ax1* Other, double AngularTolerance, VARIANT_BOOL* res)=0;
	ICALLTYPE IsOpposite(IKO_gp_Ax1* Other, double AngularTolerance, VARIANT_BOOL* res)=0;
	ICALLTYPE IsParallel(IKO_gp_Ax1* Other, double AngularTolerance, VARIANT_BOOL* res)=0;
	ICALLTYPE Angle(IKO_gp_Ax1* Other, double* angle)=0;
	ICALLTYPE Reverse()=0;
	IUNKNOWN_
};

// {3813FA29-7F44-4BB1-BE0B-2F5736DF4267}
static const GUID IID_IKO_gp_Ax2 = { 0x3813fa29, 0x7f44, 0x4bb1, { 0xbe, 0xb, 0x2f, 0x57, 0x36, 0xdf, 0x42, 0x67 } };
class IKO_gp_Ax2 : public IUnknown
{
public:
	ICALLTYPE SetDirection(DIVect* vZAxis)=0;
	ICALLTYPE Direction(DIVect* vZAxis)=0;
	ICALLTYPE SetLocation(DIPoint* P)=0;
	ICALLTYPE Location(DIPoint* P)=0;
	ICALLTYPE SetXDirection(DIVect* V)=0;
	ICALLTYPE XDirection(DIVect* V)=0;
	ICALLTYPE SetYDirection(DIVect* V)=0;
	ICALLTYPE YDirection(DIVect* V)=0;
	ICALLTYPE Axis(IKO_gp_Ax1** ZAxis)=0;
	ICALLTYPE Init(DIPoint* P, DIVect* N, DIVect* Vx)=0;
	ICALLTYPE Init1(DIPoint* P, DIVect* V)=0;
	ICALLTYPE SetAxis(IKO_gp_Ax1* A1)=0;
	ICALLTYPE Angle(IKO_gp_Ax2* Other, double* ret)=0;
	ICALLTYPE IsCoplanar(IKO_gp_Ax1* A1, double LinearTolerance, double AngularTolerance, VARIANT_BOOL* ret)=0;
	ICALLTYPE IsCoplanar2(IKO_gp_Ax2* Other, double LinearTolerance, double AngularTolerance, VARIANT_BOOL* ret)=0;
	IUNKNOWN_
};

// {3B96634C-1004-4FD3-8640-AF0852A9CA77}
static const GUID IID_IKO_gp_Ax3 = { 0x3b96634c, 0x1004, 0x4fd3, { 0x86, 0x40, 0xaf, 0x8, 0x52, 0xa9, 0xca, 0x77 } };
class IKO_gp_Ax3 : public IUnknown
{
public:
	ICALLTYPE Init(IKO_gp_Ax2* A)=0;
	ICALLTYPE Init1(DIPoint* P, DIVect* N, DIVect* Vx)=0;
	ICALLTYPE Init2(DIPoint* P, DIVect* V)=0;
	ICALLTYPE ReverseAxis(int axis)=0;
	ICALLTYPE Direct(VARIANT_BOOL* res)=0;
	ICALLTYPE SetAxis(IKO_gp_Ax1* A1)=0;
	ICALLTYPE SetDirection(DIVect* V)=0;
	ICALLTYPE SetLocation(DIPoint* P)=0;
	ICALLTYPE SetXDirection(DIVect* Vx)=0;
	ICALLTYPE SetYDirection(DIVect* Vy)=0;
	ICALLTYPE Angle(IKO_gp_Ax3* Other, double* ret)=0;
	ICALLTYPE Axis(IKO_gp_Ax1** ret)=0;
	ICALLTYPE Ax2(IKO_gp_Ax2** ret)=0;
	ICALLTYPE Direction(DIVect* ret)=0;
	ICALLTYPE Location(DIPoint* ret)=0;
	ICALLTYPE XDirection(DIVect* ret)=0;
	ICALLTYPE YDirection(DIVect* ret)=0;
	ICALLTYPE IsCoplanar(IKO_gp_Ax3* Other, double LinearTolerance, double AngularTolerance, VARIANT_BOOL* ret)=0;
	ICALLTYPE IsCoplanar2(IKO_gp_Ax1* A1, double LinearTolerance, double AngularTolerance, VARIANT_BOOL* ret)=0;
	IUNKNOWN_
};

// {E10F3D33-92D4-4106-B657-8EE03CF795DD}
static const GUID IID_IKO_gp_Circ = { 0xe10f3d33, 0x92d4, 0x4106, { 0xb6, 0x57, 0x8e, 0xe0, 0x3c, 0xf7, 0x95, 0xdd } };
class IKO_gp_Circ : public IUnknown
{
public:
	ICALLTYPE SetLocation(double x, double y, double z)=0;
	ICALLTYPE GetLocation(double* x, double* y, double* z)=0;
	ICALLTYPE SetAxisDirection(double vx, double vy, double vz)=0;
	ICALLTYPE GetAxisDirection(double* vx, double* vy, double* vz)=0;
	ICALLTYPE SetRadius(double Radius)=0;
	ICALLTYPE GetRadius(double* Radius)=0;
	ICALLTYPE Distance(DIPoint* pt, double* dist)=0;
	ICALLTYPE Contains(DIPoint* pt, double tolerance, VARIANT_BOOL* result)=0;
	ICALLTYPE Mirror(DIPoint* pt)=0;
	ICALLTYPE SetPosition(IKO_gp_Ax2* A2)=0;
	ICALLTYPE Position(IKO_gp_Ax2* A2)=0;
	IUNKNOWN_
};

// {9A32F7F0-D76D-4F77-9E27-9D4DEFB55745}
static const GUID IID_IKO_gp_Trsf = { 0x9a32f7f0, 0xd76d, 0x4f77, { 0x9e, 0x27, 0x9d, 0x4d, 0xef, 0xb5, 0x57, 0x45 } };
class IKO_gp_Trsf : public IUnknown
{
public:
	ICALLTYPE SetMirror(DIPoint* P)=0;
	ICALLTYPE SetMirror2(IKO_gp_Ax1* A1)=0;
	ICALLTYPE SetMirror3(IKO_gp_Ax2* A2)=0;
	ICALLTYPE SetRotation(IKO_gp_Ax1* A1, double Ang)=0;
	ICALLTYPE SetRotation2(IKO_gp_Quaternion* rotation)=0;
	ICALLTYPE SetScale(DIPoint* P, double S)=0;
	ICALLTYPE SetDisplacement(IKO_gp_Ax3* FromSystem1, IKO_gp_Ax3* ToSystem2)=0;
	ICALLTYPE SetTransformation(IKO_gp_Ax3* FromSystem1, IKO_gp_Ax3* ToSystem2)=0;
	ICALLTYPE SetTransformation2(IKO_gp_Ax3* ToSystem)=0;
	ICALLTYPE SetTransformation3(IKO_gp_Quaternion* R, DIVect* T)=0;
	ICALLTYPE SetTranslation(DIVect* V)=0;
	ICALLTYPE SetTranslation2(DIPoint* P1, DIPoint* P2)=0;
	ICALLTYPE SetTranslationPart(DIVect* V)=0;
	ICALLTYPE SetScaleFactor(double S)=0;
	ICALLTYPE SetValues(double a11, double a12, double a13, double a14, double a21, double a22, double a23, double a24, double a31, double a32, double a33, double a34, double Tolang, double TolDist)=0;
	ICALLTYPE TranslationPart(DIVect* V)=0;
	ICALLTYPE GetRotation(IKO_gp_Quaternion** rotation)=0;
	ICALLTYPE Value(int Row, int Col, double* d)=0;
	ICALLTYPE Invert()=0;
	ICALLTYPE Multiply(IKO_gp_Trsf* T)=0;
	ICALLTYPE Transforms(double* X, double* Y, double* Z)=0;
	ICALLTYPE Transforms2(DIPoint* P)=0;
	IUNKNOWN_
};

// {ACE2A362-2343-452E-A9B1-597AAD89AEDC}
static const GUID IID_IKO_gp_Object = { 0xace2a362, 0x2343, 0x452e, { 0xa9, 0xb1, 0x59, 0x7a, 0xad, 0x89, 0xae, 0xdc } };
class IKO_gp_Object : public IUnknown
{
public:
/*	ICALLTYPE Mirror(DIPoint* pt)=0;
	ICALLTYPE Rotate(IKO_gp_Ax1* A1, double Ang)=0;
	ICALLTYPE Scale(DIPoint* P, double S)=0;
	ICALLTYPE Transform(IKO_gp_Trsf* T)=0;
	ICALLTYPE Translate(DIVect* V)=0;*/
	ICALLTYPE SetLocation(double x, double y, double z)=0;
	ICALLTYPE GetLocation(double* x, double* y, double* z)=0;
	ICALLTYPE SetPosition(IKO_gp_Ax3* A3)=0;
	ICALLTYPE Position(IKO_gp_Ax3* A3)=0;
	ICALLTYPE SetAxis(IKO_gp_Ax1* A1)=0;
	ICALLTYPE Axis(IKO_gp_Ax1* axis)=0;
	IUNKNOWN_
};

// {28EE66B4-26B3-4A28-93CA-7B1F6DC85CC9}
static const GUID IID_IKO_gp_Transformation = { 0x28ee66b4, 0x26b3, 0x4a28, { 0x93, 0xca, 0x7b, 0x1f, 0x6d, 0xc8, 0x5c, 0xc9 } };
class IKO_gp_Transformation : public IUnknown
{
public:
	ICALLTYPE Translate(DIVect* V)=0;
	ICALLTYPE Rotate(IKO_gp_Ax1* A1, double Ang)=0;
	ICALLTYPE Scale(DIPoint* P, double S)=0;
	ICALLTYPE Mirror(DIPoint* P)=0; 
	ICALLTYPE Mirror1(IKO_gp_Ax1* A1)=0; 
	ICALLTYPE Mirror2(IKO_gp_Ax2* A2)=0; 
	ICALLTYPE Transform(IKO_gp_Trsf* T)=0;
	IUNKNOWN_
};

// {1921E6DA-1C72-47C4-A932-1A2301A84F7E}
static const GUID IID_IKO_gp_Pln = { 0x1921e6da, 0x1c72, 0x47c4, { 0xa9, 0x32, 0x1a, 0x23, 0x1, 0xa8, 0x4f, 0x7e } };
class IKO_gp_Pln : public IUnknown
{
public:
	ICALLTYPE Init(IKO_gp_Ax3* A3)=0;
	ICALLTYPE Init2(DIPoint* P, DIVect* V)=0;
	ICALLTYPE Init3(double A, double B, double C, double D)=0;
	ICALLTYPE Coefficients(double* A, double* B, double* C, double* D)=0;
	ICALLTYPE Distance(DIPoint* P, double* dist)=0;
	ICALLTYPE Contains(DIPoint* P, double LinearTolerance, VARIANT_BOOL* res)=0;
	IUNKNOWN_
};

// {F5EDE138-6839-4C44-BF85-595C868343B4}
static const GUID IID_IKO_gp_Lin = { 0xf5ede138, 0x6839, 0x4c44, { 0xbf, 0x85, 0x59, 0x5c, 0x86, 0x83, 0x43, 0xb4 } };
class IKO_gp_Lin : public IUnknown
{
public:
	ICALLTYPE Init(IKO_gp_Ax1* A1)=0;
	ICALLTYPE Init2(DIPoint* P, DIVect* V)=0;
	ICALLTYPE Replicate(IKO_gp_Lin** replica)=0; 
	ICALLTYPE Reverse()=0;
	ICALLTYPE SetDirection(DIVect* V)=0;
	ICALLTYPE SetLocation(DIPoint* P)=0;
	ICALLTYPE SetPosition(IKO_gp_Ax1* A1)=0;
	ICALLTYPE Direction(DIVect* dir)=0; 
	ICALLTYPE Location(DIPoint* P)=0; 
	ICALLTYPE Position(IKO_gp_Ax1** ax)=0; 
	ICALLTYPE Angle(IKO_gp_Lin* Other, double* val)=0; 
	ICALLTYPE Contains(DIPoint* P, double LinearTolerance, VARIANT_BOOL* ret)=0; 
	ICALLTYPE Normal(DIPoint* P, IKO_gp_Lin** normal)=0; 
/*	ICALLTYPE Mirror(DIPoint* P)=0;
	ICALLTYPE Mirror(IKO_gp_Ax1* A1)=0;
	ICALLTYPE Mirror(IKO_gp_Ax2* A2)=0;
	ICALLTYPE Rotate(IKO_gp_Ax1* A1, double Ang)=0;
	ICALLTYPE Scale(DIPoint* P, double S)=0;
	ICALLTYPE Transform(IKO_gp_Trsf* T)=0;
	ICALLTYPE Translate(DIVect* V)=0;
	ICALLTYPE Translate(DIPoint* P1, DIPoint* P2)=0;*/
	IUNKNOWN_
};

// {188D2FAB-8451-45AB-BF50-5A9A7206AE69}
static const GUID IID_IKO_gp_Cylinder = { 0x188d2fab, 0x8451, 0x45ab, { 0xbf, 0x50, 0x5a, 0x9a, 0x72, 0x6, 0xae, 0x69 } };
class IKO_gp_Cylinder : public IUnknown
{
public:
	ICALLTYPE Init(IKO_gp_Ax3* A3, double Radius)=0;
	ICALLTYPE SetRadius(double R)=0;
	ICALLTYPE Coefficients(double* A1, double* A2, double* A3, double* B1, double* B2, double* B3, double* C1, double* C2, double* C3, double* D)=0;
	ICALLTYPE Radius(double* radius)=0;
	IUNKNOWN_
};

// {E1D64C16-6216-4ECC-B111-F112DBB986E8}
static const GUID IID_IKO_gp_Cone = { 0xe1d64c16, 0x6216, 0x4ecc, { 0xb1, 0x11, 0xf1, 0x12, 0xdb, 0xb9, 0x86, 0xe8 } };
class IKO_gp_Cone : public IUnknown
{
public:
	ICALLTYPE Init(IKO_gp_Ax3* A3, double Ang, double Radius)=0; 
	ICALLTYPE SetRadius(double R)=0; 
	ICALLTYPE SetSemiAngle(double Ang)=0; 
	ICALLTYPE Apex(DIPoint* P)=0;
	ICALLTYPE Coefficients(double* A1, double* A2, double* A3, double* B1, double* B2, double* B3, double* C1, double* C2, double* C3, double* D)=0;  
	ICALLTYPE RefRadius(double* retVal)=0;
	ICALLTYPE SemiAngle(double* retVal)=0;
	IUNKNOWN_
};

// {64F42A6D-30C1-4AB3-8101-0957C2239224}
static const GUID IID_IKO_gp_Sphere = { 0x64f42a6d, 0x30c1, 0x4ab3, { 0x81, 0x1, 0x9, 0x57, 0xc2, 0x23, 0x92, 0x24 } };
class IKO_gp_Sphere : public IUnknown
{
public:
	ICALLTYPE Init(IKO_gp_Ax3* A3, double Radius)=0;
	ICALLTYPE SetRadius (double R)=0;
	ICALLTYPE Area (double* retVal)=0;  
	ICALLTYPE Coefficients (double* A1, double* A2, double* A3, double* B1, double* B2, double* B3, double* C1, double* C2, double* C3, double* D)=0;  
	ICALLTYPE Radius (double* retVal)=0;  
	ICALLTYPE Volume (double* retVal)=0;
	IUNKNOWN_
};

// {D15EC4A8-FEDB-45D6-B786-9CEEA6469F60}
static const GUID IID_IKO_gp_Torus = { 0xd15ec4a8, 0xfedb, 0x45d6, { 0xb7, 0x86, 0x9c, 0xee, 0xa6, 0x46, 0x9f, 0x60 } };
class IKO_gp_Torus : public IUnknown
{
public:
	ICALLTYPE Init(IKO_gp_Ax3* A3, double MajorRadius, double MinorRadius)=0;
	ICALLTYPE SetMajorRadius(double MajorRadius)=0;
	ICALLTYPE SetMinorRadius(double MinorRadius)=0;
	ICALLTYPE Area(double* retVal)=0;
	ICALLTYPE Coefficients(IKO_TColStd_Array1OfReal* Coef)=0;
	ICALLTYPE MajorRadius(double* retVal)=0;
	ICALLTYPE MinorRadius(double* retVal)=0;
	ICALLTYPE Volume(double* retVal)=0;
	IUNKNOWN_
};

// {C472C188-3CFC-4D85-89C0-99C33F9F8566}
static const GUID IID_IKO_TColgp_Array1OfPnt = { 0xc472c188, 0x3cfc, 0x4d85, { 0x89, 0xc0, 0x99, 0xc3, 0x3f, 0x9f, 0x85, 0x66 } };
class IKO_TColgp_Array1OfPnt : public IUnknown
{
public:
	ICALLTYPE Create(int lower, int upper)=0;
	ICALLTYPE SetValue(int Index, DIPoint* pt)=0;
	ICALLTYPE GetValue(int Index, DIPoint* pt)=0;
	IUNKNOWN_
};

// {EA90C8EA-5097-4551-8431-A4D3B1BF5139}
static const GUID IID_IKO_TColgp_Array1OfPnt2d = { 0xea90c8ea, 0x5097, 0x4551, { 0x84, 0x31, 0xa4, 0xd3, 0xb1, 0xbf, 0x51, 0x39 } };
class IKO_TColgp_Array1OfPnt2d : public IUnknown
{
public:
	ICALLTYPE SetValue(int Index, KC2D* pt)=0;
	ICALLTYPE GetValue(int Index, KC2D* pt)=0;
	IUNKNOWN_
};

// {21C950AC-B796-423F-B2FB-7551DC8C5815}
static const GUID IID_IKO_TColgp_Array1OfVec = { 0x21c950ac, 0xb796, 0x423f, { 0xb2, 0xfb, 0x75, 0x51, 0xdc, 0x8c, 0x58, 0x15 } };
class IKO_TColgp_Array1OfVec : public IUnknown
{
public:
	ICALLTYPE Create(int lower, int upper)=0;
	ICALLTYPE SetValue(int Index, DIVect* pt)=0;
	ICALLTYPE GetValue(int Index, DIVect* pt)=0;
	IUNKNOWN_
};

// {A9CCB766-A422-4019-92BD-F1351A704213}
static const GUID IID_IKO_TColgp_Array2OfPnt = { 0xa9ccb766, 0xa422, 0x4019, { 0x92, 0xbd, 0xf1, 0x35, 0x1a, 0x70, 0x42, 0x13 } };
class IKO_TColgp_Array2OfPnt : public IUnknown
{
public:
	ICALLTYPE Create(int R1, int R2, int C1, int C2)=0;
	ICALLTYPE SetValue(int Row, int Col, DIPoint* pt)=0;
	ICALLTYPE Value(int Row, int Col, DIPoint* pt)=0;
	IUNKNOWN_
};

// {1AF9AEB7-C312-4F22-AABF-30A0A08797B5}
static const GUID IID_IKO_Poly_Polygon2D = { 0x1af9aeb7, 0xc312, 0x4f22, { 0xaa, 0xbf, 0x30, 0xa0, 0xa0, 0x87, 0x97, 0xb5 } };
class IKO_Poly_Polygon2D : public IUnknown
{
public:
	ICALLTYPE Init(IKO_TColgp_Array1OfPnt2d* Nodes)=0;
	ICALLTYPE GetDeflection(double* val)=0;
	ICALLTYPE Deflection(double D)=0;
	ICALLTYPE NbNodes(int* nodes)=0;
	ICALLTYPE Nodes(IKO_TColgp_Array1OfPnt2d* nodes)=0;
	IUNKNOWN_
};

// {D3B351DE-C05E-43AB-B4E9-0DAB0D171028}
static const GUID IID_IKO_Poly_Polygon3D = { 0xd3b351de, 0xc05e, 0x43ab, { 0xb4, 0xe9, 0xd, 0xab, 0xd, 0x17, 0x10, 0x28 } };
class IKO_Poly_Polygon3D : public IUnknown
{
public:
	ICALLTYPE Init(IKO_TColgp_Array1OfPnt* nodes)=0;
	ICALLTYPE Init2(IKO_TColgp_Array1OfPnt* nodes, IKO_TColStd_Array1OfReal* parameters)=0;
	ICALLTYPE GetDeflection(double* deflection)=0;
	ICALLTYPE Deflection(double D)=0;
	ICALLTYPE NbNodes(int* nodes)=0;
	ICALLTYPE Nodes(IKO_TColgp_Array1OfPnt* nodes)=0;
	ICALLTYPE HasParameters(VARIANT_BOOL* ret)=0;
	ICALLTYPE Parameters(IKO_TColStd_Array1OfReal* params)=0;
	ICALLTYPE ChangeParameters(IKO_TColStd_Array1OfReal* params)=0;
	IUNKNOWN_
};

// {989992C4-F81D-41DF-A89C-5AB1D833B85E}
static const GUID IID_IKO_Poly_Triangulation = { 0x989992c4, 0xf81d, 0x41df, { 0xa8, 0x9c, 0x5a, 0xb1, 0xd8, 0x33, 0xb8, 0x5e } };
class IKO_Poly_Triangulation : public IUnknown
{
public:
	ICALLTYPE Init(int nbNodes, int nbTriangles, VARIANT_BOOL UVNodes)=0;
	ICALLTYPE Init2(IKO_TColgp_Array1OfPnt *Nodes, IArray2 *Triangles)=0;
	ICALLTYPE Init3(IKO_TColgp_Array1OfPnt *Nodes, IKO_TColgp_Array1OfPnt2d* UVNodes, IArray2* Triangles)=0;
	ICALLTYPE GetDeflection(double* deflection)=0; 
	ICALLTYPE Deflection(double D)=0;
	ICALLTYPE RemoveUVNodes()=0;
	ICALLTYPE NbNodes(int* nodes)=0; 
	ICALLTYPE NbTriangles(int* triangles)=0; 
	ICALLTYPE HasUVNodes(VARIANT_BOOL* val)=0; 
	ICALLTYPE Nodes(IKO_TColgp_Array1OfPnt* nodes)=0; 
	ICALLTYPE ChangeNodes(IKO_TColgp_Array1OfPnt* nodes)=0;
	ICALLTYPE UVNodes(IKO_TColgp_Array1OfPnt2d* nodes)=0; 
	ICALLTYPE ChangeUVNodes(IKO_TColgp_Array1OfPnt2d* nodes)=0;
	ICALLTYPE Triangles(IArray2* triangles)=0; 
	ICALLTYPE ChangeTriangles(IArray2* triangles)=0;
	ICALLTYPE SetNormals(IKO_TColgp_Array1OfVec* theNormals)=0;
	ICALLTYPE Normals(IKO_TColgp_Array1OfVec* normals)=0; 
	ICALLTYPE ChangeNormals(IKO_TColgp_Array1OfVec* normals)=0;
	ICALLTYPE HasNormals(VARIANT_BOOL* val)=0; 
	IUNKNOWN_
};

// {94AC6334-A23C-4390-B268-B701A3568CF8}
static const GUID IID_IKO_Poly_PolygonOnTriangulation = { 0x94ac6334, 0xa23c, 0x4390, { 0xb2, 0x68, 0xb7, 0x1, 0xa3, 0x56, 0x8c, 0xf8 } };
class IKO_Poly_PolygonOnTriangulation : public IUnknown
{
public:
	ICALLTYPE Init(IKO_TColStd_Array1OfInteger*Nodes)=0;
	ICALLTYPE Init2(IKO_TColStd_Array1OfInteger* Nodes, IKO_TColStd_Array1OfReal* Parameters)=0;
	ICALLTYPE Deflection(double* D)=0;
	ICALLTYPE Deflection2(double D)=0;
	ICALLTYPE NbNodes(int* count)=0;
	ICALLTYPE Nodes(IKO_TColStd_Array1OfInteger* nodes)=0;
	ICALLTYPE HasParameters(VARIANT_BOOL val)=0;
	ICALLTYPE Parameters(IKO_TColStd_Array1OfReal* params)=0;
	IUNKNOWN_
};

// {0EF8D0D4-2911-4C78-8E83-9194A34FDFEA}
static const GUID IID_IKO_TopoDS_Vertex = { 0xef8d0d4, 0x2911, 0x4c78, { 0x8e, 0x83, 0x91, 0x94, 0xa3, 0x4f, 0xdf, 0xea } };
class IKO_TopoDS_Vertex : public IUnknown {public:	IUNKNOWN_ };
// {952A65A6-029B-48B5-808F-B9158D76E0A7}
static const GUID IID_IKO_TopoDS_Edge = { 0x952a65a6, 0x29b, 0x48b5, { 0x80, 0x8f, 0xb9, 0x15, 0x8d, 0x76, 0xe0, 0xa7 } };
class IKO_TopoDS_Edge : public IUnknown {public:	IUNKNOWN_ };
// {515E3E53-43C1-441A-A45F-7F1C304540BE}
static const GUID IID_IKO_TopoDS_Face = { 0x515e3e53, 0x43c1, 0x441a, { 0xa4, 0x5f, 0x7f, 0x1c, 0x30, 0x45, 0x40, 0xbe } };
class IKO_TopoDS_Face : public IUnknown {public:	IUNKNOWN_ };
// {FC2DC0FB-4ADD-4DAE-B653-DE1CB372CFBD}
static const GUID IID_IKO_TopoDS_Wire = { 0xfc2dc0fb, 0x4add, 0x4dae, { 0xb6, 0x53, 0xde, 0x1c, 0xb3, 0x72, 0xcf, 0xbd } };
class IKO_TopoDS_Wire : public IUnknown {public:	IUNKNOWN_ };
// {24F085A2-C713-4D78-B437-7821CCC66BC1}
static const GUID IID_IKO_TopoDS_Shell = { 0x24f085a2, 0xc713, 0x4d78, { 0xb4, 0x37, 0x78, 0x21, 0xcc, 0xc6, 0x6b, 0xc1 } };
class IKO_TopoDS_Shell : public IUnknown {public:	IUNKNOWN_ };
// {BAACFC30-7B01-41D3-A812-F96B5307D41F}
static const GUID IID_IKO_TopoDS_Solid = { 0xbaacfc30, 0x7b01, 0x41d3, { 0xa8, 0x12, 0xf9, 0x6b, 0x53, 0x7, 0xd4, 0x1f } };
class IKO_TopoDS_Solid : public IUnknown {public:	IUNKNOWN_ };
// {A0041557-959E-4BF2-A415-C6C28B080B64}
static const GUID IID_IKO_TopoDS_CompSolid = { 0xa0041557, 0x959e, 0x4bf2, { 0xa4, 0x15, 0xc6, 0xc2, 0x8b, 0x8, 0xb, 0x64 } };
class IKO_TopoDS_CompSolid : public IUnknown {public:	IUNKNOWN_ };
// {B28A211E-78A8-42CB-BD7A-71B1F02C2B2B}
static const GUID IID_IKO_TopoDS_Compound = { 0xb28a211e, 0x78a8, 0x42cb, { 0xbd, 0x7a, 0x71, 0xb1, 0xf0, 0x2c, 0x2b, 0x2b } };
class IKO_TopoDS_Compound : public IUnknown {public:	IUNKNOWN_ };

// {2DCEF9A6-1347-4AA9-BAEF-D114E1DCA9B9}
static const GUID IID_IKO_TopoDS_Shape = { 0x2dcef9a6, 0x1347, 0x4aa9, { 0xba, 0xef, 0xd1, 0x14, 0xe1, 0xdc, 0xa9, 0xb9 } };
class IKO_TopoDS_Shape : public IUnknown
{
public:
	ICALLTYPE Location(IFrame** ret)=0;
	ICALLTYPE SetLocation(IFrame* Loc)=0;
	ICALLTYPE Orientation(TopAbs_OrientationKO* ret)=0;
	ICALLTYPE SetOrientation(TopAbs_OrientationKO Orient)=0;
	ICALLTYPE ShapeType(TopAbs_ShapeEnumKO* type)=0;
	ICALLTYPE Free(VARIANT_BOOL* ret)=0;
	ICALLTYPE SetFree(VARIANT_BOOL F)=0;
	ICALLTYPE Modified(VARIANT_BOOL* ret)=0;
	ICALLTYPE SetModified(VARIANT_BOOL M)=0;
	ICALLTYPE Orientable(VARIANT_BOOL* ret)=0;
	ICALLTYPE SetOrientable(VARIANT_BOOL C)=0;
	ICALLTYPE Closed(VARIANT_BOOL* ret)=0;
	ICALLTYPE SetClosed(VARIANT_BOOL C)=0;
	ICALLTYPE Infinite(VARIANT_BOOL* ret)=0;
	ICALLTYPE SetInfinite(VARIANT_BOOL C)=0;
	ICALLTYPE Convex(VARIANT_BOOL* ret)=0;
	ICALLTYPE SetConvex(VARIANT_BOOL C)=0;
	ICALLTYPE Move(IFrame* position)=0;
	ICALLTYPE Reverse()=0;
	ICALLTYPE Complement()=0;
	ICALLTYPE Compose(TopAbs_OrientationKO Orient)=0;
	ICALLTYPE IsPartner(IKO_TopoDS_Shape* other, VARIANT_BOOL* ret)=0;
	ICALLTYPE IsSame(IKO_TopoDS_Shape* other, VARIANT_BOOL* ret)=0;
	ICALLTYPE IsEqual(IKO_TopoDS_Shape* other, VARIANT_BOOL* ret)=0;
	ICALLTYPE HashCode(int Upper, int* ret)=0;
	IUNKNOWN_
};

// {7F3662A8-362E-4A5D-A08C-91810C6A0638}
static const GUID IID_IKO_BRepExtrema_DistShapeShape = { 0x7f3662a8, 0x362e, 0x4a5d, { 0xa0, 0x8c, 0x91, 0x81, 0x0c, 0x6a, 0x06, 0x38 } };
class IKO_BRepExtrema_DistShapeShape : public IUnknown
{
public:
	ICALLTYPE Init()=0;
	ICALLTYPE Init1(IKO_TopoDS_Shape* Shape1, IKO_TopoDS_Shape* Shape2, Extrema_ExtFlagKO F, Extrema_ExtAlgoKO A)=0;
	ICALLTYPE Init2(IKO_TopoDS_Shape* Shape1, IKO_TopoDS_Shape* Shape2, double theDeflection, Extrema_ExtFlagKO F, Extrema_ExtAlgoKO A)=0;
	ICALLTYPE SetDeflection(double theDeflection)=0;
	ICALLTYPE LoadS1(IKO_TopoDS_Shape* Shape1)=0;
	ICALLTYPE LoadS2(IKO_TopoDS_Shape* Shape1)=0;
	ICALLTYPE Perform(VARIANT_BOOL* ret)=0;
	ICALLTYPE IsDone(VARIANT_BOOL* ret)=0;
	ICALLTYPE NbSolution(int* ret)=0;
	ICALLTYPE Value(double* ret)=0;
	ICALLTYPE InnerSolution(VARIANT_BOOL* ret)=0;
	ICALLTYPE PointOnShape1(int N, DIPoint* ret)=0;
	ICALLTYPE PointOnShape2(int N, DIPoint* ret)=0;
	ICALLTYPE SupportTypeShape1(int N, BRepExtrema_SupportTypeKO* ret)=0;
	ICALLTYPE SupportTypeShape2(int N, BRepExtrema_SupportTypeKO* ret)=0;
	ICALLTYPE SupportOnShape1(int N, IKO_TopoDS_Shape** ret)=0;
	ICALLTYPE SupportOnShape2(int N, IKO_TopoDS_Shape** ret)=0;
	ICALLTYPE ParOnEdgeS1(int N, double* t)=0;
	ICALLTYPE ParOnEdgeS2(int N, double* t)=0;
	ICALLTYPE ParOnFaceS1(int N, double* u, double* v)=0;
	ICALLTYPE ParOnFaceS2(int N, double* u, double* v)=0;
	ICALLTYPE SetFlag(Extrema_ExtFlagKO F)=0;
	ICALLTYPE SetAlgo(Extrema_ExtAlgoKO A)=0;
	IUNKNOWN_
};







// {994FFFC5-59E6-4357-9A06-9A6979D41A33}
static const GUID IID_IKO_TopoDS_Builder = { 0x994fffc5, 0x59e6, 0x4357, { 0x9a, 0x6, 0x9a, 0x69, 0x79, 0xd4, 0x1a, 0x33 } };
class IKO_TopoDS_Builder : public IUnknown
{
public:
	ICALLTYPE MakeWire(IKO_TopoDS_Wire* wire)=0;
	ICALLTYPE MakeShell(IKO_TopoDS_Shell* shell)=0;
	ICALLTYPE MakeSolid(IKO_TopoDS_Solid* solid)=0;
	ICALLTYPE MakeCompSolid(IKO_TopoDS_CompSolid* compSolid)=0;
	ICALLTYPE MakeCompound(IKO_TopoDS_Compound* compound)=0;
	ICALLTYPE Add(IKO_TopoDS_Shape* shapeTo, IKO_TopoDS_Shape* shapeAdded)=0;
	ICALLTYPE Remove(IKO_TopoDS_Shape* shapeFrom, IKO_TopoDS_Shape* shapeRemoved)=0;
	IUNKNOWN_
};

// {A860B1FE-F826-4D76-9659-AD6DEB1A1FA9}
static const GUID IID_IKO_TopTools_Array1OfShape = { 0xa860b1fe, 0xf826, 0x4d76, { 0x96, 0x59, 0xad, 0x6d, 0xeb, 0x1a, 0x1f, 0xa9 } };
class IKO_TopTools_Array1OfShape : public IUnknown
{
public:
	ICALLTYPE GetSize(int* size)=0;
	ICALLTYPE SetValue(int Index, IKO_TopoDS_Shape* shape)=0;
	ICALLTYPE GetValue(int Index, IKO_TopoDS_Shape** shape)=0;
	IUNKNOWN_
};


// {0488B318-6FB9-4D15-96C4-EF89972C4B03}
static const GUID IID_IKO_Graphic2d_Primitive = { 0x488b318, 0x6fb9, 0x4d15, { 0x96, 0xc4, 0xef, 0x89, 0x97, 0x2c, 0x4b, 0x3 } };
class IKO_Graphic2d_Primitive : public IUnknown
{
public:
	ICALLTYPE GetColor(float* red, float* green, float* blue)=0;
	ICALLTYPE SetColor(float red, float green, float blue)=0;
	ICALLTYPE SetDisplayMode(int aMode)=0;
	ICALLTYPE DisplayMode(int* mode)=0;
	ICALLTYPE MinMax(float* Minx, float* Maxx, float* Miny, float* Maxy, VARIANT_BOOL* success)=0;  
	ICALLTYPE IsInMinMax(float X, float Y, float aPrecision, VARIANT_BOOL* success)=0;
	IUNKNOWN_
};

// {2E1ACC1D-DE53-4B75-9A28-D547C69F18AC}
static const GUID IID_IKO_Graphic2d_Point = { 0x2e1acc1d, 0xde53, 0x4b75, { 0x9a, 0x28, 0xd5, 0x47, 0xc6, 0x9f, 0x18, 0xac } };
class IKO_Graphic2d_Point : public IUnknown
{
public:
	ICALLTYPE Init(double X, double Y, double Z)=0;
	IUNKNOWN_
};

// {2870B5A0-F1B8-4AE6-9AD6-F3CA3EB55590}
static const GUID IID_IKO_gp_Ax2d = { 0x2870b5a0, 0xf1b8, 0x4ae6, { 0x9a, 0xd6, 0xf3, 0xca, 0x3e, 0xb5, 0x55, 0x90 } };
class IKO_gp_Ax2d : public IUnknown
{
public:
	ICALLTYPE Init()=0;
	ICALLTYPE Init1(KC2D* P, KC2D* V)=0;
	ICALLTYPE SetLocation(KC2D* Locat)=0;
	ICALLTYPE SetDirection(KC2D* V)=0;
	ICALLTYPE Location(KC2D* ret)=0;
	ICALLTYPE Direction(KC2D* ret)=0;
	ICALLTYPE IsCoaxial(IKO_gp_Ax2d* Other, double AngularTolerance, double LinearTolerance, VARIANT_BOOL* ret)=0;
	ICALLTYPE IsNormal(IKO_gp_Ax2d* Other, double AngularTolerance, VARIANT_BOOL* ret)=0;
	ICALLTYPE IsOpposite(IKO_gp_Ax2d* Other, double AngularTolerance, VARIANT_BOOL* ret)=0;
	ICALLTYPE IsParallel(IKO_gp_Ax2d* Other, double AngularTolerance, VARIANT_BOOL* ret)=0;
	ICALLTYPE Angle(IKO_gp_Ax2d* Other, double* ret)=0;
	ICALLTYPE Reverse()=0;
	ICALLTYPE Reversed(IKO_gp_Ax2d** ret)=0;
	ICALLTYPE Mirror(KC2D* P)=0;
	ICALLTYPE Mirrored(KC2D* P, IKO_gp_Ax2d** ret)=0;
	ICALLTYPE Mirror1(IKO_gp_Ax2d* A)=0;
	ICALLTYPE Mirrored1(IKO_gp_Ax2d* A, IKO_gp_Ax2d** ret)=0;
	ICALLTYPE Rotate(KC2D* P, double Ang)=0;
	ICALLTYPE Rotated(KC2D* P, double Ang, IKO_gp_Ax2d** ret)=0;
	ICALLTYPE Scale(KC2D* P, double S)=0;
	ICALLTYPE Scaled(KC2D* P, double S, IKO_gp_Ax2d** ret)=0;
	ICALLTYPE Transform(IKO_gp_Trsf2d* T)=0;
	ICALLTYPE Transformed(IKO_gp_Trsf2d* T, IKO_gp_Ax2d** ret)=0;
	ICALLTYPE Translate(KC2D* V)=0;
	ICALLTYPE Translated(KC2D* V, IKO_gp_Ax2d** ret)=0;
	ICALLTYPE Translate1(KC2D* P1, KC2D* P2)=0;
	ICALLTYPE Translated1(KC2D* P1, KC2D* P2, IKO_gp_Ax2d** ret)=0;
	ICALLTYPE _CSFDB_Getgp_Ax2dloc(KC2D* ret)=0;
	ICALLTYPE _CSFDB_Getgp_Ax2dvdir(KC2D* ret)=0;
	IUNKNOWN_
};

// {00AEE18E-19E7-4E22-B673-1B56F7C57FCC}
static const GUID IID_IKO_gp_Trsf2d = { 0xaee18e, 0x19e7, 0x4e22, { 0xb6, 0x73, 0x1b, 0x56, 0xf7, 0xc5, 0x7f, 0xcc } };
class IKO_gp_Trsf2d : public IUnknown
{
public:
	ICALLTYPE Init()=0;
	ICALLTYPE Init1(IKO_gp_Trsf* T)=0;
	ICALLTYPE SetMirror(KC2D* P)=0;
	ICALLTYPE SetMirror1(IKO_gp_Ax2d* A)=0;
	ICALLTYPE SetRotation(KC2D* P, double Ang)=0;
	ICALLTYPE SetScale(KC2D* P, double S)=0;
	ICALLTYPE SetTransformation(IKO_gp_Ax2d* FromSystem1, IKO_gp_Ax2d* ToSystem2)=0;
	ICALLTYPE SetTransformation1(IKO_gp_Ax2d* ToSystem)=0;
	ICALLTYPE SetTranslation(KC2D* V)=0;
	ICALLTYPE SetTranslation1(KC2D* P1, KC2D* P2)=0;
	ICALLTYPE SetTranslationPart(KC2D* V)=0;
	ICALLTYPE SetScaleFactor(double S)=0;
	ICALLTYPE IsNegative(VARIANT_BOOL* ret)=0;
	ICALLTYPE Form(gp_TrsfFormKO* ret)=0;
	ICALLTYPE ScaleFactor(double* ret)=0;
	ICALLTYPE TranslationPart(KC2D* ret)=0;
	ICALLTYPE VectorialPart(IKO_gp_Mat2d** ret)=0;
	ICALLTYPE HVectorialPart(IKO_gp_Mat2d** ret)=0;
	ICALLTYPE RotationPart(double* ret)=0;
	ICALLTYPE Value(int Row, int Col, double* ret)=0;
	ICALLTYPE Invert()=0;
	ICALLTYPE Inverted(IKO_gp_Trsf2d** ret)=0;
	ICALLTYPE Multiplied(IKO_gp_Trsf2d* T, IKO_gp_Trsf2d** ret)=0;
	ICALLTYPE Multiply(IKO_gp_Trsf2d* T)=0;
	ICALLTYPE PreMultiply(IKO_gp_Trsf2d* T)=0;
	ICALLTYPE Power(int N)=0;
	ICALLTYPE Powered(int N, IKO_gp_Trsf2d** ret)=0;
	ICALLTYPE Transforms(double* X, double* Y)=0;
	ICALLTYPE Transforms1(KC2D* Coord)=0;
	ICALLTYPE _CSFDB_Getgp_Trsf2dscale(double* ret)=0;
	ICALLTYPE _CSFDB_Setgp_Trsf2dscale(double p)=0;
	ICALLTYPE _CSFDB_Getgp_Trsf2dshape(gp_TrsfFormKO* ret)=0;
	ICALLTYPE _CSFDB_Setgp_Trsf2dshape(gp_TrsfFormKO p)=0;
	ICALLTYPE _CSFDB_Getgp_Trsf2dmatrix(IKO_gp_Mat2d** ret)=0;
	ICALLTYPE _CSFDB_Getgp_Trsf2dloc(KC2D* ret)=0;
	IUNKNOWN_
};

// {80BAC60A-F212-4C15-A30C-B635244E81CC}
static const GUID IID_IKO_gp_GTrsf2d = { 0x80bac60a, 0xf212, 0x4c15, { 0xa3, 0x0c, 0xb6, 0x35, 0x24, 0x4e, 0x81, 0xcc } };
class IKO_gp_GTrsf2d : public IUnknown
{
public:
	ICALLTYPE Init()=0;
	ICALLTYPE Init1(IKO_gp_Trsf2d* T)=0;
	ICALLTYPE Init2(IKO_gp_Mat2d* M, KC2D* V)=0;
	ICALLTYPE SetAffinity(IKO_gp_Ax2d* A, double Ratio)=0;
	ICALLTYPE SetValue(int Row, int Col, double Value)=0;
	ICALLTYPE SetTranslationPart(KC2D* Coord)=0;
	ICALLTYPE SetTrsf2d(IKO_gp_Trsf2d* T)=0;
	ICALLTYPE SetVectorialPart(IKO_gp_Mat2d* Matrix)=0;
	ICALLTYPE IsNegative(VARIANT_BOOL* ret)=0;
	ICALLTYPE IsSingular(VARIANT_BOOL* ret)=0;
	ICALLTYPE Form(gp_TrsfFormKO* ret)=0;
	ICALLTYPE TranslationPart(KC2D* ret)=0;
	ICALLTYPE VectorialPart(IKO_gp_Mat2d** ret)=0;
	ICALLTYPE Value(int Row, int Col, double* ret)=0;
	ICALLTYPE Invert()=0;
	ICALLTYPE Inverted(IKO_gp_GTrsf2d** ret)=0;
	ICALLTYPE Multiply(IKO_gp_GTrsf2d* T)=0;
	ICALLTYPE Multiplied(IKO_gp_GTrsf2d* T, IKO_gp_GTrsf2d** ret)=0;
	ICALLTYPE PreMultiply(IKO_gp_GTrsf2d* T)=0;
	ICALLTYPE Power(int N)=0;
	ICALLTYPE Powered(int N, IKO_gp_GTrsf2d** ret)=0;
	ICALLTYPE Transforms(KC2D* Coord)=0;
	ICALLTYPE Transformed(KC2D* Coord, KC2D* ret)=0;
	ICALLTYPE Transforms1(double* X, double* Y)=0;
	ICALLTYPE Trsf2d(IKO_gp_Trsf2d** ret)=0;
	ICALLTYPE _CSFDB_Getgp_GTrsf2dmatrix(IKO_gp_Mat2d** ret)=0;
	ICALLTYPE _CSFDB_Getgp_GTrsf2dloc(KC2D* ret)=0;
	ICALLTYPE _CSFDB_Getgp_GTrsf2dshape(gp_TrsfFormKO* ret)=0;
	ICALLTYPE _CSFDB_Setgp_GTrsf2dshape(gp_TrsfFormKO p)=0;
	ICALLTYPE _CSFDB_Getgp_GTrsf2dscale(double* ret)=0;
	ICALLTYPE _CSFDB_Setgp_GTrsf2dscale(double p)=0;
	IUNKNOWN_
};

// {A2F96014-393F-409A-A92A-D03C798E453B}
static const GUID IID_IKO_gp_Lin2d = { 0xa2f96014, 0x393f, 0x409a, { 0xa9, 0x2a, 0xd0, 0x3c, 0x79, 0x8e, 0x45, 0x3b } };
class IKO_gp_Lin2d : public IUnknown
{
public:
	ICALLTYPE Init()=0;
	ICALLTYPE Init1(IKO_gp_Ax2d* A)=0;
	ICALLTYPE Init2(KC2D* P, KC2D* V)=0;
	ICALLTYPE Init3(double A, double B, double C)=0;
	ICALLTYPE Reverse()=0;
	ICALLTYPE Reversed(IKO_gp_Lin2d** ret)=0;
	ICALLTYPE SetDirection(KC2D* V)=0;
	ICALLTYPE SetLocation(KC2D* P)=0;
	ICALLTYPE SetPosition(IKO_gp_Ax2d* A)=0;
	ICALLTYPE Coefficients(double* A, double* B, double* C)=0;
	ICALLTYPE Direction(KC2D* ret)=0;
	ICALLTYPE Location(KC2D* ret)=0;
	ICALLTYPE Position(IKO_gp_Ax2d** ret)=0;
	ICALLTYPE Angle(IKO_gp_Lin2d* Other, double* ret)=0;
	ICALLTYPE Contains(KC2D* P, double LinearTolerance, VARIANT_BOOL* ret)=0;
	ICALLTYPE Distance(KC2D* P, double* ret)=0;
	ICALLTYPE Distance1(IKO_gp_Lin2d* Other, double* ret)=0;
	ICALLTYPE SquareDistance(KC2D* P, double* ret)=0;
	ICALLTYPE SquareDistance1(IKO_gp_Lin2d* Other, double* ret)=0;
	ICALLTYPE Normal(KC2D* P, IKO_gp_Lin2d** ret)=0;
	ICALLTYPE Mirror(KC2D* P)=0;
	ICALLTYPE Mirrored(KC2D* P, IKO_gp_Lin2d** ret)=0;
	ICALLTYPE Mirror1(IKO_gp_Ax2d* A)=0;
	ICALLTYPE Mirrored1(IKO_gp_Ax2d* A, IKO_gp_Lin2d** ret)=0;
	ICALLTYPE Rotate(KC2D* P, double Ang)=0;
	ICALLTYPE Rotated(KC2D* P, double Ang, IKO_gp_Lin2d** ret)=0;
	ICALLTYPE Scale(KC2D* P, double S)=0;
	ICALLTYPE Scaled(KC2D* P, double S, IKO_gp_Lin2d** ret)=0;
	ICALLTYPE Transform(IKO_gp_Trsf2d* T)=0;
	ICALLTYPE Transformed(IKO_gp_Trsf2d* T, IKO_gp_Lin2d** ret)=0;
	ICALLTYPE Translate(KC2D* V)=0;
	ICALLTYPE Translated(KC2D* V, IKO_gp_Lin2d** ret)=0;
	ICALLTYPE Translate1(KC2D* P1, KC2D* P2)=0;
	ICALLTYPE Translated1(KC2D* P1, KC2D* P2, IKO_gp_Lin2d** ret)=0;
	ICALLTYPE _CSFDB_Getgp_Lin2dpos(IKO_gp_Ax2d** ret)=0;
	IUNKNOWN_
};

// {4A6F4B21-43FC-48FE-93B3-D9B3C4875BA8}
static const GUID IID_IKO_gp_Ax22d = { 0x4a6f4b21, 0x43fc, 0x48fe, { 0x93, 0xb3, 0xd9, 0xb3, 0xc4, 0x87, 0x5b, 0xa8 } };
class IKO_gp_Ax22d : public IUnknown
{
public:
	ICALLTYPE Init()=0;
	ICALLTYPE Init1(KC2D* P, KC2D* Vx, KC2D* Vy)=0;
	ICALLTYPE Init2(KC2D* P, KC2D* V, VARIANT_BOOL Sense)=0;
	ICALLTYPE Init3(IKO_gp_Ax2d* A, VARIANT_BOOL Sense)=0;
	ICALLTYPE SetAxis(IKO_gp_Ax22d* A1)=0;
	ICALLTYPE SetXAxis(IKO_gp_Ax2d* A1)=0;
	ICALLTYPE SetYAxis(IKO_gp_Ax2d* A1)=0;
	ICALLTYPE SetLocation(KC2D* P)=0;
	ICALLTYPE SetXDirection(KC2D* Vx)=0;
	ICALLTYPE SetYDirection(KC2D* Vy)=0;
	ICALLTYPE XAxis(IKO_gp_Ax2d** ret)=0;
	ICALLTYPE YAxis(IKO_gp_Ax2d** ret)=0;
	ICALLTYPE Location(KC2D* ret)=0;
	ICALLTYPE XDirection(KC2D* ret)=0;
	ICALLTYPE YDirection(KC2D* ret)=0;
	ICALLTYPE Mirror(KC2D* P)=0;
	ICALLTYPE Mirrored(KC2D* P, IKO_gp_Ax22d** ret)=0;
	ICALLTYPE Mirror1(IKO_gp_Ax2d* A)=0;
	ICALLTYPE Mirrored1(IKO_gp_Ax2d* A, IKO_gp_Ax22d** ret)=0;
	ICALLTYPE Rotate(KC2D* P, double Ang)=0;
	ICALLTYPE Rotated(KC2D* P, double Ang, IKO_gp_Ax22d** ret)=0;
	ICALLTYPE Scale(KC2D* P, double S)=0;
	ICALLTYPE Scaled(KC2D* P, double S, IKO_gp_Ax22d** ret)=0;
	ICALLTYPE Transform(IKO_gp_Trsf2d* T)=0;
	ICALLTYPE Transformed(IKO_gp_Trsf2d* T, IKO_gp_Ax22d** ret)=0;
	ICALLTYPE Translate(KC2D* V)=0;
	ICALLTYPE Translated(KC2D* V, IKO_gp_Ax22d** ret)=0;
	ICALLTYPE Translate1(KC2D* P1, KC2D* P2)=0;
	ICALLTYPE Translated1(KC2D* P1, KC2D* P2, IKO_gp_Ax22d** ret)=0;
	ICALLTYPE _CSFDB_Getgp_Ax22dpoint(KC2D* ret)=0;
	ICALLTYPE _CSFDB_Getgp_Ax22dvydir(KC2D* ret)=0;
	ICALLTYPE _CSFDB_Getgp_Ax22dvxdir(KC2D* ret)=0;
	IUNKNOWN_
};

// {2B1C950D-A1AE-441E-AC3D-7BEC03B3F6A3}
static const GUID IID_IKO_Geom2d_Curve = { 0x2b1c950d, 0xa1ae, 0x441e, { 0xac, 0x3d, 0x7b, 0xec, 0x3, 0xb3, 0xf6, 0xa3 } };
class IKO_Geom2d_Curve : public IUnknown
{
public:
	ICALLTYPE Reverse()=0;
	ICALLTYPE ReversedParameter(double U, double* val)=0;
	ICALLTYPE TransformedParameter(double U, IKO_gp_Trsf* T, double* retVal)=0;
	ICALLTYPE ParametricTransformation(IKO_gp_Trsf* T, double* retVal)=0;
	ICALLTYPE FirstParameter(double* val)=0;
	ICALLTYPE LastParameter(double* val)=0;
	ICALLTYPE IsClosed(VARIANT_BOOL* closed)=0;
	ICALLTYPE IsPeriodic(VARIANT_BOOL* val)=0;
	ICALLTYPE Period(double* val)=0; 
	ICALLTYPE Continuity(int* GeomAbs_Shape_Continuity)=0;
	ICALLTYPE IsCN(int N, VARIANT_BOOL* val)=0;
	ICALLTYPE D0(double U, KC2D* P)=0;
	ICALLTYPE D1(double U, KC2D* P, KC2D* V1)=0;
	ICALLTYPE D2(double U, KC2D* P, KC2D* V1, KC2D* V2)=0;
	ICALLTYPE D3(double U, KC2D* P, KC2D* V1, KC2D* V2, KC2D* V3)=0;
	ICALLTYPE DN(double U, int N, KC2D* val)=0;
	ICALLTYPE Value(double U, KC2D* val)=0;
	IUNKNOWN_
};

// {D8526C00-CD02-47BC-AA5F-2E0FF767BF06}
static const GUID IID_IKO_Geom2d_Conic = { 0xd8526c00, 0xcd02, 0x47bc, { 0xaa, 0x5f, 0x2e, 0x0f, 0xf7, 0x67, 0xbf, 0x06 } };
class IKO_Geom2d_Conic : public IUnknown
{
public:
	ICALLTYPE SetAxis(IKO_gp_Ax22d* A)=0;
	ICALLTYPE SetXAxis(IKO_gp_Ax2d* A)=0;
	ICALLTYPE SetYAxis(IKO_gp_Ax2d* A)=0;
	ICALLTYPE SetLocation(KC2D* P)=0;
	ICALLTYPE XAxis(IKO_gp_Ax2d** ret)=0;
	ICALLTYPE YAxis(IKO_gp_Ax2d** ret)=0;
	ICALLTYPE Eccentricity(double* ret)=0;
	ICALLTYPE Location(KC2D* ret)=0;
	ICALLTYPE Position(IKO_gp_Ax22d** ret)=0;
	ICALLTYPE Reverse()=0;
	ICALLTYPE ReversedParameter(double U, double* ret)=0;
	ICALLTYPE Continuity(GeomAbs_ShapeKO* ret)=0;
	ICALLTYPE IsCN(int N, VARIANT_BOOL* ret)=0;
	IUNKNOWN_
};

// {F0C3A686-68A2-49FE-9702-BBEBC5B34CD1}
static const GUID IID_IKO_Geom2d_Geometry = { 0xf0c3a686, 0x68a2, 0x49fe, { 0x97, 0x02, 0xbb, 0xeb, 0xc5, 0xb3, 0x4c, 0xd1 } };
class IKO_Geom2d_Geometry : public IUnknown
{
public:
	ICALLTYPE Mirror(KC2D* P)=0;
	ICALLTYPE Mirror1(IKO_gp_Ax2d* A)=0;
	ICALLTYPE Rotate(KC2D* P, double Ang)=0;
	ICALLTYPE Scale(KC2D* P, double S)=0;
	ICALLTYPE Translate(KC2D* V)=0;
	ICALLTYPE Translate1(KC2D* P1, KC2D* P2)=0;
	ICALLTYPE Transform(IKO_gp_Trsf2d* T)=0;
	ICALLTYPE Mirrored(KC2D* P, IKO_Geom2d_Geometry** ret)=0;
	ICALLTYPE Mirrored1(IKO_gp_Ax2d* A, IKO_Geom2d_Geometry** ret)=0;
	ICALLTYPE Rotated(KC2D* P, double Ang, IKO_Geom2d_Geometry** ret)=0;
	ICALLTYPE Scaled(KC2D* P, double S, IKO_Geom2d_Geometry** ret)=0;
	ICALLTYPE Transformed(IKO_gp_Trsf2d* T, IKO_Geom2d_Geometry** ret)=0;
	ICALLTYPE Translated(KC2D* V, IKO_Geom2d_Geometry** ret)=0;
	ICALLTYPE Translated1(KC2D* P1, KC2D* P2, IKO_Geom2d_Geometry** ret)=0;
	ICALLTYPE Copy(IKO_Geom2d_Geometry** ret)=0;
	IUNKNOWN_
};

// {4FE698EA-DF25-41C7-B5FA-1A06815D285A}
static const GUID IID_IKO_Geom2d_Line = { 0x4fe698ea, 0xdf25, 0x41c7, { 0xb5, 0xfa, 0x1a, 0x06, 0x81, 0x5d, 0x28, 0x5a } };
class IKO_Geom2d_Line : public IUnknown
{
public:
	ICALLTYPE Init(IKO_gp_Ax2d* A)=0;
	ICALLTYPE Init1(IKO_gp_Lin2d* L)=0;
	ICALLTYPE Init2(KC2D* P, KC2D* V)=0;
	ICALLTYPE SetLin2d(IKO_gp_Lin2d* L)=0;
	ICALLTYPE SetDirection(KC2D* V)=0;
	ICALLTYPE Direction(KC2D* ret)=0;
	ICALLTYPE SetLocation(KC2D* P)=0;
	ICALLTYPE Location(KC2D* ret)=0;
	ICALLTYPE SetPosition(IKO_gp_Ax2d* A)=0;
	ICALLTYPE Position(IKO_gp_Ax2d** ret)=0;
	ICALLTYPE Lin2d(IKO_gp_Lin2d** ret)=0;
	ICALLTYPE Reverse()=0;
	ICALLTYPE ReversedParameter(double U, double* ret)=0;
	ICALLTYPE FirstParameter(double* ret)=0;
	ICALLTYPE LastParameter(double* ret)=0;
	ICALLTYPE IsClosed(VARIANT_BOOL* ret)=0;
	ICALLTYPE IsPeriodic(VARIANT_BOOL* ret)=0;
	ICALLTYPE Continuity(GeomAbs_ShapeKO* ret)=0;
	ICALLTYPE Distance(KC2D* P, double* ret)=0;
	ICALLTYPE IsCN(int N, VARIANT_BOOL* ret)=0;
	ICALLTYPE D0(double U, KC2D* P)=0;
	ICALLTYPE D1(double U, KC2D* P, KC2D* V1)=0;
	ICALLTYPE D2(double U, KC2D* P, KC2D* V1, KC2D* V2)=0;
	ICALLTYPE D3(double U, KC2D* P, KC2D* V1, KC2D* V2, KC2D* V3)=0;
	ICALLTYPE DN(double U, int N, KC2D* ret)=0;
	ICALLTYPE Transform(IKO_gp_Trsf2d* T)=0;
	ICALLTYPE TransformedParameter(double U, IKO_gp_Trsf2d* T, double* ret)=0;
	ICALLTYPE ParametricTransformation(IKO_gp_Trsf2d* T, double* ret)=0;
	ICALLTYPE Copy(IKO_Geom2d_Geometry** ret)=0;
	IUNKNOWN_
};

// {A4AC8C49-DD99-4A62-896F-241E6F645CB3}
static const GUID IID_IKO_gp_Circ2d = { 0xa4ac8c49, 0xdd99, 0x4a62, { 0x89, 0x6f, 0x24, 0x1e, 0x6f, 0x64, 0x5c, 0xb3 } };
class IKO_gp_Circ2d : public IUnknown
{
public:
	ICALLTYPE Init()=0;
	ICALLTYPE Init1(IKO_gp_Ax2d* XAxis, double Radius, VARIANT_BOOL Sense)=0;
	ICALLTYPE Init2(IKO_gp_Ax22d* Axis, double Radius)=0;
	ICALLTYPE SetLocation(KC2D* P)=0;
	ICALLTYPE SetXAxis(IKO_gp_Ax2d* A)=0;
	ICALLTYPE SetAxis(IKO_gp_Ax22d* A)=0;
	ICALLTYPE SetYAxis(IKO_gp_Ax2d* A)=0;
	ICALLTYPE SetRadius(double Radius)=0;
	ICALLTYPE Area(double* ret)=0;
	ICALLTYPE Coefficients(double* A, double* B, double* C, double* D, double* E, double* F)=0;
	ICALLTYPE Contains(KC2D* P, double LinearTolerance, VARIANT_BOOL* ret)=0;
	ICALLTYPE Distance(KC2D* P, double* ret)=0;
	ICALLTYPE SquareDistance(KC2D* P, double* ret)=0;
	ICALLTYPE Length(double* ret)=0;
	ICALLTYPE Location(KC2D* ret)=0;
	ICALLTYPE Radius(double* ret)=0;
	ICALLTYPE Axis(IKO_gp_Ax22d** ret)=0;
	ICALLTYPE Position(IKO_gp_Ax22d** ret)=0;
	ICALLTYPE XAxis(IKO_gp_Ax2d** ret)=0;
	ICALLTYPE YAxis(IKO_gp_Ax2d** ret)=0;
	ICALLTYPE Reverse()=0;
	ICALLTYPE Reversed(IKO_gp_Circ2d** ret)=0;
	ICALLTYPE IsDirect(VARIANT_BOOL* ret)=0;
	ICALLTYPE Mirror(KC2D* P)=0;
	ICALLTYPE Mirrored(KC2D* P, IKO_gp_Circ2d** ret)=0;
	ICALLTYPE Mirror1(IKO_gp_Ax2d* A)=0;
	ICALLTYPE Mirrored1(IKO_gp_Ax2d* A, IKO_gp_Circ2d** ret)=0;
	ICALLTYPE Rotate(KC2D* P, double Ang)=0;
	ICALLTYPE Rotated(KC2D* P, double Ang, IKO_gp_Circ2d** ret)=0;
	ICALLTYPE Scale(KC2D* P, double S)=0;
	ICALLTYPE Scaled(KC2D* P, double S, IKO_gp_Circ2d** ret)=0;
	ICALLTYPE Transform(IKO_gp_Trsf2d* T)=0;
	ICALLTYPE Transformed(IKO_gp_Trsf2d* T, IKO_gp_Circ2d** ret)=0;
	ICALLTYPE Translate(KC2D* V)=0;
	ICALLTYPE Translated(KC2D* V, IKO_gp_Circ2d** ret)=0;
	ICALLTYPE Translate1(KC2D* P1, KC2D* P2)=0;
	ICALLTYPE Translated1(KC2D* P1, KC2D* P2, IKO_gp_Circ2d** ret)=0;
	ICALLTYPE _CSFDB_Getgp_Circ2dpos(IKO_gp_Ax22d** ret)=0;
	ICALLTYPE _CSFDB_Getgp_Circ2dradius(double* ret)=0;
	ICALLTYPE _CSFDB_Setgp_Circ2dradius(double p)=0;
	IUNKNOWN_
};

// {8C7954F1-783E-47E5-9E22-1148A607EEFC}
static const GUID IID_IKO_Geom2d_Circle = { 0x8c7954f1, 0x783e, 0x47e5, { 0x9e, 0x22, 0x11, 0x48, 0xa6, 0x7, 0xee, 0xfc } };
class IKO_Geom2d_Circle : public IUnknown
{
public:
	ICALLTYPE Init(IKO_gp_Circ2d* C)=0;
	ICALLTYPE Init1(IKO_gp_Ax2d* A, double Radius, VARIANT_BOOL Sense)=0;
	ICALLTYPE Init2(IKO_gp_Ax22d* A, double Radius)=0;
	ICALLTYPE SetCirc2d(IKO_gp_Circ2d* C)=0;
	ICALLTYPE SetRadius(double R)=0;
	ICALLTYPE Circ2d(IKO_gp_Circ2d** ret)=0;
	ICALLTYPE Radius(double* ret)=0;
	ICALLTYPE ReversedParameter(double U, double* ret)=0;
	ICALLTYPE Eccentricity(double* ret)=0;
	ICALLTYPE FirstParameter(double* ret)=0;
	ICALLTYPE LastParameter(double* ret)=0;
	ICALLTYPE IsClosed(VARIANT_BOOL* ret)=0;
	ICALLTYPE IsPeriodic(VARIANT_BOOL* ret)=0;
	ICALLTYPE D0(double U, KC2D* P)=0;
	ICALLTYPE D1(double U, KC2D* P, KC2D* V1)=0;
	ICALLTYPE D2(double U, KC2D* P, KC2D* V1, KC2D* V2)=0;
	ICALLTYPE D3(double U, KC2D* P, KC2D* V1, KC2D* V2, KC2D* V3)=0;
	ICALLTYPE DN(double U, int N, KC2D* ret)=0;
	ICALLTYPE Transform(IKO_gp_Trsf2d* T)=0;
	ICALLTYPE Copy(IKO_Geom2d_Geometry** ret)=0;
	IUNKNOWN_
};

// {8FC72FAF-6975-41D5-852A-F7C89D6824DB}
static const GUID IID_IKO_Graphic2d_Text = { 0x8fc72faf, 0x6975, 0x41d5, { 0x85, 0x2a, 0xf7, 0xc8, 0x9d, 0x68, 0x24, 0xdb } };
class IKO_Graphic2d_Text : public IUnknown
{
public:
	ICALLTYPE Init(BSTR aText, double X, double Y, double Z, int Aspect_TypeOfText_0_Solid_1_Outline, double angleSlant_0_default, int colorIndex_1_default, int fontIndex_1_default, double aScale_1_default)=0;
	ICALLTYPE GetText(BSTR *text)=0;
	ICALLTYPE SetText(BSTR text)=0; 
	ICALLTYPE GetCoord(double* X, double* Y, double* Z)=0;
	ICALLTYPE SetCoord(double X, double Y, double Z)=0;
	ICALLTYPE GetTypeOfText(int* Aspect_TypeOfText_0_Solid_1_Outline)=0; 
	ICALLTYPE SetTypeOfText(int Aspect_TypeOfText_0_Solid_1_Outline)=0;
	ICALLTYPE GetAngle(double* angle)=0; 
	ICALLTYPE SetAngle(double aNewAngle)=0;
	ICALLTYPE GetSlant(double* slant)=0; 
	ICALLTYPE SetSlant(double angleSlant_0_default)=0;
	ICALLTYPE GetFontIndex(int* index)=0; 
	ICALLTYPE SetFontIndex(int index)=0; 
	ICALLTYPE GetScale(double* scale)=0; 
	ICALLTYPE SetScale(double scale)=0; 
	IUNKNOWN_
};

// {8F5C775C-3730-4FB7-BE1E-F3D58B9F5917}
static const GUID IID_IKO_Geom_Geometry = { 0x8f5c775c, 0x3730, 0x4fb7, { 0xbe, 0x1e, 0xf3, 0xd5, 0x8b, 0x9f, 0x59, 0x17 } };
class IKO_Geom_Geometry : public IUnknown
{
public:
	ICALLTYPE Mirror(DIPoint* pt)=0;
	ICALLTYPE Scale(DIPoint* pt, double S)=0;
	ICALLTYPE Translate( DIVect* V)=0;
	ICALLTYPE Translate2(DIPoint* pt1, DIPoint* pt2)=0;
	ICALLTYPE Transform(IKO_gp_Trsf* T)=0;
	IUNKNOWN_
};

// {05EC5404-9D05-4278-88D0-6DFD6385A11E}
static const GUID IID_IKO_JetUnivar = { 0x5ec5404, 0x9d05, 0x4278, { 0x88, 0xd0, 0x6d, 0xfd, 0x63, 0x85, 0xa1, 0x1e } };
class IKO_JetUnivar : public IUnknown
{
public:
	ICALLTYPE D0(double U,  DIPoint* P)=0; 
	ICALLTYPE D1(double U,  DIPoint* P, DIVect* V1)=0; 
	ICALLTYPE D2(double U,  DIPoint* P, DIVect* V1, DIVect* V2)=0; 
	ICALLTYPE D3(double U,  DIPoint* P, DIVect* V1, DIVect* V2, DIVect* V3)=0; 
	ICALLTYPE DN(double U, int N, DIVect* V)=0;
	IUNKNOWN_
};
// {B2239E42-542F-458E-A8DB-2114A0651259}
static const GUID IID_IKO_Geom_Line = { 0xb2239e42, 0x542f, 0x458e, { 0xa8, 0xdb, 0x21, 0x14, 0xa0, 0x65, 0x12, 0x59 } };
class IKO_Geom_Line : public IUnknown
{
public:
	ICALLTYPE Init(IKO_gp_Ax1* A1)=0;
	ICALLTYPE Init2(IKO_gp_Lin* L)=0;
	ICALLTYPE Init3(DIPoint* P, DIVect* V)=0;
	ICALLTYPE SetDirection(DIVect* V)=0;
	ICALLTYPE SetLocation( DIPoint* P)=0;
	ICALLTYPE SetPosition(IKO_gp_Ax1* A1)=0;
	ICALLTYPE Position(IKO_gp_Ax1** posn)=0; 
	ICALLTYPE Reverse()=0;
	ICALLTYPE ReversedParameter(double U, double* val)=0; 
	ICALLTYPE FirstParameter(double* val)=0; 
	ICALLTYPE LastParameter(double* val)=0; 
	ICALLTYPE IsClosed(VARIANT_BOOL* ret)=0; 
	ICALLTYPE IsPeriodic(VARIANT_BOOL* ret)=0; 
	ICALLTYPE Continuity(int* GeomAbs_Shape_retVal)=0; 
	ICALLTYPE IsCN(int N, VARIANT_BOOL* ret)=0; 
	ICALLTYPE GetDs(IKO_JetUnivar** T)=0;
	ICALLTYPE Transform(IKO_gp_Trsf* T)=0;
	ICALLTYPE TransformedParameter(double U, IKO_gp_Trsf* T, double* val)=0; 
	ICALLTYPE ParametricTransformation(IKO_gp_Trsf* T, double* val)=0; 
	ICALLTYPE Copy(IKO_Geom_Geometry** replica)=0; 
	IUNKNOWN_
};
// {DE7D9CDD-84A5-43B4-9126-3B7BD3A1063F}
static const GUID IID_IKO_Geom_Circle = { 0xde7d9cdd, 0x84a5, 0x43b4, { 0x91, 0x26, 0x3b, 0x7b, 0xd3, 0xa1, 0x6, 0x3f } };
class IKO_Geom_Circle : public IUnknown
{
public:
	ICALLTYPE Init(IKO_gp_Circ* C)=0;
	ICALLTYPE Init2(IKO_gp_Ax2* A2, double radius)=0;
	ICALLTYPE SetCirc(IKO_gp_Circ* C)=0;
	ICALLTYPE SetRadius(double R)=0;
	ICALLTYPE Circ(IKO_gp_Circ** ret)=0;
	ICALLTYPE Radius(double* ret)=0;
	ICALLTYPE ReversedParameter(double U, double* ret)=0;
	ICALLTYPE Eccentricity(double* ret)=0;
	ICALLTYPE FirstParameter(double* ret)=0;
	ICALLTYPE LastParameter(double* ret)=0;
	ICALLTYPE IsClosed(VARIANT_BOOL* ret)=0;
	ICALLTYPE IsPeriodic(VARIANT_BOOL* ret)=0;
	ICALLTYPE GetDs(IKO_JetUnivar** T)=0;
	ICALLTYPE Transform(IKO_gp_Trsf* T)=0;
	ICALLTYPE Copy(IKO_Geom_Geometry** ret)=0;
	IUNKNOWN_
};

// {A39746F3-435E-4994-B346-B7B3BDD20295}
static const GUID IID_IKO_Geom_Curve = { 0xa39746f3, 0x435e, 0x4994, { 0xb3, 0x46, 0xb7, 0xb3, 0xbd, 0xd2, 0x2, 0x95 } };
class IKO_Geom_Curve : public IUnknown
{
public:
	ICALLTYPE Reverse()=0;
	ICALLTYPE ReversedParameter(double U, double* retVal)=0;
	ICALLTYPE TransformedParameter(double U, IKO_gp_Trsf* T, double* retVal)=0;
	ICALLTYPE ParametricTransformation(IKO_gp_Trsf* T, double* retVal)=0;
	ICALLTYPE FirstParameter(double* retVal)=0;
	ICALLTYPE LastParameter(double* retVal)=0;
	ICALLTYPE IsClosed(VARIANT_BOOL* retVal)=0;
	ICALLTYPE IsPeriodic(VARIANT_BOOL* retVal)=0;
	ICALLTYPE Period(double* retVal)=0;
	ICALLTYPE Continuity(int* GeomAbs_Shape_retVal)=0;
	ICALLTYPE IsCN(int N, VARIANT_BOOL* retVal)=0;
	ICALLTYPE D0(double U, DIPoint* P)=0;
	ICALLTYPE D1(double U, DIPoint* P, DIVect* V1)=0;
	ICALLTYPE D2(double U, DIPoint* P, DIVect* V1, DIVect* V2)=0;
	ICALLTYPE D3(double U, DIPoint* P, DIVect* V1, DIVect* V2, DIVect* V3)=0;
	ICALLTYPE DN(double U, int N, DIVect* V)=0;
	ICALLTYPE Value(double U, DIPoint* pt)=0;
	IUNKNOWN_
};
// {18562717-ECF6-4765-BE35-2C53CBD9609B}
static const GUID IID_IKO_JetBivar = { 0x18562717, 0xecf6, 0x4765, { 0xbe, 0x35, 0x2c, 0x53, 0xcb, 0xd9, 0x60, 0x9b } };
class IKO_JetBivar : public IUnknown
{
public:
	ICALLTYPE D0(double U, double V, DIPoint* P)=0; 
	ICALLTYPE D1(double U, double V, DIPoint* P, DIVect* D1U, DIVect* D1V)=0; 
	ICALLTYPE D2(double U, double V, DIPoint* P, DIVect* D1U, DIVect* D1V, DIVect* D2U, DIVect* D2V, DIVect* D2UV)=0; 
	ICALLTYPE D3(double U, double V, DIPoint* P, DIVect* D1U, DIVect* D1V, DIVect* D2U, DIVect* D2UV, DIVect* D2V, DIVect* D3U, DIVect* D3V, DIVect* D3UUV, DIVect* D3UVV)=0; 
	ICALLTYPE DN(double U, double V, int Nu, int Nv, DIVect* der)=0;
	IUNKNOWN_
};
// {3A195FD7-0FC4-4301-BC4C-01EAEEDE5C03}
static const GUID IID_IKO_Geom_Plane = { 0x3a195fd7, 0xfc4, 0x4301, { 0xbc, 0x4c, 0x1, 0xea, 0xee, 0xde, 0x5c, 0x3 } };
class IKO_Geom_Plane : public IUnknown
{
public:
	ICALLTYPE Init(IKO_gp_Ax3* A3)=0;
	ICALLTYPE Init1(IKO_gp_Pln* Pl)=0;
	ICALLTYPE Init2(DIPoint* P, DIVect* V)=0;
	ICALLTYPE Init3(double A, double B, double C, double D)=0;
	ICALLTYPE SetPln(IKO_gp_Pln* Pl)=0;
	ICALLTYPE Pln(IKO_gp_Pln** ret)=0;
	ICALLTYPE UReverse()=0;
	ICALLTYPE UReversedParameter(double U, double* ret)=0;
	ICALLTYPE VReverse()=0;
	ICALLTYPE VReversedParameter(double V, double* ret)=0;
	ICALLTYPE TransformParameters(double* U, double* V, IKO_gp_Trsf* T)=0;
	ICALLTYPE Bounds(double* U1, double* U2, double* V1, double* V2)=0;
	ICALLTYPE Coefficients(double* A, double* B, double* C, double* D)=0;
	ICALLTYPE UIso(double U, IKO_Geom_Curve** ret)=0;
	ICALLTYPE VIso(double V, IKO_Geom_Curve** ret)=0;
	ICALLTYPE GetDs(IKO_JetBivar** J)=0;
	IUNKNOWN_
};
// {8CD4D0AF-5385-44AC-B358-A4B4311B6664}
static const GUID IID_IKO_Geom_BSplineCurve = { 0x8cd4d0af, 0x5385, 0x44ac, { 0xb3, 0x58, 0xa4, 0xb4, 0x31, 0x1b, 0x66, 0x64 } };
class IKO_Geom_BSplineCurve : public IUnknown
{
public:
	ICALLTYPE Init(IKO_TColgp_Array1OfPnt* Poles, IKO_TColStd_Array1OfReal* Knots, IKO_TColStd_Array1OfInteger* Multiplicities, int Degree, VARIANT_BOOL Periodic)=0;
	ICALLTYPE Init2(IKO_TColgp_Array1OfPnt* Poles, IKO_TColStd_Array1OfReal* Weights, IKO_TColStd_Array1OfReal* Knots, IKO_TColStd_Array1OfInteger* Multiplicities, int Degree, VARIANT_BOOL Periodic, VARIANT_BOOL CheckRational)=0;
	ICALLTYPE IncreaseDegree(int Degree)=0;
	ICALLTYPE IncreaseMultiplicity(int Index, int M)=0;
	ICALLTYPE IncreaseMultiplicity2(int I1, int I2, int M)=0;
	ICALLTYPE InsertKnot(double U, int M, double ParametricTolerance, VARIANT_BOOL Add)=0;
	ICALLTYPE InsertKnots(IKO_TColStd_Array1OfReal* Knots, IKO_TColStd_Array1OfInteger* Mults, double ParametricTolerance, VARIANT_BOOL Add)=0;
	ICALLTYPE RemoveKnot(int Index, int M, double Tolerance)=0;
	ICALLTYPE Reverse()=0;
	ICALLTYPE Segment(double U1, double U2)=0;
	ICALLTYPE SetKnot(int Index, double K)=0;
	ICALLTYPE SetKnots(IKO_TColStd_Array1OfReal* K)=0;
	ICALLTYPE SetKnot2(int Index, double K, int M)=0;
	ICALLTYPE PeriodicNormalization(double* U)=0;  
	ICALLTYPE SetPeriodic()=0;
	ICALLTYPE SetOrigin(int Index)=0;
	ICALLTYPE SetOrigin2(double U, double Tol)=0;
	ICALLTYPE SetNotPeriodic()=0;
	ICALLTYPE SetPole(int Index, DIPoint* P)=0;
	ICALLTYPE SetPole2(int Index, DIPoint* P, double Weight)=0;
	ICALLTYPE SetWeight(int Index, double Weight)=0;
	ICALLTYPE MovePoint(double U, DIPoint* P, int Index1, int Index2, int* FirstModifiedPole, int* LastModifiedPole)=0;
	ICALLTYPE MovePointAndTangent(double U, DIPoint* P, DIVect* Tangent, double Tolerance, int StartingCondition, int EndingCondition, int* ErrorStatus)=0;
	ICALLTYPE IsCN(int N, VARIANT_BOOL* ret)=0;  
	ICALLTYPE IsClosed( VARIANT_BOOL* closed)=0;  
	ICALLTYPE IsPeriodic( VARIANT_BOOL* periodic)=0;  
	ICALLTYPE IsRational( VARIANT_BOOL* rational)=0;  
	ICALLTYPE Continuity(int* continuity)=0;  
	ICALLTYPE Degree(int* degree)=0;
	ICALLTYPE D0(double U, DIPoint* P)=0;  
	ICALLTYPE D1(double U, DIPoint* P, DIVect* V1)=0;  
	ICALLTYPE D2(double U, DIPoint* P, DIVect* V1, DIVect* V2)=0;  
	ICALLTYPE D3(double U, DIPoint* P, DIVect* V1, DIVect* V2, DIVect* V3)=0;
	ICALLTYPE DN(double U, int N, DIVect* V)=0;
	/*ICALLTYPE LocalValue(double U, int FromK1, int ToK2, DIPoint* pnt)=0;  
	ICALLTYPE LocalD0(double U, int FromK1, int ToK2, DIPoint* P)=0;  
	ICALLTYPE LocalD1(double U, int FromK1, int ToK2, DIPoint* P, DIVect* V1)=0;  
	ICALLTYPE LocalD2(double U, int FromK1, int ToK2, DIPoint* P, DIVect* V1, DIVect* V2)=0;  
	ICALLTYPE LocalD3(double U, int FromK1, int ToK2, DIPoint* P, DIVect* V1, DIVect* V2, DIVect* V3)=0;  
	ICALLTYPE LocalDN(double U, int FromK1, int ToK2, int N, DIVect* ret)=0;  */
	ICALLTYPE EndPoint(DIPoint* P)=0;  
	ICALLTYPE FirstUKnotIndex(int* ind)=0;  
	ICALLTYPE FirstParameter(double* t)=0;  
	ICALLTYPE Knot(int Index, double* t)=0;  
	ICALLTYPE Knots(IKO_TColStd_Array1OfReal* K)=0;  
	ICALLTYPE KnotSequence(IKO_TColStd_Array1OfReal* K)=0;
	ICALLTYPE KnotDistribution(int* GeomAbs_BSplKnotDistribution_retVal)=0;
	ICALLTYPE LastUKnotIndex(int* retVal)=0;
	ICALLTYPE LastParameter(double* t)=0;  
	ICALLTYPE LocateU(double U, double ParametricTolerance, int* I1, int* I2, VARIANT_BOOL WithKnotRepetition)=0;  
	ICALLTYPE Multiplicity(int Index, int* multiplicity)=0;  
	ICALLTYPE Multiplicities(IKO_TColStd_Array1OfInteger* iArr)=0;  
	ICALLTYPE NbKnots(int* count)=0;  
	ICALLTYPE NbPoles(int* count)=0;  
	ICALLTYPE Pole(int Index, DIPoint* P)=0;  
	ICALLTYPE Poles(IKO_TColgp_Array1OfPnt** iArr)=0;  
	ICALLTYPE StartPoint(DIPoint* P)=0;  
	ICALLTYPE Weight(int Index, double* weight)=0;  
	ICALLTYPE Weights(IKO_TColStd_Array1OfReal* W)=0;  
	ICALLTYPE Resolution(double Tolerance3D, double* UTolerance)=0;
	IUNKNOWN_
};

// {43ED6219-56B1-4A9C-9E24-32441C827500}
static const GUID IID_IKO_Geom_Surface = { 0x43ed6219, 0x56b1, 0x4a9c, { 0x9e, 0x24, 0x32, 0x44, 0x1c, 0x82, 0x75, 0x0 } };
class IKO_Geom_Surface : public IUnknown
{
public:
	ICALLTYPE UReverse()=0;
	ICALLTYPE VReverse()=0; 
	ICALLTYPE TransformParameters(double* U, double* V, IKO_gp_Trsf* T)=0;  
	ICALLTYPE Bounds(double* U1, double* U2, double* V1, double* V2)=0;
	ICALLTYPE IsUClosed(VARIANT_BOOL* retVal)=0;
	ICALLTYPE IsVClosed(VARIANT_BOOL* retVal)=0;
	ICALLTYPE IsUPeriodic(VARIANT_BOOL* retVal)=0;
	ICALLTYPE UPeriod(double* retVal)=0;
	ICALLTYPE IsVPeriodic(VARIANT_BOOL* retVal)=0;
	ICALLTYPE VPeriod(double* retVal)=0;
	ICALLTYPE UIso(double U, IKO_Geom_Curve* curve)=0;
	ICALLTYPE VIso(double V, IKO_Geom_Curve* curve)=0;
	ICALLTYPE Continuity(int* GeomAbs_Shape_retVal)=0;
	ICALLTYPE IsCNu(int N, VARIANT_BOOL* retVal)=0;
	ICALLTYPE IsCNv(int N, VARIANT_BOOL* retVal)=0;
	ICALLTYPE D0(double U, double V, DIPoint* P)=0;
	ICALLTYPE D1(double U, double V, DIPoint* P, DIVect*D1U, DIVect*D1V)=0;
	ICALLTYPE D2(double U, double V, DIPoint* P, DIVect*D1U, DIVect*D1V, DIVect*D2U, DIVect*D2V, DIVect*D2UV)=0;
	ICALLTYPE D3(double U, double V, DIPoint* P, DIVect*D1U, DIVect*D1V, DIVect*D2U, DIVect*D2V, DIVect*D2UV, DIVect*D3U, DIVect*D3V, DIVect*D3UUV, DIVect*D3UVV)=0;
	ICALLTYPE DN(double U, double V, int Nu, int Nv, DIVect* retVal)=0;
	ICALLTYPE Value(double U, double V, DIPoint* retVal)=0;
	IUNKNOWN_
};

// {22D42713-1E0C-4929-8FB7-B3AFEA865444}
static const GUID IID_IKO_Geom_ElementarySurface = { 0x22d42713, 0x1e0c, 0x4929, { 0x8f, 0xb7, 0xb3, 0xaf, 0xea, 0x86, 0x54, 0x44 } };
class IKO_Geom_ElementarySurface : public IUnknown
{
public:
	ICALLTYPE SetAxis(IKO_gp_Ax1* A1)=0;
	ICALLTYPE SetLocation(DIPoint* Loc)=0;
	ICALLTYPE SetPosition(IKO_gp_Ax3* A3)=0;
	ICALLTYPE Axis(IKO_gp_Ax1** ret)=0;
	ICALLTYPE Location(DIPoint* ret)=0;
	ICALLTYPE Position(IKO_gp_Ax3** ret)=0;
	ICALLTYPE UReverse()=0;
	ICALLTYPE UReversedParameter(double U, double* ret)=0;
	ICALLTYPE VReverse()=0;
	ICALLTYPE VReversedParameter(double V, double* ret)=0;
	ICALLTYPE Continuity(GeomAbs_ShapeKO* ret)=0;
	ICALLTYPE IsCNu(int N, VARIANT_BOOL* ret)=0;
	ICALLTYPE IsCNv(int N, VARIANT_BOOL* ret)=0;
	IUNKNOWN_
};

// {7204C506-F3BE-4668-AF27-A0F4AF950E5D}
static const GUID IID_IKO_Geom_CylindricalSurface = { 0x7204c506, 0xf3be, 0x4668, { 0xaf, 0x27, 0xa0, 0xf4, 0xaf, 0x95, 0xe, 0x5d } };
class IKO_Geom_CylindricalSurface : public IUnknown
{
public:
	ICALLTYPE Init(IKO_gp_Ax3* A3, double Radius)=0;
	ICALLTYPE Init1(IKO_gp_Cylinder* C)=0;
	ICALLTYPE SetCylinder(IKO_gp_Cylinder* C)=0;
	ICALLTYPE SetRadius(double R)=0;
	ICALLTYPE Cylinder(IKO_gp_Cylinder** ret)=0;
	ICALLTYPE UReversedParameter(double U, double* ret)=0;
	ICALLTYPE VReversedParameter(double V, double* ret)=0;
	ICALLTYPE TransformParameters(double* U, double* V, IKO_gp_Trsf* T)=0;
	ICALLTYPE ParametricTransformation(IKO_gp_Trsf* T, IKO_gp_GTrsf2d** ret)=0;
	ICALLTYPE Bounds(double* U1, double* U2, double* V1, double* V2)=0;
	ICALLTYPE Coefficients(double* A1, double* A2, double* A3, double* B1, double* B2, double* B3, double* C1, double* C2, double* C3, double* D)=0;
	ICALLTYPE Radius(double* ret)=0;
	ICALLTYPE IsUClosed(VARIANT_BOOL* ret)=0;
	ICALLTYPE IsVClosed(VARIANT_BOOL* ret)=0;
	ICALLTYPE IsUPeriodic(VARIANT_BOOL* ret)=0;
	ICALLTYPE IsVPeriodic(VARIANT_BOOL* ret)=0;
	ICALLTYPE UIso(double U, IKO_Geom_Curve** ret)=0;
	ICALLTYPE VIso(double V, IKO_Geom_Curve** ret)=0;
	ICALLTYPE D0(double U, double V, DIPoint* P)=0;
	ICALLTYPE D1(double U, double V, DIPoint* P, DIVect* D1U, DIVect* D1V)=0;
	ICALLTYPE D2(double U, double V, DIPoint* P, DIVect* D1U, DIVect* D1V, DIVect* D2U, DIVect* D2V, DIVect* D2UV)=0;
	ICALLTYPE D3(double U, double V, DIPoint* P, DIVect* D1U, DIVect* D1V, DIVect* D2U, DIVect* D2V, DIVect* D2UV, DIVect* D3U, DIVect* D3V, DIVect* D3UUV, DIVect* D3UVV)=0;
	ICALLTYPE DN(double U, double V, int Nu, int Nv, DIVect* ret)=0;
	ICALLTYPE Transform(IKO_gp_Trsf* T)=0;
	ICALLTYPE Copy(IKO_Geom_Geometry** ret)=0;
	IUNKNOWN_
};

// {E9C8466C-2A6E-4425-A30B-315D7DDCC4C5}
static const GUID IID_IKO_Geom_BSplineSurface = { 0xe9c8466c, 0x2a6e, 0x4425, { 0xa3, 0xb, 0x31, 0x5d, 0x7d, 0xdc, 0xc4, 0xc5 } };
class IKO_Geom_BSplineSurface : public IUnknown
{
public:
	ICALLTYPE Init(IKO_TColgp_Array2OfPnt* Poles, IKO_TColStd_Array1OfReal* UKnots, IKO_TColStd_Array1OfReal* VKnots, IKO_TColStd_Array1OfInteger* UMults, IKO_TColStd_Array1OfInteger* VMults, int UDegree, int VDegree, VARIANT_BOOL UPeriodic_deft_false, VARIANT_BOOL VPeriodic_deft_false)=0;
	ICALLTYPE Init2(IKO_TColgp_Array2OfPnt* Poles, IKO_TColStd_Array2OfReal* Weights, IKO_TColStd_Array1OfReal* UKnots, IKO_TColStd_Array1OfReal* VKnots, IKO_TColStd_Array1OfInteger* UMults, IKO_TColStd_Array1OfInteger* VMults, int UDegree, int VDegree, VARIANT_BOOL UPeriodic_deft_false, VARIANT_BOOL VPeriodic_deft_false)=0;
	ICALLTYPE ExchangeUV()=0;
	ICALLTYPE SetUPeriodic(VARIANT_BOOL periodic)=0;
	ICALLTYPE SetVPeriodic(VARIANT_BOOL periodic)=0;
	ICALLTYPE PeriodicNormalization(double* U, double* V)=0;
	ICALLTYPE SetUOrigin(int Index)=0;
	ICALLTYPE SetVOrigin(int Index)=0;
	ICALLTYPE UReverse()=0;
	ICALLTYPE VReverse()=0;
	ICALLTYPE IncreaseDegree(int UDegree, int VDegree)=0;
	ICALLTYPE InsertUKnots(IKO_TColStd_Array1OfReal* Knots, IKO_TColStd_Array1OfInteger* Mults, double ParametricTolerance, VARIANT_BOOL Add)=0;
	ICALLTYPE InsertVKnots(IKO_TColStd_Array1OfReal* Knots, IKO_TColStd_Array1OfInteger* Mults, double ParametricTolerance, VARIANT_BOOL Add)=0;
	ICALLTYPE RemoveUKnot(int Index, int M, double Tolerance, VARIANT_BOOL* retVal)=0;
	ICALLTYPE RemoveVKnot(int Index, int M, double Tolerance, VARIANT_BOOL* retVal)=0;
	ICALLTYPE IncreaseUMultiplicity(int UIndex, int M)=0;
	ICALLTYPE IncreaseUMultiplicity2(int FromI1, int ToI2, int M)=0;
	ICALLTYPE IncrementUMultiplicity(int FromI1, int ToI2, int Step)=0;
	ICALLTYPE IncreaseVMultiplicity(int VIndex, int M)=0;
	ICALLTYPE IncreaseVMultiplicity2(int FromI1, int ToI2, int M)=0;
	ICALLTYPE IncrementVMultiplicity(int FromI1, int ToI2, int Step)=0;
	ICALLTYPE InsertUKnot(double U, int M, double ParametricTolerance, VARIANT_BOOL Add)=0;
	ICALLTYPE InsertVKnot(double V, int M, double ParametricTolerance, VARIANT_BOOL Add)=0;
	ICALLTYPE Segment(double U1, double U2, double V1, double V2)=0;
	ICALLTYPE CheckAndSegment(double U1, double U2, double V1, double V2)=0;
	ICALLTYPE SetUKnot(int UIndex, double K)=0;
	ICALLTYPE SetUKnots(IKO_TColStd_Array1OfReal* UK)=0;
	ICALLTYPE SetUKnot2(int UIndex, double K, int M)=0;
	ICALLTYPE SetVKnot(int VIndex, double K)=0;
	ICALLTYPE SetVKnots(IKO_TColStd_Array1OfReal* VK)=0;
	ICALLTYPE SetVKnot2(int VIndex, double K, int M)=0;
	ICALLTYPE LocateU(double U, double ParametricTolerance, int* I1, int* I2, VARIANT_BOOL WithKnotRepetition)=0;
	ICALLTYPE LocateV(double V, double ParametricTolerance, int* I1, int* I2, VARIANT_BOOL WithKnotRepetition)=0;
	ICALLTYPE SetPole(int UIndex, int VIndex, DIPoint* P)=0;
	ICALLTYPE SetPole2(int UIndex, int VIndex, DIPoint* P, double Weight)=0;
	ICALLTYPE SetPoleCol(int VIndex, IKO_TColgp_Array1OfPnt* CPoles)=0;
	ICALLTYPE SetPoleCol2(int VIndex, IKO_TColgp_Array1OfPnt* CPoles, IKO_TColStd_Array1OfReal* CPoleWeights)=0;
	ICALLTYPE SetPoleRow(int UIndex, IKO_TColgp_Array1OfPnt* CPoles, IKO_TColStd_Array1OfReal* CPoleWeights)=0;
	ICALLTYPE SetPoleRow2(int UIndex, IKO_TColgp_Array1OfPnt* CPoles)=0;
	ICALLTYPE SetWeight(int UIndex, int VIndex, double Weight)=0;
	ICALLTYPE SetWeightCol(int VIndex, IKO_TColStd_Array1OfReal* CPoleWeights)=0;
	ICALLTYPE SetWeightRow(int UIndex, IKO_TColStd_Array1OfReal* CPoleWeights)=0;
	ICALLTYPE MovePoint(double U, double V, DIPoint* P, int UIndex1, int UIndex2, int VIndex1, int VIndex2, int* UFirstIndex, int* ULastIndex, int* VFirstIndex, int* VLastIndex)=0;
	ICALLTYPE IsUClosed(VARIANT_BOOL* retVal)=0;
	ICALLTYPE IsVClosed(VARIANT_BOOL* retVal)=0;
	ICALLTYPE IsCNu(int N, VARIANT_BOOL* retVal)=0;
	ICALLTYPE IsCNv(int N, VARIANT_BOOL* retVal)=0;
	ICALLTYPE IsUPeriodic(VARIANT_BOOL* retVal)=0;
	ICALLTYPE IsURational(VARIANT_BOOL* retVal)=0;
	ICALLTYPE IsVPeriodic(VARIANT_BOOL* retVal)=0;
	ICALLTYPE IsVRational(VARIANT_BOOL* retVal)=0;
	ICALLTYPE IsCacheValid(double UParameter, double VParameter, VARIANT_BOOL* retVal)=0;
	ICALLTYPE Bounds(double* U1, double* U2, double* V1, double* V2)=0;
	ICALLTYPE Continuity(int* GeomAbs_Shape_continuity)=0;
	ICALLTYPE FirstUKnotIndex(int* retVal)=0;
	ICALLTYPE FirstVKnotIndex(int* retVal)=0;
	ICALLTYPE LastUKnotIndex(int* retVal)=0;
	ICALLTYPE LastVKnotIndex(int* retVal)=0;
	ICALLTYPE NbUKnots(int* retVal)=0;
	ICALLTYPE NbUPoles(int* retVal)=0;
	ICALLTYPE NbVKnots(int* retVal)=0;
	ICALLTYPE NbVPoles(int* retVal)=0;
	ICALLTYPE Pole(int UIndex, int VIndex, DIPoint* pt)=0;
	ICALLTYPE Poles(IKO_TColgp_Array2OfPnt* P)=0;
	ICALLTYPE UDegree(int* retVal)=0;
	ICALLTYPE UKnot(int UIndex, double* knot)=0;
	ICALLTYPE UKnotDistribution(int* GeomAbs_BSplKnotDistribution_retVal)=0;
	ICALLTYPE UKnots(IKO_TColStd_Array1OfReal* Ku)=0;
	ICALLTYPE UKnotSequence(IKO_TColStd_Array1OfReal* Ku)=0;
	ICALLTYPE UMultiplicity(int UIndex, int* retVal)=0;
	ICALLTYPE UMultiplicities(IKO_TColStd_Array1OfInteger* Mu)=0;
	ICALLTYPE VDegree(int* retVal)=0;
	ICALLTYPE VKnot(int VIndex, double* knot)=0;
	ICALLTYPE VKnotDistribution(int* GeomAbs_BSplKnotDistribution_retVal)=0;
	ICALLTYPE VKnots(IKO_TColStd_Array1OfReal* Kv)=0;
	ICALLTYPE VKnotSequence(IKO_TColStd_Array1OfReal* Kv)=0;
	ICALLTYPE VMultiplicity(int VIndex, int* retVal)=0;
	ICALLTYPE VMultiplicities(IKO_TColStd_Array1OfInteger* Mv)=0;
	ICALLTYPE Weight(int UIndex, int VIndex, double* retVal)=0;
	ICALLTYPE Weights(IKO_TColStd_Array2OfReal* W)=0;
	ICALLTYPE D0(double U, double V, DIPoint* P)=0;
	ICALLTYPE D1(double U, double V, DIPoint* P, DIVect* D1U, DIVect* D1V)=0;
	ICALLTYPE D2(double U, double V, DIPoint* P, DIVect* D1U, DIVect* D1V, DIVect* D2U, DIVect* D2V, DIVect* D2UV)=0;
	ICALLTYPE D3(double U, double V, DIPoint* P, DIVect* D1U, DIVect* D1V, DIVect* D2U, DIVect* D2V, DIVect* D2UV, DIVect* D3U, DIVect* D3V, DIVect* D3UUV, DIVect* D3UVV)=0;
	ICALLTYPE DN(double U, double V, int Nu, int Nv, DIVect* retV)=0;
	ICALLTYPE UIso(double U, IKO_Geom_Curve** curve)=0;
	ICALLTYPE VIso(double V, IKO_Geom_Curve** curve)=0;
	ICALLTYPE Resolution(double Tolerance3D, double* UTolerance, double* VTolerance)=0;
	IUNKNOWN_
};

// {B340360A-C5FF-4945-82F5-92A7F9B22318}
static const GUID IID_IKO_BRepBuilderAPI_MakeEdge = { 0xb340360a, 0xc5ff, 0x4945, { 0x82, 0xf5, 0x92, 0xa7, 0xf9, 0xb2, 0x23, 0x18 } };
class IKO_BRepBuilderAPI_MakeEdge : public IUnknown
{
public:
	ICALLTYPE FromObject(IKO_Standard_Object* iObject, IKO_TopoDS_Edge** edge)=0;
	IUNKNOWN_
};

// {AD9BC36A-9E70-44C6-9339-AC6E529FA319}
static const GUID IID_IKO_BRepBuilderAPI_MakeFace = { 0xad9bc36a, 0x9e70, 0x44c6, { 0x93, 0x39, 0xac, 0x6e, 0x52, 0x9f, 0xa3, 0x19 } };
class IKO_BRepBuilderAPI_MakeFace : public IUnknown
{
public:
	ICALLTYPE FromPlane(IKO_gp_Pln* P, IKO_TopoDS_Face** face)=0;
	ICALLTYPE FromCylinder(IKO_gp_Cylinder* C, IKO_TopoDS_Face** face)=0;
	ICALLTYPE FromCone(IKO_gp_Cone* C, IKO_TopoDS_Face** face)=0;
	ICALLTYPE FromSphere(IKO_gp_Sphere* S, IKO_TopoDS_Face** face)=0;
	ICALLTYPE FromTorus(IKO_gp_Torus* C, IKO_TopoDS_Face** face)=0;
	ICALLTYPE FromSurface(IKO_Geom_Surface* S, IKO_TopoDS_Face** face)=0;
	ICALLTYPE FromPlane2(IKO_gp_Pln* P, double UMin, double UMax, double VMin, double VMax, IKO_TopoDS_Face** face)=0;
	ICALLTYPE FromCylinder2(IKO_gp_Cylinder* C, double UMin, double UMax, double VMin, double VMax, IKO_TopoDS_Face** face)=0;
	ICALLTYPE FromCone2(IKO_gp_Cone* C, double UMin, double UMax, double VMin, double VMax, IKO_TopoDS_Face** face)=0;
	ICALLTYPE FromSphere2(IKO_gp_Sphere* S, double UMin, double UMax, double VMin, double VMax, IKO_TopoDS_Face** face)=0;
	ICALLTYPE FromTorus2(IKO_gp_Torus* C, double UMin, double UMax, double VMin, double VMax, IKO_TopoDS_Face** face)=0;
	ICALLTYPE FromSurface2(IKO_Geom_Surface* S, double UMin, double UMax, double VMin, double VMax, IKO_TopoDS_Face** face)=0;
	ICALLTYPE FromWire(IKO_TopoDS_Wire* W, VARIANT_BOOL OnlyPlane, IKO_TopoDS_Face** face)=0;
	ICALLTYPE FromPlaneAndWire(IKO_gp_Pln* P, IKO_TopoDS_Wire* W, VARIANT_BOOL Inside, IKO_TopoDS_Face** face)=0;
	ICALLTYPE FromCylinderAndWire(IKO_gp_Cylinder* C, IKO_TopoDS_Wire* W, VARIANT_BOOL Inside, IKO_TopoDS_Face** face)=0;
	ICALLTYPE FromConeAndWire(IKO_gp_Cone* C, IKO_TopoDS_Wire* W, VARIANT_BOOL Inside, IKO_TopoDS_Face** face)=0;
	ICALLTYPE FromSphereAndWire(IKO_gp_Sphere* S, IKO_TopoDS_Wire* W, VARIANT_BOOL Inside, IKO_TopoDS_Face** face)=0;
	ICALLTYPE FromTorusAndWire(IKO_gp_Torus* C, IKO_TopoDS_Wire* W, VARIANT_BOOL Inside, IKO_TopoDS_Face** face)=0;
	ICALLTYPE FromSurfaceAndWire(IKO_Geom_Surface* S, IKO_TopoDS_Wire* W, VARIANT_BOOL Inside, IKO_TopoDS_Face** face)=0;
	ICALLTYPE FromFaceAndWire(IKO_TopoDS_Face*F, IKO_TopoDS_Wire* W, IKO_TopoDS_Face** face)=0;
 	ICALLTYPE Init(IKO_TopoDS_Face*F, IKO_TopoDS_Face** face)=0;
	ICALLTYPE Init2(IKO_Geom_Surface* S, VARIANT_BOOL Bound, IKO_TopoDS_Face** face)=0;
	ICALLTYPE Init3(IKO_Geom_Surface* S, double UMin, double UMax, double VMin, double VMax, IKO_TopoDS_Face** face)=0;
	ICALLTYPE Add(IKO_TopoDS_Wire* W, IKO_TopoDS_Face** face)=0;
	//ICALLTYPE Face(IKO_TopoDS_Face** retVal)=0;
	IUNKNOWN_
};

// {75F1D4C1-5ED3-42D9-9A04-EE543E03817A}
static const GUID IID_IKO_BRepBuilderAPI_MakeWire = { 0x75f1d4c1, 0x5ed3, 0x42d9, { 0x9a, 0x4, 0xee, 0x54, 0x3e, 0x3, 0x81, 0x7a } };
class IKO_BRepBuilderAPI_MakeWire : public IUnknown
{
public:
	ICALLTYPE FromEdge(IKO_TopoDS_Edge* edge, IKO_TopoDS_Wire** wire)=0;
	IUNKNOWN_
};

// {A7CC6995-49C9-4AEA-9EAB-F92CADB5B264}
static const GUID IID_IKO_BRep_Builder = { 0xa7cc6995, 0x49c9, 0x4aea, { 0x9e, 0xab, 0xf9, 0x2c, 0xad, 0xb5, 0xb2, 0x64 } };
class IKO_BRep_Builder : public IUnknown
{
public:
	ICALLTYPE MakeFace(IKO_TopoDS_Face* F)=0;
	ICALLTYPE MakeFace1(IKO_TopoDS_Face* F, IKO_Geom_Surface* S, double Tol)=0;
	ICALLTYPE MakeFace2(IKO_TopoDS_Face* F, IKO_Geom_Surface* S, IFrame* location, double Tol)=0;
	ICALLTYPE UpdateFace(IKO_TopoDS_Face* F, IKO_Geom_Surface* S, IFrame* location, double Tol)=0;
	ICALLTYPE UpdateFace1(IKO_TopoDS_Face* F, IKO_Poly_Triangulation*T)=0;
	ICALLTYPE UpdateFace2(IKO_TopoDS_Face* F, double Tol)=0;
	ICALLTYPE NaturalRestriction(IKO_TopoDS_Face* F, VARIANT_BOOL N)=0;
	ICALLTYPE MakeEdge(IKO_TopoDS_Edge* E)=0;
	ICALLTYPE MakeEdge1(IKO_TopoDS_Edge* E, IKO_Geom_Curve* C, double Tol)=0;
	ICALLTYPE MakeEdge2(IKO_TopoDS_Edge* E, IKO_Geom_Curve* C, IFrame* location, double Tol)=0;
	ICALLTYPE MakeEdge3(IKO_TopoDS_Edge* E, IKO_Poly_Polygon3D* P)=0;
	ICALLTYPE MakeEdge4(IKO_TopoDS_Edge* E, IKO_Poly_PolygonOnTriangulation*N, IKO_Poly_Triangulation*T)=0;
	ICALLTYPE MakeEdge5(IKO_TopoDS_Edge* E, IKO_Poly_PolygonOnTriangulation*N, IKO_Poly_Triangulation*T, IFrame* location)=0;
	ICALLTYPE UpdateEdge(IKO_TopoDS_Edge* E, IKO_Geom_Curve* C, double Tol)=0;
	ICALLTYPE UpdateEdge1(IKO_TopoDS_Edge* E, IKO_Geom_Curve* C, IFrame* location, double Tol)=0;
	ICALLTYPE UpdateEdge2(IKO_TopoDS_Edge* E, IKO_Geom2d_Curve* C, IKO_TopoDS_Face* F, double Tol)=0;
	ICALLTYPE UpdateEdge3(IKO_TopoDS_Edge* E, IKO_Geom2d_Curve* C1, IKO_Geom2d_Curve* C2, IKO_TopoDS_Face* F, double Tol)=0;
	ICALLTYPE UpdateEdge4(IKO_TopoDS_Edge* E, IKO_Geom2d_Curve* C, IKO_Geom_Surface* S, IFrame* location, double Tol)=0;
	ICALLTYPE UpdateEdge5(IKO_TopoDS_Edge* E, IKO_Geom2d_Curve* C, IKO_Geom_Surface* S, IFrame* location, double Tol, KC2D* Pf, KC2D* Pl)=0;
	ICALLTYPE UpdateEdge6(IKO_TopoDS_Edge* E, IKO_Geom2d_Curve* C1, IKO_Geom2d_Curve* C2, IKO_Geom_Surface* S, IFrame* location, double Tol)=0;
	ICALLTYPE UpdateEdge7(IKO_TopoDS_Edge* E, IKO_Geom2d_Curve* C1, IKO_Geom2d_Curve* C2, IKO_Geom_Surface* S, IFrame* location, double Tol, KC2D* Pf, KC2D* Pl)=0;
	ICALLTYPE UpdateEdge8(IKO_TopoDS_Edge* E, IKO_Poly_Polygon3D* P)=0;
	ICALLTYPE UpdateEdge9(IKO_TopoDS_Edge* E, IKO_Poly_Polygon3D* P, IFrame* location)=0;
	ICALLTYPE UpdateEdge10(IKO_TopoDS_Edge* E, IKO_Poly_PolygonOnTriangulation*N, IKO_Poly_Triangulation*T)=0;
	ICALLTYPE UpdateEdge11(IKO_TopoDS_Edge* E, IKO_Poly_PolygonOnTriangulation*N, IKO_Poly_Triangulation*T, IFrame* location)=0;
	ICALLTYPE UpdateEdge12(IKO_TopoDS_Edge* E, IKO_Poly_PolygonOnTriangulation*N1, IKO_Poly_PolygonOnTriangulation*N2, IKO_Poly_Triangulation*T)=0;
	ICALLTYPE UpdateEdge13(IKO_TopoDS_Edge* E, IKO_Poly_PolygonOnTriangulation*N1, IKO_Poly_PolygonOnTriangulation*N2, IKO_Poly_Triangulation*T, IFrame* location)=0;
	ICALLTYPE UpdateEdge14(IKO_TopoDS_Edge* E, IKO_Poly_Polygon2D* P, IKO_TopoDS_Face* S)=0;
	ICALLTYPE UpdateEdge15(IKO_TopoDS_Edge* E, IKO_Poly_Polygon2D* P, IKO_Geom_Surface* S, IFrame* location)=0;
	ICALLTYPE UpdateEdge16(IKO_TopoDS_Edge* E, IKO_Poly_Polygon2D* P1, IKO_Poly_Polygon2D* P2, IKO_TopoDS_Face* F)=0;
	ICALLTYPE UpdateEdge17(IKO_TopoDS_Edge* E, IKO_Poly_Polygon2D* P1, IKO_Poly_Polygon2D* P2, IKO_Geom_Surface* S, IFrame* location)=0;
	ICALLTYPE UpdateEdge18(IKO_TopoDS_Edge* E, double Tol)=0;
	ICALLTYPE Continuity(IKO_TopoDS_Edge* E, IKO_TopoDS_Face* F1, IKO_TopoDS_Face* F2, int GeomAbs_Shape_Continuity)=0;
	ICALLTYPE Continuity1(IKO_TopoDS_Edge* E, IKO_Geom_Surface* S1, IKO_Geom_Surface* S2, IFrame* location1, IFrame* location2, int GeomAbs_Shape_Continuity)=0;
	ICALLTYPE SameParameter(IKO_TopoDS_Edge* E, VARIANT_BOOL S)=0;
	ICALLTYPE SameRange(IKO_TopoDS_Edge* E, VARIANT_BOOL S)=0;
	ICALLTYPE Degenerated(IKO_TopoDS_Edge* E, VARIANT_BOOL D)=0;
	ICALLTYPE Range(IKO_TopoDS_Edge* E, double First, double Last, VARIANT_BOOL Only3d)=0;
	ICALLTYPE Range1(IKO_TopoDS_Edge* E, IKO_Geom_Surface* S, IFrame* location, double First, double Last)=0;
	ICALLTYPE Range2(IKO_TopoDS_Edge* E, IKO_TopoDS_Face* F, double First, double Last)=0;
	ICALLTYPE Transfert(IKO_TopoDS_Edge* Ein, IKO_TopoDS_Edge* Eout)=0;
	ICALLTYPE MakeVertex(IKO_TopoDS_Vertex* V)=0;
	ICALLTYPE MakeVertex1(IKO_TopoDS_Vertex* V, DIPoint* P, double Tol)=0;
	ICALLTYPE UpdateVertex(IKO_TopoDS_Vertex* V, DIPoint* P, double Tol)=0;
	ICALLTYPE UpdateVertex1(IKO_TopoDS_Vertex* V, double P, IKO_TopoDS_Edge* E, double Tol)=0;
	ICALLTYPE UpdateVertex2(IKO_TopoDS_Vertex* V, double P, IKO_TopoDS_Edge* E, IKO_TopoDS_Face* F, double Tol)=0;
	ICALLTYPE UpdateVertex3(IKO_TopoDS_Vertex* V, double P, IKO_TopoDS_Edge* E, IKO_Geom_Surface* S, IFrame* location, double Tol)=0;
	ICALLTYPE UpdateVertex4(IKO_TopoDS_Vertex* Ve, double U, double V, IKO_TopoDS_Face* F, double Tol)=0;
	ICALLTYPE UpdateVertex5(IKO_TopoDS_Vertex* V, double Tol)=0;
	ICALLTYPE Transfert2(IKO_TopoDS_Edge* Ein, IKO_TopoDS_Edge* Eout, IKO_TopoDS_Vertex* Vin, IKO_TopoDS_Vertex* Vout)=0;
	// Base methods from IKO_TopoDS_Builder
	ICALLTYPE MakeWire(IKO_TopoDS_Wire* wire)=0;
	ICALLTYPE MakeShell(IKO_TopoDS_Shell* shell)=0;
	ICALLTYPE MakeSolid(IKO_TopoDS_Solid* solid)=0;
	ICALLTYPE MakeCompSolid(IKO_TopoDS_CompSolid* compSolid)=0;
	ICALLTYPE MakeCompound(IKO_TopoDS_Compound* compound)=0;
	ICALLTYPE Add(IKO_TopoDS_Shape* shapeTo, IKO_TopoDS_Shape* shapeAdded)=0;
	ICALLTYPE Remove(IKO_TopoDS_Shape* shapeFrom, IKO_TopoDS_Shape* shapeRemoved)=0;
	IUNKNOWN_
};

// {9BE3DB32-443F-4E60-AFC0-A9AEAAEA9977}
static const GUID IID_IKO_BRep_Tool = { 0x9be3db32, 0x443f, 0x4e60, { 0xaf, 0xc0, 0xa9, 0xae, 0xaa, 0xea, 0x99, 0x77 } };
class IKO_BRep_Tool : public IUnknown
{
public:
	ICALLTYPE IsClosed(IKO_TopoDS_Shape* shape, VARIANT_BOOL* closed) = 0;
	ICALLTYPE Surface(IKO_TopoDS_Face* face, IKO_Geom_Surface** surface, IFrame** location) = 0;
	ICALLTYPE Surface2(IKO_TopoDS_Face* face, IKO_Geom_Surface** surface) = 0;
	ICALLTYPE Triangulation(IKO_TopoDS_Face* face, IFrame** location, IKO_Poly_Triangulation** retTriangulation) = 0;
	ICALLTYPE Tolerance(IKO_TopoDS_Face* face, double* tolerance) = 0;
	ICALLTYPE NaturalRestriction(IKO_TopoDS_Face* face, VARIANT_BOOL* ret) = 0;
	ICALLTYPE IsGeometric(IKO_TopoDS_Edge* edge, VARIANT_BOOL* ret) = 0;
	ICALLTYPE Curve(IKO_TopoDS_Edge* edge, IFrame** location, double* first, double* last, IKO_Geom_Curve** retCurve) = 0;
	ICALLTYPE Curve2(IKO_TopoDS_Edge* edge, double* first, double* last, IKO_Geom_Curve** retCurve) = 0;
	ICALLTYPE Polygon3D(IKO_TopoDS_Edge* edge, IFrame** location, IKO_Poly_Polygon3D** retPolygon) = 0;
	ICALLTYPE CurveOnSurface(IKO_TopoDS_Edge* edge, IKO_TopoDS_Face* face, double* first, double* last, IKO_Geom2d_Curve** retCurve) = 0;
	ICALLTYPE CurveOnSurface2(IKO_TopoDS_Edge* edge, IKO_Geom_Surface* surface, IFrame* location, double* first, double* last, IKO_Geom2d_Curve** retCurve) = 0;
	ICALLTYPE CurveOnSurface3(IKO_TopoDS_Edge* edge, IKO_Geom2d_Curve** curve, IKO_Geom_Surface** surface, IFrame** location, double* first, double* last, int index) = 0;
	ICALLTYPE PolygonOnSurface(IKO_TopoDS_Edge* edge, IKO_TopoDS_Face* face, IKO_Poly_Polygon2D** retPolygon) = 0;
	ICALLTYPE PolygonOnSurface2(IKO_TopoDS_Edge* edge, IKO_Geom_Surface* surface, IFrame* location, IKO_Poly_Polygon2D** retPolygon) = 0;
	ICALLTYPE PolygonOnSurface3(IKO_TopoDS_Edge* edge, IKO_Poly_Polygon2D** curve, IKO_Geom_Surface** surface, IFrame** location) = 0;
	ICALLTYPE PolygonOnSurface4(IKO_TopoDS_Edge* edge, IKO_Poly_Polygon2D** curve, IKO_Geom_Surface** surface, IFrame** location, int index) = 0;
	ICALLTYPE PolygonOnTriangulation(IKO_TopoDS_Edge* edge, IKO_Poly_Triangulation* triang, IFrame* location, IKO_Poly_PolygonOnTriangulation** retPolygon) = 0;
	ICALLTYPE PolygonOnTriangulation2(IKO_TopoDS_Edge* edge, IKO_Poly_PolygonOnTriangulation** polyg, IKO_Poly_Triangulation** triang, IFrame** location) = 0;
	ICALLTYPE PolygonOnTriangulation3(IKO_TopoDS_Edge* edge, IKO_Poly_PolygonOnTriangulation** polyg, IKO_Poly_Triangulation** triang, IFrame** location, int index) = 0;
	ICALLTYPE IsClosed2(IKO_TopoDS_Edge* edge, IKO_TopoDS_Face* face, VARIANT_BOOL* closed) = 0;
	ICALLTYPE IsClosed3(IKO_TopoDS_Edge* edge, IKO_Geom_Surface* surface, IFrame* location, VARIANT_BOOL* closed) = 0;
	ICALLTYPE IsClosed4(IKO_TopoDS_Edge* edge, IKO_Poly_Triangulation* triangulation, IFrame* location, VARIANT_BOOL* closed) = 0;
	ICALLTYPE Tolerance2(IKO_TopoDS_Edge* edge, double* retTolerance) = 0;
	ICALLTYPE SameParameter(IKO_TopoDS_Edge* edge, VARIANT_BOOL* ret) = 0;
	ICALLTYPE SameRange(IKO_TopoDS_Edge* edge, VARIANT_BOOL* ret) = 0;
	ICALLTYPE Degenerated(IKO_TopoDS_Edge* edge, VARIANT_BOOL* ret) = 0;
	ICALLTYPE Range(IKO_TopoDS_Edge* edge, double* first, double* last) = 0;
	ICALLTYPE Range2(IKO_TopoDS_Edge* edge, IKO_Geom_Surface* surface, IFrame* location, double* first, double* last) = 0;
	ICALLTYPE Range3(IKO_TopoDS_Edge* edge, IKO_TopoDS_Face* face, double* first, double* last) = 0;
	ICALLTYPE UVPoints(IKO_TopoDS_Edge* edge, IKO_Geom_Surface* surface, IFrame* location, KC2D* first, KC2D* last) = 0;
	ICALLTYPE UVPoints2(IKO_TopoDS_Edge* edge, IKO_TopoDS_Face* face, KC2D* first, KC2D* last) = 0;
	ICALLTYPE SetUVPoints(IKO_TopoDS_Edge* edge, IKO_Geom_Surface* surface, IFrame* location, KC2D* first, KC2D* last) = 0;
	ICALLTYPE SetUVPoints2(IKO_TopoDS_Edge* edge, IKO_TopoDS_Face* face, KC2D* first, KC2D* last) = 0;
	ICALLTYPE HasContinuity(IKO_TopoDS_Edge* edge, IKO_TopoDS_Face* face1, IKO_TopoDS_Face* face2, VARIANT_BOOL* ret) = 0;
	ICALLTYPE Continuity(IKO_TopoDS_Edge* edge, IKO_TopoDS_Face* face1, IKO_TopoDS_Face* face2, int* GeomAbs_Shape_continuity) = 0;
	ICALLTYPE HasContinuity2(IKO_TopoDS_Edge* edge, IKO_Geom_Surface* surface1, IKO_Geom_Surface* surface2, IFrame* location1, IFrame* location2, VARIANT_BOOL* ret) = 0;
	ICALLTYPE Continuity2(IKO_TopoDS_Edge* edge, IKO_Geom_Surface* surface1, IKO_Geom_Surface* surface2, IFrame* location1, IFrame* location2, int* GeomAbs_Shape_continuity) = 0;
	ICALLTYPE HasContinuity3(IKO_TopoDS_Edge* edge, VARIANT_BOOL* ret) = 0;
	ICALLTYPE Pnt(IKO_TopoDS_Vertex* vertex, DIPoint* outPoint) = 0;
	ICALLTYPE Tolerance3(IKO_TopoDS_Vertex* vertex, double* retTolerance) = 0;
	ICALLTYPE Parameter(IKO_TopoDS_Vertex* vertex, IKO_TopoDS_Edge* edge, double* retParameter) = 0;
	ICALLTYPE Parameter2(IKO_TopoDS_Vertex* vertex, IKO_TopoDS_Edge* edge, IKO_TopoDS_Face* face, double* retParameter) = 0;
	ICALLTYPE Parameter3(IKO_TopoDS_Vertex* vertex, IKO_TopoDS_Edge* edge, IKO_Geom_Surface* surface, IFrame* location, double* retParam) = 0;
	ICALLTYPE Parameters(IKO_TopoDS_Vertex* vertex, IKO_TopoDS_Face* face, KC2D* outParams) = 0;
	IUNKNOWN_
};

// {9305087F-146E-4AAD-B9C7-1AC3F115409F}
static const GUID IID_IKO_BRepOffsetAPI_ThruSections = { 0x9305087f, 0x146e, 0x4aad, { 0xb9, 0xc7, 0x1a, 0xc3, 0xf1, 0x15, 0x40, 0x9f } };
class IKO_BRepOffsetAPI_ThruSections : public IUnknown
{
public:
	ICALLTYPE Init(VARIANT_BOOL isSolid, VARIANT_BOOL ruled, double pres3d)=0;
	ICALLTYPE AddWire(IKO_TopoDS_Wire* wire)=0;
	ICALLTYPE Build()=0;
	ICALLTYPE Shape(IKO_TopoDS_Shape** shape)=0;
	IUNKNOWN_
};

// {1C44A8D8-8D3D-4A6D-B0F1-530A263F0A4C}
static const GUID IID_IKO_GeomAPI_PointsToBSpline = { 0x1c44a8d8, 0x8d3d, 0x4a6d, { 0xb0, 0xf1, 0x53, 0xa, 0x26, 0x3f, 0xa, 0x4c } };
class IKO_GeomAPI_PointsToBSpline : public IUnknown
{
public:
	ICALLTYPE Init(IKO_TColgp_Array1OfPnt* Points, int DegMin, int DegMax, int GeomAbs_Shape_continuity, double Tol3D)=0;
	ICALLTYPE Init2(IKO_TColgp_Array1OfPnt* Points, int Approx_ParametrizationType_ParType, int DegMin, int DegMax, int GeomAbs_Shape_continuity, double Tol3D)=0; 
	ICALLTYPE Init3(IKO_TColgp_Array1OfPnt* Points, IKO_TColStd_Array1OfReal* Parameters, int DegMin, int DegMax, int GeomAbs_Shape_continuity, double Tol3D)=0; 
	ICALLTYPE Init4(IKO_TColgp_Array1OfPnt* Points, double Weight1, double Weight2, double Weight3, int DegMax, int GeomAbs_Shape_continuity, double Tol3D)=0;
	ICALLTYPE Curve(IKO_Geom_BSplineCurve** curve)=0;
	IUNKNOWN_
};

// {6D247F41-5D88-43FD-86BA-C02398550FE5}
static const GUID IID_IKO_GeomAPI_Interpolate = { 0x6d247f41, 0x5d88, 0x43fd, { 0x86, 0xba, 0xc0, 0x23, 0x98, 0x55, 0xf, 0xe5 } };
class IKO_GeomAPI_Interpolate : public IUnknown
{
public:
	ICALLTYPE Init(IKO_TColgp_Array1OfPnt* Points, VARIANT_BOOL Periodic, double Tolerance)=0;
	ICALLTYPE Init2(IKO_TColgp_Array1OfPnt* Points, IKO_TColStd_Array1OfReal* Parameters, VARIANT_BOOL Periodic, double Tolerance)=0;
	ICALLTYPE Load( DIVect* InitialTangent, DIVect* FinalTangent, VARIANT_BOOL Scale)=0;
	ICALLTYPE Load2(IKO_TColgp_Array1OfVec* Tangents, IKO_TColStd_Array1OfBoolean* TangentFlags, VARIANT_BOOL Scale)=0;
	ICALLTYPE ClearTangents()=0;
	ICALLTYPE Perform()=0;
	ICALLTYPE Curve(IKO_Geom_BSplineCurve** curve)=0;
	IUNKNOWN_
};

// {261860EF-912E-4F9A-9A0D-9E6C417725C5}
static const GUID IID_IKO_Model = { 0x261860ef, 0x912e, 0x4f9a, { 0x9a, 0xd, 0x9e, 0x6c, 0x41, 0x77, 0x25, 0xc5 } };
class IKO_Model : public IUnknown
{
public:
	ICALLTYPE AddShape(IKO_TopoDS_Shape* shape, IKO_Standard_Object** section)=0;
	ICALLTYPE AddGeometryItem(IKO_Geom_Geometry* item, IKO_Standard_Object** section)=0;
	ICALLTYPE AddGraphic2d(IKO_Graphic2d_Primitive* item, IKO_Standard_Object** sceneItem)=0;
	IUNKNOWN_
};

// {2660BEE0-C32F-498C-9532-DEE6D4855073}
static const GUID IID_IKO_AIS_InteractiveObject = { 0x2660bee0, 0xc32f, 0x498c, { 0x95, 0x32, 0xde, 0xe6, 0xd4, 0x85, 0x50, 0x73 } };
class IKO_AIS_InteractiveObject : public IUnknown
{
public:
	ICALLTYPE SetDisplayMode(int aMode)=0;
	ICALLTYPE DisplayMode(int* aMode)=0;
	ICALLTYPE SetColor(float red, float green, float blue)=0;
	ICALLTYPE Color(float* red, float* green, float* blue)=0;
	ICALLTYPE Redisplay(VARIANT_BOOL AllModes)=0;
	IUNKNOWN_
};

// {0DA699B2-323B-4FF4-B677-08FA21943C2E}
static const GUID IID_IKO_BRepPrimAPI = { 0xda699b2, 0x323b, 0x4ff4, { 0xb6, 0x77, 0x8, 0xfa, 0x21, 0x94, 0x3c, 0x2e } };
class IKO_BRepPrimAPI : public IUnknown
{
public:
	//virtual HRESULT STDMETHODCALLTYPE Cylinder(double radius, double height, double angle, ISection** obj)=0;	later sort out
	virtual HRESULT STDMETHODCALLTYPE Cylinder(double radius, double height, double angle)=0;
	virtual HRESULT STDMETHODCALLTYPE Cone(double radiusBottom, double radiusTop, double height, double angle)=0;

	virtual HRESULT STDMETHODCALLTYPE QueryInterface( REFIID iid, void **ppvObject)=0;
	virtual ULONG STDMETHODCALLTYPE AddRef()=0;
	virtual ULONG STDMETHODCALLTYPE Release()=0;
};

// {87811035-A3B8-4057-B3DF-DA5D3B8468DD}
static const GUID IID_IKO_BRepPrimAPI_MakePrism = { 0x87811035, 0xa3b8, 0x4057, { 0xb3, 0xdf, 0xda, 0x5d, 0x3b, 0x84, 0x68, 0xdd } };
class IKO_BRepPrimAPI_MakePrism : public IUnknown
{
public:
	ICALLTYPE FromShape(IKO_TopoDS_Shape* S, DIVect* V, VARIANT_BOOL copy, VARIANT_BOOL canonize, IKO_TopoDS_Shape** shapeCreated)=0;
	ICALLTYPE FromShapeInf(IKO_TopoDS_Shape* S, DIVect* Dir, VARIANT_BOOL infinite, VARIANT_BOOL copy, VARIANT_BOOL canonize, IKO_TopoDS_Shape** shapeCreated)=0;
	IUNKNOWN_
};

// {2B870910-533F-415A-964C-8E6C0BD0FA44}
static const GUID IID_IKO_BRepBuilderAPI_MakePolygon = { 0x2b870910, 0x533f, 0x415a, { 0x96, 0x4c, 0x8e, 0x6c, 0xb, 0xd0, 0xfa, 0x44 } };
class IKO_BRepBuilderAPI_MakePolygon : public IUnknown
{
public:
	ICALLTYPE Add(DIPoint* P)=0;
	ICALLTYPE Close(VARIANT_BOOL addToModel, IKO_TopoDS_Wire** wire)=0;
	IUNKNOWN_
};

// {A13EBB7A-88FF-41C2-B0B1-A570086B5672}
static const GUID IID_IKO_TopExp_Explorer = { 0xa13ebb7a, 0x88ff, 0x41c2, { 0xb0, 0xb1, 0xa5, 0x70, 0x8, 0x6b, 0x56, 0x72 } };
class IKO_TopExp_Explorer : public IUnknown
{
public:
	ICALLTYPE GetSubShapes(TopAbs_ShapeEnumKO type, IKO_TopTools_Array1OfShape** subShapes)=0;
	ICALLTYPE GetAncestors(IKO_TopoDS_Shape* topShape, TopAbs_ShapeEnumKO type, IKO_TopTools_Array1OfShape** ancestors)=0;
	IUNKNOWN_
};

// {0C0F7FBE-FB5B-470E-85AA-9C76B8FC29CC}
static const GUID IID_IKO_BRepGProp_Face = { 0xc0f7fbe, 0xfb5b, 0x470e, { 0x85, 0xaa, 0x9c, 0x76, 0xb8, 0xfc, 0x29, 0xcc } };
class IKO_BRepGProp_Face : public IUnknown
{
public:
	ICALLTYPE NaturalRestriction(VARIANT_BOOL* trimmed)=0;
	ICALLTYPE Value2d(double curveParam, KC2D* pointUV)=0;
	ICALLTYPE SIntOrder(double Eps, int* degreePlus)=0;
	ICALLTYPE SUIntSubs(int* UKnotsMinus)=0;
	ICALLTYPE SVIntSubs(int* VKnotsMinus)=0;
	ICALLTYPE UKnots(IKO_TColStd_Array1OfReal** uKnots)=0;
	ICALLTYPE VKnots(IKO_TColStd_Array1OfReal** vKnots)=0;
	ICALLTYPE Bounds(double* U1, double* U2, double* V1, double* V2)=0;
	ICALLTYPE Normal(double U, double V, DIPoint* P, DIVect* VNor)=0;
	ICALLTYPE Load(IKO_TopoDS_Edge* edge)=0;
	ICALLTYPE FirstParameter(double* min)=0;
	ICALLTYPE LastParameter(double* max)=0;
	ICALLTYPE D12d(double param, KC2D* pointUV, KC2D* tangentVectUV)=0;
	ICALLTYPE Load2(VARIANT_BOOL first, VARIANT_BOOL U)=0;
	IUNKNOWN_
};