// Misc.h
#pragma once

//////////////////////////////////////////  DEFs ///////////////////////////

#define IUNKNOWN_	ICALLTYPE QueryInterface( REFIID iid, void **ppvObject)=0;\
					virtual ULONG STDMETHODCALLTYPE AddRef()=0;\
					virtual ULONG STDMETHODCALLTYPE Release()=0;

#define ICALLTYPE	virtual HRESULT STDMETHODCALLTYPE

#define RELEASE(I)			\
	{						\
		if(I)				\
			I->Release();	\
		I = NULL;			\
	}	

inline COLORREF ToColorref(float fRed, float fGreen, float fBlue)
{
	return (COLORREF)(((BYTE)(255.0*fRed)|((WORD)((BYTE)(255.0*fGreen))<<8))|(((DWORD)(BYTE)(255.0*fBlue))<<16)); 
}


inline void ToColor(COLORREF clr, float* pfRed, float* pfGreen, float* pfBlue)
{
	*pfRed = (float)((BYTE)clr)/255;

	*pfGreen = (float)(BYTE)(((WORD)(clr)) >> 8)/255;

	*pfBlue = (float)((BYTE)(clr>>16))/255;
}

#define CH(p)		ASSERT(p);if(!(p)) return;
#define CHN(p)		ASSERT(p);if(!(p)) return NULL;
#define CHF(p)		ASSERT(p);if(!(p)) return false;
#define DDX_KCText3(pDX, ID, var) if( pDX->m_bSaveAndValidate ) DDX_Text(pDX, ID, var); else {CString str; str.Format("%.3f", var); DDX_Text(pDX, ID, str); }

#define ENABLE_MENU(control, item, enable) {				\
	IView* iView = (IView*)control.GetView();				\
	IMenu_KC* iMenu = NULL;				iView->QueryInterface(IID_IMenu_KC, (void**)&iMenu);				\
	iMenu->Enable(item, enable ? VARIANT_TRUE : VARIANT_FALSE );	iMenu->Release();	iView->Release();	}

const double	dPi = 3.14159265358979;
const double	gTol = 1e-10;
const double dDegreeToRadian = 3.14159265358979 / 180.0;
const double dRadianToDegree = 180.0 / 3.14159265358979;
