// TypesDG.h
#pragma once

/*#ifdef __midl
#define Enum enum
#else
#define Enum enum class
#endif*/

typedef enum ThreeState_DG
{
	unknownDG = -1,
	falseDG = 0,
	trueDG = 1
} ThreeState_DG;

typedef enum EDictionaryType_DG {
	eDictTypeUnknown,
	eDictTypeInt,
	eDictTypeDouble,
	eDictTypeBool,
	eDictType3State,
	eDictTypeString,
	eDictTypeVariant,
	eDictTypeInterface,
	eDictTypePointer,
} EDictionaryType_DG;

typedef enum SegmentType_DG {
	eSegmLine = 1,
	eSegmArc = 2,
} SegmentType_DG;

typedef enum EDim_DG{ e0D, e1D, e2D, e3D, eUD } EDim_DG;		// eUD - unknown

typedef enum DrawPrimitive_DG {
	ePointsDG,
	eLinesDG,
	eLineLoopDG,
	eLineStripDG,
	eTrianglesDG,
	eTriangleStripDG,
	eTriangleFanDG,
	eQuadsDG,
	eQuadStripDG,
	ePolygonDG,
	eDrawPrimitiveUnknownDG
} DrawPrimitive_DG;

//! Identifies various topological shapes. This <br>
//! enumeration allows you to use dynamic typing of shapes. <br>
//! The values are listed in order of complexity, from the <br>
//! most complex to the most simple i.e. <br>
//! COMPOUND > COMPSOLID > SOLID > .... > VERTEX > SHAPE. <br>
//!  Any shape can contain simpler shapes in its definition. <br>
//! Abstract topological data structure describes a basic <br>
//! entity, the shape (present in this enumeration as the <br>
//! SHAPE value), which can be divided into the following <br>
//! component topologies: <br>
//! - COMPOUND: A group of any of the shapes below. <br>
//! - COMPSOLID: A set of solids connected by their <br>
//!   faces. This expands the notions of WIRE and SHELL to solids. <br>
//! - SOLID: A part of 3D space bounded by shells. <br>
//! - SHELL: A set of faces connected by some of the <br>
//!   edges of their wire boundaries. A shell can be open or closed. <br>
//! - FACE: Part of a plane (in 2D geometry) or a surface <br>
//!   (in 3D geometry) bounded by a closed wire. Its <br>
//!   geometry is constrained (trimmed) by contours. <br>
//! - WIRE: A sequence of edges connected by their <br>
//!  vertices. It can be open or closed depending on <br>
//!  whether the edges are linked or not. <br>
//! - EDGE: A single dimensional shape corresponding <br>
//!   to a curve, and bound by a vertex at each extremity. <br>
//! - VERTEX: A zero-dimensional shape corresponding to a point in geometry. <br>
//!	- UNKNOWN: Depending on context either any or an error
typedef enum ShapeType_DG {

	eShTypeCompoundDG,
	eShTypeCompsolidDG,
	eShTypeSolidDG,
	eShTypeShellDG,
	eShTypeFaceDG,
	eShTypeWireDG,
	eShTypeEdgeDG,
	eShTypeVertexDG,
	eShTypeShapeDG,
	eShTypeUnknownDG

} ShapeType_DG;

typedef enum BRepOrientation_DG {
	eBRepOrientationForward,
	eBRepOrientationReversed,
	eBRepOrientationInternal,
	eBRepOrientationExternal
} BRepOrientation_DG;

typedef enum JoinType_DG {
	eJoinTypeArc,
	eJoinTypeTangent,
	eJoinTypeIntersection
} JoinType_DG;

typedef enum Continuity_DG
{
	eCont_C0,		// Only continuous
	eCont_G1,		// Geometrically smooth
	eCont_C1,		// Smooth WRT parameter
	eCont_G2,		// Geometrically smooth curvature
	eCont_C2,		// Smooth WRT parameter up to 2nd derivatives
	eCont_C3,		// Smooth WRT parameter up to 3rd derivatives
	eCont_CN		// Infinitely smooth
} Continuity_DG;

typedef enum ESurfaceType_DG {
	eSurfTypeUnknown,
	eSurfTypeBSpline,
	eSurfTypeBezier,
	eSurfTypePlane,
	eSurfTypeCylinder,
	eSurfTypeCone,
	eSurfTypeSphere,
	eSurfTypeTorus,
	eSurfTypeRectangularTrimmed,
	eSurfTypeSurfaceOfRevolution,
	eSurfTypeLinearExtrusion,
	eSurfTypeOffset,
	eSurfTypePlate,
	eSurfTypeComposite,
} ESurfaceType_DG;

typedef enum PointVs2dLineLocation_DG {
	ePointVs2dLineLocationDgUnknown,
	ePointVs2dLineLocationDgOutside,	// Either on the left or on the right. Unknown where exactly
	ePointVs2dLineLocationDgLeft,
	ePointVs2dLineLocationDgRight,
	ePointVs2dLineLocationDgInside,		// Somewhere on the line. Unknown where exactly
	ePointVs2dLineLocationDgOrigin,
	ePointVs2dLineLocationDgBefore,
	ePointVs2dLineLocationDgAfter,
} PointVs2dLineLocation_DG;

typedef enum PointVs2dCurveLocation_DG {
	ePointVs2dCurveLocationDgUnknown,
	ePointVs2dCurveLocationDgOutside,	// Either on the left or on the right. Unknown where exactly
	ePointVs2dCurveLocationDgLeft,
	ePointVs2dCurveLocationDgRight,
	ePointVs2dCurveLocationDgInside,	// Somewhere on the line. Unknown where exactly
	ePointVs2dCurveLocationDgFirstEnd,
	ePointVs2dCurveLocationDgLastEnd,
	ePointVs2dCurveLocationDgInternal,	// in open interval (first,last)
} PointVs2dCurveLocation_DG;

typedef enum PointVsLineLocation_DG
{
	ePointVsLineLocationOrigin,
	ePointVsLineLocationOnLineBefore,
	ePointVsLineLocationOnLineAfter,
	ePointVsLineLocationOnLine,
	ePointVsLineLocationOutside,
	ePointVsLineLocationOutsideInPlane,
	ePointVsLineLocationOutsideNegativeSemiSpace,
	ePointVsLineLocationOutsidePositiveSemiSpace
} PointVsLineLocation_DG;

typedef enum PointVsCurveLocation_DG {
	ePointVsCurveLocationDgUnknown,
	ePointVsCurveLocationDgOutside,
	ePointVsCurveLocationDgFirstEnd,
	ePointVsCurveLocationDgLastEnd,
	ePointVsCurveLocationDgInternal,
} PointVsCurveLocation_DG;

typedef enum PointVsSurfaceLocation_DG {
	ePointVsSurfaceLocationDgUnknown,
	ePointVsSurfaceLocationDgUnknownOutside,
	ePointVsSurfaceLocationDgNegativeSide,
	ePointVsSurfaceLocationDgPositiveSide,
	ePointVsSurfaceLocationDgOnSurface,
} PointVsSurfaceLocation_DG;

typedef enum PointVsSimplexLocation_DG {
	ePointVsSimplexLocationUnknown,
	ePointVsSimplexLocationInside,
	ePointVsSimplexLocationEdge,
	ePointVsSimplexLocationVertex,
	ePointVsSimplexLocationOutsideInPlane,
	ePointVsSimplexLocationNotInPlane,
} PointVsSimplexLocation_DG;

typedef enum PointVsSolidLocation_DG
{
	ePointVsSolidLocationUnknown,
	ePointVsSolidLocationInOpen,
	ePointVsSolidLocationAtVertex,
	ePointVsSolidLocationOnEdge,
	ePointVsSolidLocationOnFace,
	ePointVsSolidLocationOnSurface,
	ePointVsSolidLocationInside,
	ePointVsSolidLocationOutside
} PointVsSolidLocation_DG;

typedef enum LineVsLineLocation_DG
{
	eLineVsLineLocationUnknown,
	eLineVsLineLocationGeneral,        // No intersection, not ||
	eLineVsLineLocationIntersection,
	eLineVsLineLocationCollinear,      // Parallel
	eLineVsLineLocationCoinside,       // Origin may be shifted
	eLineVsLineLocationIdentical
} LineVsLineLocation_DG;

typedef enum CurveVsSurfaceLocation_DG {
	eCurveVsSurfaceLocationDgUnknown,
	eCurveVsSurfaceLocationDgUnknownOutside,
	eCurveVsSurfaceLocationDgNegativeSide,
	eCurveVsSurfaceLocationDgPositiveSide,
	eCurveVsSurfaceLocationDgIntersection,
	eCurveVsSurfaceLocationDgOnSurface,
} CurveVsSurfaceLocation_DG;

typedef enum SurfaceVsSurfaceLocation_DG {
	eSurfaceVsSurfaceLocationDgUnknown,
	eSurfaceVsSurfaceLocationDgUnknownOutside,
	eSurfaceVsSurfaceLocationDgNegativeSide,
	eSurfaceVsSurfaceLocationDgNegativeSideContact,
	eSurfaceVsSurfaceLocationDgIntersection,
	eSurfaceVsSurfaceLocationDgCoinside,
	eSurfaceVsSurfaceLocationDgPositiveSideContact,
	eSurfaceVsSurfaceLocationDgPositiveSide,
} SurfaceVsSurfaceLocation_DG;

typedef enum MeshElementType_DG {
	eMeshElemVertex,
	eMeshElemSegment,
	eMeshElemSimplex,
} MeshElementType_DG;

typedef enum MeshModsAction_DG
{
	eMeshModsActionNone = 0,
	eMeshModsActionNormalsFastApprox = 1,
	eMeshModsActionNormalsMedium = 2,
	eMeshModsActionNormalsFull = 4,
	eMeshModsActionNormalsAuto = 8,
} MeshModsAction_DG;

typedef enum MeshRefineType_DG {
	eMeshRefineTypeDgFlat,
	eMeshRefineTypeDgButterfly,
	eMeshRefineTypeDgLoop,
	eMeshRefineTypeDgCatmull,
	eMeshRefineTypeDgONE_QUAD_X_EDGE
} MeshRefineType_DG;

typedef enum SelectionItemType_DG {
	eSelectionTypeBRepVertex,
	eSelectionTypeBRepEdge,
	eSelectionTypeBRepFace,
	eSelectionTypeEntity,
	eSelectionTypeMeshVertex,
	eSelectionTypeMeshSegment,
	eSelectionTypeMeshSimplex,
	eSelectionTypeUnknown,
} SelectionItemType_DG;

typedef enum CADFormat_DG {
	eCadFormatDgGLM,
	eCadFormatDgVRML,
	eCadFormatDgSTL,
	eCadFormatDgAutoCADDXF,
	eCadFormatDgAutoCADDWG,
	eCadFormatDgSAT,
	eCadFormatDgCSV,
	eCadFormatDgXYZ,
	eCadFormatDgPLY,
	eCadFormatDgSTEP,
	eCadFormatDgIGES,
	eCadFormatDgBREP,
	eCadFormatDgCSFDB,
	eCadFormatDgDat,
	eCadFormatDgMDG,
	eCadFormatDgOBJ,
	eCadFormatDgUnknown,
} CADFormat_DG;

typedef enum STLAnalysisType_DG {
	eStlAnDgAuto,
	eStlAnDgPerform,
	eStlAnDgSkip,
} STLAnalysisType_DG;

typedef enum ViewMode_DG {
	eViewModeDgUnknown,			// Uninitialised state
	eViewModeDgView,
	eViewModeDgModify
} ViewMode_DG;

typedef enum ViewType_DG {
	eViewTypeDg2D = 2,
	eViewTypeDg3D = 3,
} ViewType_DG;

typedef enum RenderType_DG {
	eRenderTypeDgUnknown,
	eRenderTypeDgSolid,
	eRenderTypeDgWireFrame,
} RenderType_DG;

typedef enum ProjectionType_DG {
	eProjectionTypeDgOrthographic,
	eProjectionTypeDgPerspective,
} ProjectionType_DG;

typedef enum ViewBoolAttribute_DG {
	eViewBoolAttributeDgUnknown,
	eViewBoolAttributeDgShowNormals,
	eViewBoolAttributeDgEnableSurfaceHighLighting,
	eViewBoolAttributeDgEnablePan,
	eViewBoolAttributeDgEnableZoom,
	eViewBoolAttributeDgEnableRotate,
} ViewBoolAttribute_DG;

typedef enum ContextParamType_DG {
	eUnknown,
	eDouble,
	eSingle,
	eLong,
	eShort,
	eString,
	eBool,
	eIUnknown,
	eColor,
} ContextParamType_DG;

typedef enum ViewNavigationType_DG {
	eViewNavigationTypePan = 1,
	eViewNavigationTypeZoom = 2,
	eViewNavigationTypeRotate = 4,
} ViewNavigationType_DG;

typedef enum EColorParams_DG {		// Continuing E2DColorParams See DITypes.h
	eColorParamDGSelectedEntity = 6,
	eColorParamDGCurrentEntity = 7,
	eColorParamDGUnknown = 8			// count also. So keep it last
} EColorParams_DG;

typedef enum LightSourceType_DG
{
	eLightSourceTypeDirectional,
	eLightSourceTypePoint
} LightSourceType_DG;

typedef enum LightPositioningType_DG
{
	eLightPosTypeAutomatic,
	eLightPosTypeManual
} LightPositioningType_DG;

typedef enum LightComponent_DG 
{ 
	eLightAmbient, 
	eLightDiffuse, 
	eLightSpecular,
	eLightShininess,
	eLightWireFrame
} LightComponent_DG;

typedef enum MoveParametrisationType_DG
{
	eMoveParametrisationTypeSegmentStrip,
	eMoveParametrisationTypeArcSpline,
	eMoveParametrisationTypeUnknown,
} MoveParametrisationType_DG;

typedef enum StringSource_DG 
{
	eStringSourceDgUnknown,
	eStringSourceDgObjectName,
	eStringSourceDgLayerName,
	eStringSourceDgTemplate,
} StringSource_DG;

typedef enum ViewFrame_DG
{
	eViewFrameGlobal,
	eViewFrameEye
} ViewFrame_DG;

typedef enum ModelEntity_DG
{
	eModelEntityDgUnknown,
	eModelEntityDgObject,
	eModelEntityDgModel,
} ModelEntity_DG;

typedef struct Color_DG {
	float red;
	float green;
	float blue;
	float alpha;
} Color_DG;

typedef struct PairInt_DG {
	int first;
	int second;
} PairInt_DG;

typedef struct Range_DG { 
							double min;
							double max;
} Range_DG;

typedef struct Rectangle_DG {
	Range_DG range[2];
} Rectangle_DG;

typedef struct Box_DG {
	Range_DG range[3];
} Box_DG;

typedef struct DG2D {
	double x[2];
} DG2D;

typedef struct Ray2d_DG {
	DG2D origin;
	DG2D direction;
} Ray2d_DG;

typedef struct Vect_DG {
	double v[3];
} Vect_DG;

typedef struct Point_DG {
	double x[3];
} Point_DG;

typedef struct Line_DG {
	Point_DG origin;
	Vect_DG direction;
} Line_DG;

typedef struct Plane_DG {
	Point_DG origin;
	Vect_DG normal;
} Plane_DG;

typedef struct Bitmap_DG {
	int type;
	int width;
	int height;
	int widthBytes;
	short planes;
	short bitsPixel;
} Bitmap_DG;

// Additional parameters for IMetrics_DG.Dist method
typedef struct MetrDistContext_DG
{
	VARIANT_BOOL includeChildren;		// Include children of the objects in search for nearest points.
	VARIANT_BOOL needAll;				// Include points at distances bettween min and min+tolerance into the nearest set. Significantly affects performance
	double tolerance;					// Tolerance for the nearest set. Ignored if needAllInTolerRange is false
	double precision;					// Currently unused. Set equal to 1e-10 for forward compatibility
} MetrDistContext_DG;

// Additional parameters for IMetrics_DG.IsCloserThan method
typedef struct MetrIsCloserThanContext_DG
{
	VARIANT_BOOL includeChildren;		// Include children of both objects in search for nearest points.
	VARIANT_BOOL further;				// If true returns true if the objects are further (there is at least one pair of further points), not closer than the specified distance
	VARIANT_BOOL quickCheck;			// For increased performance check vertexes only. 

} MetrIsCloserThanContext_DG;

typedef struct PathDetectorContext_DG
{
	VARIANT_BOOL decreasingStart;		// It is known that on start of the movement minimal distance beween object decreases
	double minDistToler;				// objects are considered collided if minimal distance is less than minDist. Lower than 1e-6 is not recommended. Clumped to (1e-10, 0.1) range
	double precision;					// Precision of calculated position along movement(s) path. Lower than 1e-7 is not recommended. Clumped to (1e-10, 0.1) range
} PathDetectorContext_DG;

typedef unsigned __int64 POSN;

