// DIHelp.cpp : Opens a topic file in DInsight documentation
#include "StdAfx.h"
#include <process.h>
#include "DIHelp.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Note: This a supporting file and is not considered as a part of the current sample

DIHelp::DIHelp()
{
}

DIHelp::DIHelp(LPCSTR szTopicFile)
{
	ShowTopic(szTopicFile);
}

DIHelp::~DIHelp()
{
}

bool DIHelp::GetInstallPath(LPCSTR szInstallDir, DWORD dwSize)
{
	HKEY hKeyVer = NULL;

	REGSAM sam = KEY_READ;

	char szKeyNameBuff[126];
	sprintf_s(szKeyNameBuff, 126, "SOFTWARE\\DInsight\\Common\\DGKernel\\%d.%d", VERSION_MAJOR, VERSION_MINOR);

	LONG lRes = RegOpenKeyEx(
		HKEY_LOCAL_MACHINE,
		szKeyNameBuff,
		0,   // reserved
		sam,
		&hKeyVer
		);

	if (lRes != ERROR_SUCCESS)
		return FALSE;

	lRes = RegQueryValueEx(
		hKeyVer,
		"LastInstallPath",
		NULL,
		NULL,
		(LPBYTE)szInstallDir,
		&dwSize);

	if (lRes != ERROR_SUCCESS)
	{
		RegCloseKey(hKeyVer);
		return FALSE;
	}

	RegCloseKey(hKeyVer);

	return TRUE;
}

bool DIHelp::ShowTopic(LPCSTR szTopicFile)
{
	char url[300];	memset(url, 0, 300);
	sprintf_s(url, 300, "www.dynoinsight.com/Help/V%d_%d/DGKC/%s", VERSION_MAJOR, VERSION_MINOR, szTopicFile);
	::ShellExecute(NULL, NULL, url, NULL, NULL, SW_SHOWNORMAL);
	return TRUE;
}
